
/*
Gaigen 1.0, Copyright (c) 2001-2010, University of Amsterdam

Copying, use and development for education and research purposes 
permitted as long as this license is not removed from the files.

All rights for commercial use reserved; for more information
contact Daniel Fontijne (fontijne@science.uva.nl)

This software is unsupported.
*/
/*
Source file e3ga.cpp, generated by Gaigen 1.0 on Mon Mar 22 19:10:50 2010
*/




#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <math.h>
#include "e3ga.h"
#ifdef WIN32
#pragma warning( disable : 4996)
#endif

int e3gai_expansionTable_gp[] = {
-1,
0, 9, 18, 27, 36, 45, 54, 63, -1,
1, 8, 22, 93, 39, 107, 50, 60, -1,
2, 78, 16, 28, 35, 47, 113, 61, -1,
3, 13, 84, 24, 98, 41, 55, 62, -1,
68, 79, 19, 90, 32, 46, 117, 57, -1,
69, 75, 87, 25, 102, 40, 52, 58, -1,
70, 10, 81, 95, 37, 108, 48, 59, -1,
71, 76, 85, 94, 33, 42, 51, 56, -1
};

const char *e3gai_typeNames[4] = {
	"undefined",
	"blade",
	"versor",
	"multivector"
};
// layer 0 functions are always pure C, unless custom float class if used
extern "C" {

char *e3gai_basisElementNames[8] = {
(char*)"1",
(char*)"e1",
(char*)"e2",
(char*)"e3",
(char*)"e2^e3",
(char*)"e3^e1",
(char*)"e1^e2",
(char*)"e1^e2^e3"
};

bool e3gai_basisElementNamesAllocated[8] = {
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false
};

int e3gai_gradeSize[4] = {1, 3, 3, 1};
int e3gai_mvSize[16] = {0, 1, 3, 4, 3, 4, 6, 7, 1, 2, 4, 5, 4, 5, 7, 8};

const int e3gai_bevt0[1] = {-1};
const int e3gai_bevt1[3] = {0, 1, 2};
const int e3gai_bevt2[3] = {1, 2, 0};
const int e3gai_bevt3[1] = {0};
const int *e3gai_bevt[4] = { // bevt = basis element vector table
	e3gai_bevt0,
	e3gai_bevt1,
	e3gai_bevt2,
	e3gai_bevt3
};
const int e3gai_newBevt[8] = { // bevt = basis element vector table
	0, 1, 2, 4, 6, 5, 3, 7
};

const int e3gai_omct[24] = { // omct = Outer Morphism Construction Table
	-1, -1, 0,
	1, -1, 1,
	2, -1, 1,
	3, -1, 1,
	2, 3, 1,
	1, 3, -1,
	1, 2, 1,
	4, 1, 1
};
// end of the layer 0 functions
} /* end of 'extern "C"' */



e3gai e3gai::e1(GRADE1, 1.0, 0.0, 0.0);
e3gai e3gai::e2(GRADE1, 0.0, 1.0, 0.0);
e3gai e3gai::e3(GRADE1, 0.0, 0.0, 1.0);
e3gai *e3gai::bv[3] = {&e3gai::e1, &e3gai::e2, &e3gai::e3};
e3gai e3gai::I(GRADE3, 1.0);
e3gai e3gai::Ii(GRADE3, -1.0);

const int e3gai::dim = 3;
const int e3gai::nbCoor = 8;

e3gai::e3gai() {
	usage = 0;
	c = NULL;
}

e3gai::e3gai(const e3gai &a) {
	usage = 0;
	copy(a);
}

e3gai::e3gai(int gradeUsage, const double *coordinates) {
	usage = 0;
	set(gradeUsage, coordinates);
}

e3gai::~e3gai() {
	setUsage(0);
}

e3gai::e3gai(int grade, double c0) {
	usage = 0;
	set(grade, c0);
}

e3gai::e3gai(int grade, double c0, double c1, double c2) {
	usage = 0;
	set(grade, c0, c1, c2);
}

void e3gai::null() {
	setUsage(0);
}

void e3gai::set(int gradeUsage, const double *coordinates) {
	setUsage((e3gai_mvSize[gradeUsage] << 4) | gradeUsage);
	e3gai_copy(c, coordinates, e3gai_mvSize[gradeUsage]);
}

void e3gai::setScalar(const double coordinates[1]) {
	setUsage(17);
	e3gai_copy(c, coordinates, 1);
}

void e3gai::setVector(const double coordinates[3]) {
	setUsage(50);
	e3gai_copy(c, coordinates, 3);
}

void e3gai::set2Vector(const double coordinates[3]) {
	setUsage(52);
	e3gai_copy(c, coordinates, 3);
}

void e3gai::set3Vector(const double coordinates[1]) {
	setUsage(24);
	e3gai_copy(c, coordinates, 1);
}

int e3gai::set(int grade, double c0) {
	setUsage(grade | (e3gai_mvSize[grade] << 4));
	c[0] = c0;
	return 0;
}

int e3gai::set(int grade, double c0, double c1, double c2) {
	setUsage(grade | (e3gai_mvSize[grade] << 4));
	c[0] = c0;
	c[1] = c1;
	c[2] = c2;
	return 0;
}

const char *e3gai::fpPrecision = "%2.2f";
const char *e3gai::stringStartDelimiter = "";
const char *e3gai::stringEndDelimiter = "";

int e3gai::setFPPrecision(const char *prec) {
	if (prec == NULL) return -1;
	fpPrecision = prec;
	return 0;
}

int e3gai::setStringDelimiters(char start, char end) {
	if ((start < 0) || (end < 0)) return -1;
	static char startStr[2], endStr[2];

	startStr[0] = start; startStr[1] = 0;
	stringStartDelimiter = startStr;

	endStr[0] = end; endStr[1] = 0;
	stringEndDelimiter = endStr;
	return 0;
}

const char *e3gai::string(const char *prec /*= NULL*/) const {
	// todo: this whole function is not very (mt-)safe
	static char tmpResult[1024]; 
	tmpResult[0] = 0;

	const int maxResult = 16; 
	static char *result[maxResult];
	static int currentResult = 0;

	char *rBuf = tmpResult;
	int i, j, k = 0, ia = 0, gu = gradeUsage(), s = e3gai_mvSize[gu], p = 0, cnt = 0;
	char buf[32];	

	if (prec == NULL) prec = fpPrecision;
	sprintf(buf, "%cs%s%cs%cs", '%', prec, '%', '%');
	rBuf += sprintf(rBuf, "%s", stringStartDelimiter);
	for (i = 0; i <= 3; i++)
		if (gu & (1 << i)) {
			for (j = 0; j < e3gai_gradeSize[i]; j++) {
				if (fabs(c[k]) > 1e-14) {
					cnt++;
					rBuf += sprintf(rBuf, buf, (p) ? " + " : "", float(c[k]), (i) ? "*" : "", (i) ? e3gai_basisElementNames[ia] : "");
					p = 1;
				}
				k++; ia++;
			}
		}
		else ia += e3gai_gradeSize[i];

	if (cnt == 0) rBuf += sprintf(rBuf, "0");
	rBuf += sprintf(rBuf, "%s", stringEndDelimiter);

	k = (int)(strlen(tmpResult) + 1);
	rBuf = result[currentResult] = (char*)realloc(result[currentResult], k);
	currentResult = (currentResult + 1) % maxResult;

	if (rBuf == NULL) {
		printf("Memory allocation failure for %d bytes\n", k);
		return tmpResult; // at least return something...
	}
	else {
		memcpy(rBuf, tmpResult, k);
		return rBuf;
	}
}

void e3gai::print(const char *text /*= NULL*/, const char *prec /*= NULL*/) const {
	fprint(stdout, text, prec);
}

void e3gai::fprint(FILE *F, const char *text /*= NULL*/, const char *prec /*= NULL*/) const {
	if (text) fprintf(F, text);
	fprintf(F, "%s\n", string(prec));
}

int e3gai::renameBasisVector(const char *oldName, const char *newName) {
    unsigned int totalNb = 0;
    for (unsigned int j = 0; j < 8;j++) {
        // count number of occurances of oldName:
        char *ptr = e3gai_basisElementNames[j];
        int nb = 0;
        do {
            ptr = strstr(ptr, oldName);
            
            if (ptr != NULL) {
                nb ++;
                ptr += strlen(oldName);
            }
        } while (ptr);
        totalNb += nb;
        
        // if oldName occured:
        if (nb) {
            // allocate mem for new name
            char *buf = (char*)malloc(
                strlen(e3gai_basisElementNames[j]) + 1 + 
                nb * (strlen(newName) - strlen(oldName)));
            if (buf == NULL) return -1;

            // form new name
            ptr = e3gai_basisElementNames[j];
            char *buf2 = buf, *ptr2 = ptr;
            do {
                ptr = strstr(ptr, oldName);
                if (ptr != NULL) {
                    memcpy(buf2, ptr2, ptr - ptr2);
                    buf2 += ptr - ptr2;
                    
                    strcpy(buf2, newName);
                    buf2 += strlen(newName);
                    
                    ptr += strlen(oldName);        
                    ptr2 = ptr;
                }
                else {
                    strcpy(buf2, ptr2);
                }
            } while (ptr);
            
            // set result:
            if (e3gai_basisElementNamesAllocated[j])
                free(e3gai_basisElementNames[j]);
            e3gai_basisElementNames[j] = buf;
            e3gai_basisElementNamesAllocated[j] = true;
        }
    }
    return (totalNb == 0) ? -1 : 0;
}



int e3gai::nbBlocksAvailable[8 + 1];
int e3gai::maxBlocksAvailable[8 + 1];
double **e3gai::blocks[8 + 1];

void e3gai::doubleMaxBlocks(int n) {
	maxBlocksAvailable[n] = (maxBlocksAvailable[n]) ? maxBlocksAvailable[n] * 2 : 2;
	blocks[n] = (double**)realloc(blocks[n], sizeof(double*) * maxBlocksAvailable[n]);  // todo: check mem alloc
}

void e3gai::addBlocks(int n) {
	const int nb = 128; // nb = just a constant
	int i;
	double *newBlocks = (double*)calloc(sizeof(double) * n, nb);	// todo: check mem alloc
	while (maxBlocksAvailable[n] < nbBlocksAvailable[n] + nb) doubleMaxBlocks(n);
	for (i = 0; i < nb; i++)
		blocks[n][nbBlocksAvailable[n]++] = newBlocks + i * n;
}

void e3gai::setUsage(int u) {
	int n1, n2;

	n1 = memUsage();
	n2 = u >> (3 + 1);
	usage = u;
	if (n1 == n2) return;
	if (n1) {	// free old mem
		if (maxBlocksAvailable[n1] == nbBlocksAvailable[n1]) doubleMaxBlocks(n1);
		blocks[n1][nbBlocksAvailable[n1]] = c;
		nbBlocksAvailable[n1]++;
	}
	if (n2) {	// alloc new mem
		if (!nbBlocksAvailable[n2]) addBlocks(n2);
		nbBlocksAvailable[n2]--;
		c = blocks[n2][nbBlocksAvailable[n2]];
	}
}

void e3gai::copy(const e3gai &a) {
	setUsage(a.usage);
	e3gai_copy(c, a.c, e3gai_mvSize[a.gradeUsage()]);
}

void e3gai::compress(double epsilon /* = 1e-14 */ ) {
	double cc[8];
	int i, j, ia = 0, ib = 0, gu = gradeUsage(), gu2 = 0, f, s;
	for (i = 0; i < 6; i++) {
		if (!(gu & (1 << i))) continue;

		s = e3gai_gradeSize[i];
		j = ia + s;
		f = 0;
		for (; ia < j; ia++)
			if ((c[ia] > epsilon) || (c[ia] < -epsilon)) {f = 1; break;}
		ia = j;
		if (f) {
			e3gai_copy(cc + ib, c + ia - s, s);
			ib += s;
			gu2 |= (1 << i);
		}
	}
	if (gu2 != gu) set(gu2, cc);
}

void e3gai::reverse(const e3gai &a) {
	double *pc[4];
	copy(a);
	if (!(a.gradeUsage() & 12)) return;
	expand( (const double**) pc);
	e3gai_reverse(pc);
}

void e3gai::cliffordConjugate(const e3gai &a) {
	double *pc[4];
	copy(a);
	if (!(a.gradeUsage() & 6)) return;
	expand( (const double**) pc);
	e3gai_cliffordConjugate(pc);
}

void e3gai::gradeInvolution(const e3gai &a) {
	double *pc[4];
	copy(a);
	if (!(a.gradeUsage() & 10)) return;
	expand( (const double**) pc);
	e3gai_involution(pc);
}

void e3gai::negate(const e3gai &a) {
	setUsage(a.usage);
	e3gai_negate(c, a.c, e3gai_mvSize[a.gradeUsage()]);
}

void e3gai::add(const e3gai &a, const e3gai &b) {
	double const *pa[4], *pb[4];
	double *pc[4];
	int gu = a.gradeUsage() | b.gradeUsage();
	setUsage(gu | (e3gai_mvSize[gu] << 4));
	if (a.gradeUsage() == b.gradeUsage()) e3gai_addSameGradeUsage(c, a.c, b.c, memUsage());
	else {
		a.expand(b, pa, pb);
		expand( (const double**) pc);
		e3gai_add(pa, pb, pc);
	}
}

void e3gai::add(double scalar, const e3gai &b) {
	double const *pa[4], *pb[4];
	double *pc[4];
	int gu = GRADE0 | b.gradeUsage();
	setUsage(gu | (e3gai_mvSize[gu] << 4));
	if (GRADE0 == b.gradeUsage()) e3gai_addSameGradeUsage(c, &scalar, b.c, memUsage());
	else {
		memset(pa + 1, 0, sizeof(double*) * 3);
		pa[0] = &scalar;
		b.expand(pb);
		expand( (const double**) pc);
		e3gai_add(pa, pb, pc);
	}
}

void e3gai::sub(const e3gai &a, const e3gai &b) {
	double const *pa[4], *pb[4];
	double *pc[4];
	int gu = a.gradeUsage() | b.gradeUsage();
	setUsage(gu | (e3gai_mvSize[gu] << 4));
	if (a.gradeUsage() == b.gradeUsage()) e3gai_subSameGradeUsage(c, a.c, b.c, memUsage());
	else {
		a.expand(b, pa, pb);
		expand( (const double**) pc);
		e3gai_sub(pa, pb, pc);
	}
}

void e3gai::sub(double scalar, const e3gai &b) {
	double const *pa[4], *pb[4];
	double *pc[4];
	int gu = GRADE0 | b.gradeUsage();
	setUsage(gu | (e3gai_mvSize[gu] << 4));
	if (GRADE0 == b.gradeUsage()) e3gai_subSameGradeUsage(c, &scalar, b.c, memUsage());
	else {
		memset(pa + 1, 0, sizeof(double*) * 3);
		pa[0] = &scalar;
		b.expand(pb);
		expand( (const double**) pc);
		e3gai_sub(pa, pb, pc);
	}
}

// take grade introduced 20020710
void e3gai::takeGrade(const e3gai &a, int gu) {
	int i, gua, s;
	double *bc; 
	const double *ac; 

	// determine what the grage usage 'gu' of the result should be:
	if (gu = ((gua = a.gradeUsage()) & gu)) { // only execute if any grade will be present in the result
		// set the grade usage of the result + allocate memory
		setUsage(gu | (e3gai_mvSize[gu] << 4)); 

		bc = c; ac = a.c; // pointers to the coordinates of source (ac) and result (bc)
		for (i = 1; i <= gu; i = i << 1) { // for each grade that is possibly in the result
			if (gua & i) { // determine if grade is present in source
				s = e3gai_mvSize[i]; // get the size of grade
				if (gu & i) { // determine if grade is present in result
					e3gai_copy(bc, ac, s); // copy coordinates
					bc += s; // increment pointer to result
				}
				ac += s; // increment pointer to source
			}
		}
	}
	else setUsage(0);
}

// added an epsilon value on 2002 07 28
int e3gai::highestGrade(const e3gai &a, double epsilon /* = 1e-14 */) {
	int g = 3, gu = a.gradeUsage(), ia = e3gai_mvSize[gu], size, i;
	const double *cptr;
	do {
		if (gu & (1 << g)) {
			size = e3gai_gradeSize[g];
			ia -= size;
			cptr = a.c + ia;
			for (i = 0; i < size; i++) 
				if (fabs(cptr[i]) > epsilon) {
					set(1 << g, a.c + ia);
					return g;
				}
		}
	} while ((--g)>= 0); // bug fix on 2003 11 16, used to be while ((--g) _>_ 0)
//return -1; // modification on 20020828

	setUsage(0);
	return 0;
}

int e3gai::grade() const {
	int g = 3, gu = gradeUsage(), idx = e3gai_mvSize[gu], size, i;
	const double *cptr;
	do {
		if (gu & (1 << g)) {
			size = e3gai_gradeSize[g];
			idx -= size;
			cptr = c + idx;
			for (i = 0; i < size; i++) if (cptr[i] != (double)0.0) return (gu ^ (1 << g)) ? -1 : g;
		}
	} while ((--g)>0);
	return 0;
}

int e3gai::maxGrade() const { 
	int g = 3, gu = gradeUsage(), idx = e3gai_mvSize[gu], size, i;
	const double *cptr;
	do {
		if (gu & (1 << g)) {
			size = e3gai_gradeSize[g];
			idx -= size;
			cptr = c + idx;
			for (i = 0; i < size; i++) if (cptr[i] != (double)0.0) return g;
		}
	} while ((--g)>0);
	return -1;
}

int e3gai::largestGrade() const {
	int g = 0, gu = gradeUsage(), size;
	double largest = -1.0, tmp;
	int lg = 0;
	const double *cptr = c;
	do {
		if (gu & (1 << g)) {
			size = e3gai_gradeSize[g];
			if ( (tmp = e3gai_norm_a(cptr, size)) > largest) {
				largest = tmp;
				lg = g;
			}
			gu ^= (1 << g);
			
			cptr += size;
		}
	} while (gu && ((++g)<=3));
	return lg;
}




int e3gai::versorInverse(const e3gai &a) {
	e3gai reverse, scalar;
	reverse.reverse(a);
	scalar.scp(a, reverse);
	if ((scalar.c == NULL) || (scalar.c[0] == 0.0f)) {null(); return -1;}
	scalar.c[0] = 1.0f / scalar.c[0];
	op(scalar, reverse);
	return 0;
}

int e3gai::lounestoInverse(const e3gai &a) {
	e3gai cc, acc, scalar, pseudoscalar;
	double s, d, coor[2];

	// compute (a * clifford conjugate)
	cc.cliffordConjugate(a);
	acc.gp(a, cc);

	// get scalar and pseudoscalar of acc; compute the square of the pseudoscalar
	s = (acc.usage & 1) ? acc.c[0] : (double)0.0;
	pseudoscalar.takeGrade(acc, GRADE3);
	scalar.gp(pseudoscalar, pseudoscalar);

	// compute the denominator
	if ((d = s * s - ((scalar.usage & 1) ? scalar.c[0] : (double)0.0)) == (double)0.0) return -1;

	// compute the result
	coor[0] = s / d;
	coor[1] = ((pseudoscalar.usage & 8) ? (double) -pseudoscalar.c[0] : (double)0.0) / d;
	acc.set(GRADE0 | GRADE3, coor);
	gp(cc, acc);

	return 0;
}

void e3gai::expand(double matrix[], const int table[]) const {
	double val;
	int i, j = 0, t, g = -1, gi = 0, gu = gradeUsage(), ci = 0;
	for (i = -1; i < 8; i++) {
		if (i == -1) val = 0.0f;
		else {
			if (gi == 0) gi = e3gai_gradeSize[++g];
			if (gu & (1 << g)) val = c[ci++];
			else val = 0.0f;
			gi--;
		}
		while ((t = table[j++]) >= 0) {
			if (t & 128) matrix[t & 63] += (t & 64) ? (double)-val : (double)val;
			else matrix[t & 63] = (t & 64) ? (double)-val : (double)val;
		}
	}
}

int e3gai::generalInverse(const e3gai &a) {
	static double matrix[64];
	double *m[8] = {
		matrix + 0,
		matrix + 8,
		matrix + 16,
		matrix + 24,
		matrix + 32,
		matrix + 40,
		matrix + 48,
		matrix + 56

	};
	double maxp, *tmp, mult;
	int pi, i, j, k;
	double inverse[8];
	inverse[0] = 1.0f;

	// modification for custom float (december 9 2002)
	e3gai_null(inverse + 1, 8-1);

	int it = 0;

	a.expand(matrix, e3gai_expansionTable_gp);

	for (i = 0; i < 8; i++) {	// sweep all columns
		pi = i;
		maxp = (double)fabs(m[i][i]);

		for (j = i + 1; j < 8; j++) // find the max pivot
			if ((double)fabs(m[j][i]) > maxp)
				maxp = (double)fabs(m[pi = j][i]);
		if (inverse[pi] != 0.0f) it = 1;
		if (pi != i) { // swap rows
			if (inverse[i] != 0.0f) it = 1;
			tmp = m[pi]; m[pi] = m[i]; m[i] = tmp;
			if (it) maxp = inverse[pi]; inverse[pi] = inverse[i]; inverse[i] = maxp;
		}

		maxp = m[i][i];
		if (maxp == 0.0f) {	// singular matrix
			setUsage(0);
			return -1;
		}

		for (k = 0; k < 8; k++) { // sweep all other rows
			if (k == i) continue;
			mult = -m[k][i] / maxp;
			for (j = i + 1; j < 8; j++) m[k][j] += m[i][j] * mult;
			if (it) inverse[k] += inverse[i] * mult;
		}

		for (j = i+1; j < 8; j++) m[i][j] /= maxp; // divide the pivot row
		if (it) inverse[i] /= maxp;
	}
	set((1 << 4) - 1, inverse);
	return 0;
}

double e3gai::norm_a() const {
	return e3gai_norm_a(c, e3gai_mvSize[gradeUsage()]);
}

double e3gai::norm_b() const {
	e3gai r, s;
	r.reverse(*this);
	s.scp(*this, r);
	return s.scalar();
}

double e3gai::largestCoordinate() const {
	int nc = e3gai_mvSize[gradeUsage()], i;
	double maxC = 0.0, C;
	
	for (i = 0; i < nc; i++) {
		C = fabs(c[i]);
		if (C > maxC) maxC = C;
	}
	
	return maxC;
}

void e3gai::normalize(const e3gai &a, int norm) {
	double tmpC;
	switch(norm) {
	case 1:
		tmpC = 1.0f / (double)sqrt(a.norm_a());
		break;
	case 2:
		tmpC = 1.0f / (double)sqrt(fabs(a.norm_b()));
		break;
	}
	e3gai scalar(GRADE0, tmpC);
	op(a, scalar);
}

int e3gai::project(const e3gai &blade, const e3gai &a) {
	e3gai tmp, bladeInverse;
	bladeInverse.versorInverse(blade);
	tmp.lcont(a, blade);
	lcont(tmp, bladeInverse);
	return 0;
}

int e3gai::projectOntoVersor(const e3gai &versor, const e3gai &a) {
	e3gai tmp, versorInverse;
	versorInverse.versorInverse(versor);
	tmp.lcont(a, versor);
	gp(tmp, versorInverse);
	return 0;
}

int e3gai::reject(const e3gai &blade, const e3gai &a) {
	e3gai tmp, bladeInverse;
	// todo: check if this code is correct
	bladeInverse.versorInverse(blade);
	tmp.op(blade, a);
	lcont(bladeInverse, tmp);
	return 0;
}

// todo: ensure everything is euclidean...
int e3gai::factor(e3gai factors[], int versor /* = 0 */) const {
	e3gai ca[2], tmp, fi, tmpbv;
	int ga = (versor) ? maxGrade() : grade(), n = 0, i, idx, cca = 0, gu = gradeUsage(), bev;
	double maxC, tmpC, mul, *c2;
	const double *tmpc;
	static double bvc[3] = {1.0, 0.0, 0.0};

	if (ga <= 0) return 0;

	// compute the multiplication factor require to make every factor of the same order of magnitude
	mul = (double)pow((double)sqrt((double)norm_a()), 1.0 / (double)ga);

	// setup current 'a'
	ca[0].copy(*this);

	// get the coordinate array for grade 'ga'
	tmpc = coordinates(1 << ga);

	// find out the maximum coordinate
	maxC = (double)fabs(tmpc[idx = 0]);
	for (i = 1; i < e3gai_gradeSize[ga]; i++) 
		if ( (tmpC = (double)fabs(ca[cca].c[i])) > maxC) {maxC = tmpC;idx = i;}

	// find out which basis vectors we have to project onto the blade
	idx += e3gai_mvSize[0xff >> (8 - ga)];
	bev = e3gai_newBevt[idx];

	// setup a basis vector
	tmpbv.setVector(bvc);
	c2 = tmpbv.c;
	idx = 0;

	i = 1;
	for (; ga > 1; ga--) {
		// find the next coordinate
		do { // note: the first coordinate is always skipped; this is note a bug 
			c2[idx++] = 0.0; // direct manipulation of 'bv'; hack
			c2[idx] = 1.0; // direct manipulation of 'bv'; hack
			i <<= 1;
		} while (!(bev & i));

		tmp.project(ca[cca], tmpbv);
		factors[n].op(mul, tmp); // make all factors approximatelly the same size

		// remove the factor from the blade
		fi.versorInverse(factors[n++]); 
		if (versor) ca[cca ^ 1].gp(fi, ca[cca]);
		else ca[cca ^ 1].lcont(fi, ca[cca]);
		cca ^= 1;
	}

	factors[n++].takeGrade(ca[cca], GRADE1);	// the last factor is equal to the remaining vector

	return n;
}


int e3gai::deltaProduct(const e3gai &a, const e3gai &b) {
	e3gai mv1;
	mv1.gp(a, b);
	return this->highestGrade(mv1);
}

int e3gai::join(const e3gai &a, const e3gai &b, int algorithm /*= 1*/) {
	e3gai d, factors[3];
	int gj, ga = a.grade(), gb = b.grade(), gd;
	e3gai ca, cb;

	// if we are not handed homogeneous multivectors, take the grade parts with the largest norm
	if (ga < 0) {
		ga = a.largestGrade();
		ca.takeGrade(a, 1 << ga);
	}
	else ca.copy(a);

	if (gb < 0) {
		gb = b.largestGrade();
		cb.takeGrade(b, 1 << gb);
	}
	else cb.copy(b);

	// determine the grade of the join
	if (ga == 0) { // then the join is equal to b
		op(ca, cb); return gb;
	}
	else if (gb == 0) { // then the join is equal to a
		op(cb, ca); return ga;
	}
	else { // the join must be computed
		gd = d.deltaProduct(ca, cb);
		gj = (ga + gb + gd) >> 1;
		return (algorithm == 1) 
			? joinAlg1(ca, cb, ga, gb, gj)
			: joinAlg2(ca, cb, ga, gb, gj);
	}
}

int e3gai::meet(const e3gai &a, const e3gai &b, int algorithm /*= 1*/) {
	e3gai d, factors[3], j, jinv;
	int ga = a.grade(), gb = b.grade(), gd;

	e3gai ca, cb;

	// if we are not handed homogeneous multivectors, take the grade parts with the largest norm
	if (ga < 0) {
		ga = a.largestGrade();
		ca.takeGrade(a, 1 << ga);
	}
	else ca.copy(a);

	if (gb < 0) {
		gb = b.largestGrade();
		cb.takeGrade(b, 1 << gb);
	}
	else cb.copy(b);

	// compute delta product, join, ->meet
	gd = d.deltaProduct(ca, cb);
	j.join(ca, cb, algorithm);
	if (jinv.versorInverse(j)) {
		null();
		return 0;
	}
	lcont(d, jinv);
	return (ga + gb - gd) >> 1;
}

// todo: ensure everything is euclidean...
int e3gai::joinAlg2(const e3gai &a, const e3gai &b, int ga, int gb, int gj) {
	e3gai mv1, factors[3];
	int cg, lg, nf; // gj = grade join, gd = grade delta product

	// check for pseudoscalar case:
	if (gj == 3) {
		copy(I);
		return gj;
	}
	
	/*
	we pick the highest-dimension blade to start with,
	and factor the other blade
	*/
	e3gai res[4];
	int factorsTried[4];
	double largestNorm = -1.0f, nm;
	if (ga > gb) {
		if ( (nf = b.factor(factors)) != gb) return -1;	// should never happen
		lg = cg = ga;
		res[cg].copy(a);
	}
	else {
		if ( (nf = a.factor(factors)) != ga) return -1;	// should never happen
		lg = cg = gb;
		res[cg].copy(b);
	}

	// modification for bug of type 'join(e1, e1) = 0' (instead of e1) // 2003 10 28
	if (cg == gj) {	// if we have arrived at the grade of the join:
		copy(res[cg]);
		return gj;
	}

	/*
	Wegde as much factors as we need to get the right grade 
	*/
	factorsTried[cg] = 0;
	while (1) {
		// should we lower the current grade, and try the next factor?
		while (factorsTried[cg] >= nf) cg--;
		if (cg < lg) break;

		// wegde a factor to the result
		res[cg + 1].op(res[cg], factors[factorsTried[cg]]);
		factorsTried[cg + 1] = ++(factorsTried[cg]);
		cg++;

		if (cg == gj) {	// if we have arrived at the grade of the join:
			if ( (nm = res[cg].norm_a()) > largestNorm) {
				largestNorm = nm;
				copy(res[cg]);
			}
			cg--;
		}
	}

	return gj;
}

int e3gai::joinAlg1(const e3gai &a, const e3gai &b, int ga, int gb, int gj) {
	e3gai mv1, b1, b2, factors[3];
	int i, rg, gs; // gj = grade join, gd = grade delta product, rg = required grade, gs = grade size

	// check for pseudoscalar case:
	if (gj == 3) {
		copy(I);
		return gj;
	}

	/* we pick the highest-dimension blade (b1) to start with */
	e3gai be, pbe, tmp; // be = basis element, pbe = projected basis element
	double v1[3];
	double largestNorm = -1.0f, nm;
	if (ga > gb) {
		b1.copy(a);
		rg = gj - ga;
		b2.copy(b);
	}
	else {
		b1.copy(b);
		rg = gj - gb;
		b2.copy(a);
	}

	// project all possible basis elements of grade 'rg' onto blade b2; wegde them with b1
	gs = e3gai_gradeSize[rg];

	// modification for bug of type 'join(e1, e1) = 0' (instead of e1) // 2003 10 28
	if (gs == 0) { // nothing to do, since 'b1' already has the require grade
		copy(b1);
		return gj;
	}
	
	// modification for custom float (december 9 2002)
	e3gai_null(v1, gs);

	be.set(1 << rg, v1);
	for (i = 0; i < gs; i++) {
		be.c[i] = 1.0f;	// hack
		if (i) be.c[i-1] = 0.0f; // hack
		pbe.project(b2, be);
		tmp.op(b1, pbe);
		if ( (nm = tmp.norm_a()) > largestNorm) {
			largestNorm = nm;
			copy(tmp);
		}
	}

	return gj;
}


int e3gai::random(int grade, double scale, int versor) {

	scale *= (double)2.0;

	// compute how many vector we have to multiply/wegd
	int nb = -1;
	while (grade) {
		grade >>= 1;
		nb++;
	}
	if (nb < 0) return -1;
	else if (nb == 0) {
		setScalar(scale * ((double)rand() / (double)2147483647 - (double)0.5));
	}
	else {
		int i, j, ct = 0;
		e3gai rv, tmp[2];
		double v[3], scalar = (double)1.0;

		tmp[0].setScalar(&scalar);
		for (i = 0; i < nb; i++) {
			// create a random vector
			for (j = 0; j < 3; j++)
				v[j] = scale * ((double)rand() / (double)2147483647 - (double)0.5);
			rv.setVector(v);

			// multiply/wegde it to the result
			if (versor) tmp[ct ^ 1].gp(tmp[ct], rv);
			else tmp[ct ^ 1].op(tmp[ct], rv);

			ct ^= 1;
		}

		copy(tmp[ct]);
	}

	return 0;
}

int e3gai::reciprocalFrame(e3gai f[], const e3gai e[], int nbVectors) {
	int cb = 0, i, err, ca, j;
	double scalar = 1.0f;
	e3gai B[2], Bi, tmp, einv, A[2];

	if ((nbVectors <= 0) || (nbVectors > 3)) return 0;

	// build the blade which is the pseudoscalar for the frame 
	B[cb].copy(e[0]);
	for (i = 1; i < nbVectors; i++) {
		B[cb^1].op(B[cb], e[i]);
		cb ^= 1;
	}

	// computer the inverse of the frame
	if (err = Bi.versorInverse(B[cb])) return err;

	// compute the reciprocal vectors
	for (i = 0; i < nbVectors; i++) {
		ca = 0;

		// compute te right scalar factor
		scalar = (i & 1) ? -1.0f : 1.0f;
		A[ca].setScalar(&scalar);

		// compute the blade, with omission of vector e[i]
		for (j = 0; j < nbVectors; j++) {
			if (j == i) continue;
			A[ca^1].op(A[ca], e[j]);
			ca ^= 1;
		}

		// compute reciprocal vector f[i]
		f[i].lcont(A[ca], Bi);
	}

	return 0;
}

int e3gai::mvType(int *grade /*= NULL*/, double epsilon /* = 1e-14 */) const {
// this code fails on 'e1 + (e2 ^ e3)' (says it versor, while it isn't)
	// a = *this
	// compute versor inverse of input
	if (grade) *grade = 0;

	e3gai reverse, scalar, ai;
	reverse.reverse(*this);
	scalar.scp(*this, reverse); 
	if ((scalar.c == NULL) || (scalar.c[0] == 0.0f)) return GA_MULTIVECTOR;
	scalar.c[0] = 1.0f / scalar.c[0];
	ai.op(scalar, reverse);

	// check if ai * a = 1
	e3gai mv1, mv2, mv3;
	mv1.gp(ai, *this); 
	mv1.compress(epsilon);
	if (mv1.gradeUsage() > GRADE0) return GA_MULTIVECTOR;
	if ((mv1.gradeUsage() == 0) || (mv1.c[0] < 1.0f - epsilon) || (mv1.c[0] > 1.0f + epsilon)) 
		return GA_MULTIVECTOR;

	// check if a * ai = 1
	mv1.gp(*this, ai); 
	mv1.compress(epsilon);
	if (mv1.gradeUsage() > GRADE0) return GA_MULTIVECTOR;
	if ((mv1.gradeUsage() == 0) || (mv1.c[0] < 1.0f - epsilon) || (mv1.c[0] > 1.0f + epsilon)) 
		return GA_MULTIVECTOR;

	// test if ai * x * a is of the same grade as 'x' for all basis vectors
	int i, j, g;
	for (i = 0; i < 3; i++) { 
		mv1.gp(ai, *e3gai::bv[i]);  // todo: EUCLIDEAN?
		mv2.gp(mv1, *this);  
		mv2.compress(epsilon);
		if (mv2.gradeUsage() & (0xffff ^ GRADE1)) return GA_MULTIVECTOR;
	}

	// normalize 'a' (this is to make sure we don't misqualify 'small' (<epsilon) versors as blades
	scalar.setScalar(sqrt(fabs(scalar.c[0])));
	ai.op(scalar, *this);

	// test if a is of a single grade
	ai.compress(epsilon);
	i = ai.gradeUsage(); j = 0;
	g = GRADE0;
	while (i) {
		if (grade && (i & 1)) *grade = g;
		j += i & 1;
		i >>= 1;
		g <<= 1;
	}
	return (j <= 1) ? GA_BLADE : GA_VERSOR;
}

static int memberOf(char c, const char *set) { 
	int i = 0;
	while (set[i]) {
		if (c == set[i]) return 1;
		i++;
	}
	return 0;
}

int e3gai::parseString(const char *str, const e3ga_ben *ben /*= NULL*/) {
	int idx = 0, pmCnt, beCnt = 0;
	const int strLength = 256;
	double scalar;
	int floatStart, floatEnd, bvStart, bvEnd, i;
	e3gai blade, bv, BE, tmp;
	int stage = 0;
	char floatStr[strLength], bvStr[strLength];

	e3ga_ben defaultBen;
	if (ben == NULL) ben = &defaultBen;

	null();

	if (ben->m_startDelimiter) {
		// the first character found must be equal to m_startDelimiter
		while (str[idx] <= ' ') { // skip space until something happens
			if (str[idx] == 0) return -1; // nothing read
			idx++;
		}
		if (str[idx] != ben->m_startDelimiter) return -1; // first character is not the m_startDelimiter
		idx++;
	}

	for (;;) {
		blade.setScalar((double)1.0);
		scalar = (double)1;

		while (str[idx] <= ' ') { // skip space until something happens
			if (str[idx] == 0) return (ben->m_endDelimiter) ? -1 : idx; // done or error
			idx ++;
		}

		i = idx;
		pmCnt = 0; // plus minus count
		for (;;) { // parse [+|-]+
			if (str[idx] == '+') {scalar *= (double)+1; pmCnt++;}
			else if (str[idx] == '-') {scalar *= (double)-1; pmCnt++;}
			else if (memberOf(str[idx], "0123456789.")) break; // start of the float
			else if ((str[idx] > 0) && (str[idx] <= ' ')); // skip space
			else break;
			idx++;
		}
		if (beCnt && (!pmCnt)) return -1;

		if (memberOf(str[idx], "0123456789.")) { // parse float and '*' or '^'
			// parse the float
			floatStart = idx;
			while (memberOf(str[idx],  "0123456789.eE") ||
				(idx && ((str[idx-1] == 'e') || (str[idx-1] == 'E')) && ((str[idx] == '-') || (str[idx] == '+'))))  idx++;
			floatEnd = idx;
			memcpy(floatStr, str + floatStart, floatEnd - floatStart);
			floatStr[floatEnd - floatStart] = 0;
			if (floatEnd - floatStart <= 0) return -1;
			scalar *= (double)atof(floatStr);

			while (str[idx] <= ' ') { // skip space until something happens
				if (str[idx] == 0) {
					tmp.copy(*this); add(scalar, tmp);
					return (ben->m_endDelimiter) ? -1 : idx; // done or error
				}
				idx++;
			}

			// check if next char is +,-,* or 'ben->m_endDelimiter'
			if ((str[idx] == '+') || (str[idx] == '-')) {
				tmp.copy(*this); add(scalar, tmp);
				beCnt++;
				continue;
			}
			else if (ben->m_endDelimiter && (str[idx] == ben->m_endDelimiter)) { // end delimiter
				tmp.copy(*this); add(scalar, tmp);
				return idx+1;
			}
			else if ((str[idx] != '*') && (str[idx] != '^')) return -1; // must be either +,-, ^ or *
			else idx++; // skip over '*' or '^'

			while (str[idx] <= ' ') { // skip space until something happens
				if (str[idx] == 0) return -1; // error
				idx++;
			}
		}

		for (;;) { // parse a basis element ex ^ ey ^ ez
			bvStart = idx; // find the start and end of the basis vector name
			while ((str[idx] > ' ') && (str[idx] != '-') && (str[idx] != '+') && (str[idx] != '^') && (str[idx] != ben->m_endDelimiter)) idx ++;
			bvEnd = idx;

			// copy name, parse it 
			if ((bvEnd - bvStart + 1) >= strLength) return -1; // error (string too long)
			memcpy(bvStr, str + bvStart, bvEnd - bvStart);
			bvStr[bvEnd - bvStart] = 0;
			if (ben->lookupName(bvStr, BE) < 0) return -1; // basis vector name is invalid

			tmp.copy(blade); blade.op(tmp, BE); // wedge the basis element to the blade

			while (str[idx] <= ' ') { // skip space until something happens
				if ((str[idx] == 0) || (str[idx] == ben->m_endDelimiter))  break;
				idx++;
			}
			
			// next char must be a wedge, or this is the end of the blade
			if (str[idx] != '^') break;
			idx++;
		}

		tmp.op(scalar, blade);
		blade.copy(*this);
		add(blade, tmp);
		beCnt++;

		if (str[idx] == ben->m_endDelimiter) return idx + 1;

	}
	return idx; // the function never arrives here?
}

void e3gai::om(const e3gai &a, const e3gai_om &om) {
	int ia = 0;
	setUsage(a.usage);

	if (gradeUsage() & 1) {
		e3gai_opt_om_01x01(om.c + 0, a.c + ia, c + ia);
		ia += 1;
	}

	if (gradeUsage() & 2) {
		e3gai_opt_om_03x03(om.c + 1, a.c + ia, c + ia);
		ia += 3;
	}

	if (gradeUsage() & 4) {
		e3gai_opt_om_03x03(om.c + 10, a.c + ia, c + ia);
		ia += 3;
	}

	if (gradeUsage() & 8) {
		e3gai_opt_om_01x01(om.c + 19, a.c + ia, c + ia);
		ia += 1;
	}

}

void e3gai::expand(const double *pa[4]) const {
	int ia = 0;
	int i, j = 1;
	for (i = 0; i < 4; i++) {
		if (gradeUsage() & j) {
			pa[i] = c + ia;
			ia += e3gai_gradeSize[i];
		}
		else pa[i] = NULL;
		j <<= 1;
	}
}

void e3gai::expand2i(const e3gai &b, double const *pa[4], double const *pb[4]) const {
	int ia = 0;
	int i, j = 1;
	for (i = 0; i < 4; i++) {
		if (gradeUsage() & j) {
			pa[i] = c + ia;
			pb[i] = b.c + ia;
			ia += e3gai_gradeSize[i];
		}
		else pa[i] = pb[i] = NULL;
		j <<= 1;
	}
}

void e3gai::expand(const e3gai &b, double const *pa[4], double const *pb[4]) const {
	int ia = 0, ib = 0;
	int i, j = 1;
	for (i = 0; i < 4; i++) {
		if (gradeUsage() & j) {
			pa[i] = c + ia;
			ia += e3gai_gradeSize[i];
		}
		else pa[i] = NULL;
		if (b.gradeUsage() & j) {
			pb[i] = b.c + ib;
			ib += e3gai_gradeSize[i];
		}
		else pb[i] = NULL;
		j <<= 1;
	}
}

void e3gai::compress(double coordinates[8]) {
	int i, j, k, l, s, u;
	double cc[8];
	l = k = u = 0;
	for (i = 0; i < 4; i++) {
		s = e3gai_gradeSize[i];
		for (j = 0; j < s; j++)
			if (coordinates[k + j] != 0.0f) {
				u |= (1 << i);
				e3gai_copy(cc + l, coordinates + k, s);
				l += s;
				break;
			}
		k += s;
	}
	setUsage(u | (l << 4));
	e3gai_copy(c, cc, l);
}

const double *e3gai::coordinates(int grade) const {
	int ia = 0;
	int i, j = 1, gu = gradeUsage();
	static const double null[8] = {0}; // temp test for Brian Bouta problem
	for (i = 0; i < 4; i++) {
		if (j == grade) return (gu & j) ? c + ia : null;
		if (gu & j) ia += e3gai_gradeSize[i];
		j <<= 1;
	}
	return null;
}

int e3gai::fastDual(const e3gai &a) {
	setUsage(a.usage);
	int gua = a.gradeUsage(), gud = 0;
	int ia = e3gai_mvSize[gua], id = 0;
	const double *ca = a.c;
	double *cd = c;
	if (gua & GRADE3) {
		gud |= GRADE0;
		ia -= e3gai_gradeSize[3];
		cd[id + 0] = ca[ia + 0];
		id += e3gai_gradeSize[0];
	}
	if (gua & GRADE2) {
		gud |= GRADE1;
		ia -= e3gai_gradeSize[2];
		cd[id + 0] = ca[ia + 0];
		cd[id + 1] = ca[ia + 1];
		cd[id + 2] = ca[ia + 2];
		id += e3gai_gradeSize[1];
	}
	if (gua & GRADE1) {
		gud |= GRADE2;
		ia -= e3gai_gradeSize[1];
		cd[id + 0] = -ca[ia + 0];
		cd[id + 1] = -ca[ia + 1];
		cd[id + 2] = -ca[ia + 2];
		id += e3gai_gradeSize[2];
	}
	if (gua & GRADE0) {
		gud |= GRADE3;
		ia -= e3gai_gradeSize[0];
		cd[id + 0] = -ca[ia + 0];
		id += e3gai_gradeSize[3];
	}

	usage = gud | (usage ^ gua);
	return 0;
}

void e3gai::gp(const e3gai &a, const e3gai &b) {

	double const *pa[4], *pb[4];
	double cc[8];
	a.expand(b, pa, pb);
	e3gai_general_gp(pa, pb, cc);
	compress(cc);
}

void e3gai::lcont(const e3gai &a, const e3gai &b) {

	double const *pa[4], *pb[4];
	double cc[8];
	a.expand(b, pa, pb);
	e3gai_general_lcont(pa, pb, cc);
	compress(cc);
}

void e3gai::op(const e3gai &a, const e3gai &b) {

	double const *pa[4], *pb[4];
	double cc[8];
	a.expand(b, pa, pb);
	e3gai_general_op(pa, pb, cc);
	compress(cc);
}

void e3gai::op(double a, const e3gai &b) {

	double const *pa[4], *pb[4];
	double cc[8];
	b.expand(pb);
	memset(pa + 1, 0, sizeof(double*) * 3);
	pa[0] = &a;
	e3gai_general_op(pa, pb, cc);
	compress(cc);
}

void e3gai::scp(const e3gai &a, const e3gai &b) {

	double const *pa[4], *pb[4];
	double cc[8];
	a.expand(b, pa, pb);
	e3gai_general_scp(pa, pb, cc);
	compress(cc);
}

void e3gai::hip(const e3gai &a, const e3gai &b) {

	double const *pa[4], *pb[4];
	double cc[8];
	a.expand(b, pa, pb);
	e3gai_general_hip(pa, pb, cc);
	compress(cc);
}

void e3gai::mhip(const e3gai &a, const e3gai &b) {

	double const *pa[4], *pb[4];
	double cc[8];
	a.expand(b, pa, pb);
	e3gai_general_mhip(pa, pb, cc);
	compress(cc);
}

void e3gai::rcont(const e3gai &a, const e3gai &b) {

	double const *pa[4], *pb[4];
	double cc[8];
	a.expand(b, pa, pb);
	e3gai_general_rcont(pa, pb, cc);
	compress(cc);
}
void e3gai_opt_zero_result(const double *a, const double *b, double *c) {};

int e3gai::resetProfile() {
	return 0;
}
int e3gai::printProfile(float threshold /* = 2.0 */) {
	return 0;
}
int e3gai::saveProfile(const char *filename /*  = NULL */) {
	return 0;
}

e3gai_om::e3gai_om() {
	// modification for custom float (december 9 2002)
	e3gai_null(c, 20);
}

e3gai_om::~e3gai_om() {
}

e3gai_om::e3gai_om(const e3gai vectorImages[3]) {
	initOuterMorphism(vectorImages);
}
e3gai_om::e3gai_om(const e3gai *vectorImages[3]) {
	initOuterMorphism(vectorImages);
}

int e3gai_om::initOuterMorphism(const e3gai vectorImages[3]) {
	const e3gai *vi[3];
	int i;
	for (i = 0; i < 3; i++)
		vi[i] = vectorImages + i;
	return initOuterMorphism(vi);
}

int e3gai_om::initOuterMorphism(const e3gai *vectorImages[3]) {
	int beComputed[8], i, j, k, ic, gs, bei;	// be = Basis Element
	e3gai be[8];
	double scalar = 1.0f;
	const double *bec;

	// set all vectors
	for (i = 1; i <= 3; i++) {
		be[i].takeGrade(*(vectorImages[i-1]), GRADE1);
		beComputed[i] = 1;
	}

	// compute all the other basis elements
	memset(beComputed + 3 + 1, 0, sizeof(int) * (8 - 3 - 1));
	for (i = 3 + 1; i < 8; i++)
		computeBE(be, beComputed, i);

	// insert all coordinates into the matrix
	ic = 1;
	bei = 1;
	for (i = 1; i <= 3; i++) {
		gs = e3gai_gradeSize[i];
		for (j = 0; j < gs; j++) {
			bec = be[bei].coordinates(1 << i);
			for (k = 0; k < gs; k++) {
				c[ic + k * gs] = bec[k];
			}
			ic++;
			bei++;
		}
		ic += gs * (gs-1);
	}
	return 0;
}

int e3gai_om::computeBE(e3gai be[8], int beComputed[8], int idx) {
	int i, j, err;
	e3gai tmp;

	if (!beComputed[i = e3gai_omct[idx * 3 + 0]])
		if (err = computeBE(be, beComputed, i)) return err;
	if (!beComputed[j = e3gai_omct[idx * 3 + 1]])
		if (err = computeBE(be, beComputed, j)) return err;

	if (e3gai_omct[idx * 3 + 2] < 0) {
		tmp.negate(be[i]);
		be[idx].op(tmp, be[j]);
	}
	else {
		be[idx].op(be[i], be[j]);
	}

	beComputed[idx] = 1;

	return 0;
}

int e3gai_om::initSpinor2(const e3gai &Sp) {
	int i;
	e3gai Spi, vectorImages[3], tmp, tmp2;
	Spi.versorInverse(Sp);

	for (i = 0; i < 3; i++) {
		tmp.gp(Sp, *(e3gai::bv[i]));
		tmp2.gp(tmp, Spi);
		vectorImages[i].takeGrade(tmp2, GRADE1);
	}
	
	return initOuterMorphism(vectorImages);
}

e3gai_be::e3gai_be(const char *name, const e3gai &mv) {
	initToNothing();

	if (name) m_name = strdup(name);
	m_mv.copy(mv);
}

e3gai_be::~e3gai_be() {
	if (m_name) free(m_name);
	initToNothing();
}

void e3gai_be::initToNothing() {
	m_name = NULL;
	m_mv.null();
}

int e3gai_be::compareName(const char *name)  const {
	if ((name == NULL) || (m_name == NULL)) return 0;
	return (!strcmp(name, m_name));
}

e3ga_ben::e3ga_ben() {
	initToNothing();
	setDefaults();
}

e3ga_ben::e3ga_ben(char startDelimiter, char endDelimiter) {
	initToNothing();
	setDefaults();
	setDelimiters(startDelimiter, endDelimiter);
}

e3ga_ben::~e3ga_ben() {
	removeAll();
	initToNothing();
}

void e3ga_ben::initToNothing() {
	m_ben = NULL;
	m_nbBen = 0;
	m_startDelimiter = m_endDelimiter = 0;
}

int e3ga_ben::removeAll() {
	int i;
	if (m_ben) {
		for (i = 0; i < m_nbBen; i++)
			if (m_ben[i]) delete m_ben[i];
		free(m_ben);
	}
	m_ben = NULL;
	m_nbBen = 0;
	return 0;
}

int e3ga_ben::addName(const char *name, const e3gai &mv) {
	e3gai tmpMv;
	if (lookupName(name, tmpMv) == 0) return -1; // already present in list
	
	if ( (m_ben = (e3gai_be**)realloc(m_ben, sizeof(e3gai_be*) * (m_nbBen + 1))) == NULL) {
		printf("e3ga_ben::addName(): memory allocation failure for '%d' bytes\n", sizeof(e3gai_be*) * (m_nbBen + 1));
		return -1;
	}

	if ( (m_ben[m_nbBen] = new e3gai_be(name, mv)) == NULL) {
		printf("e3ga_ben::addName(): memory allocation failure for '%d' bytes\n", sizeof(e3gai_be));
		return -1;
	}

	m_nbBen++;

	return 0;
}

int e3ga_ben::removeName(const char *name) {
	int i;

	for (i = 0; i < m_nbBen; i++)
		if (m_ben[i]->compareName(name)) {
			delete m_ben[i];
			m_ben[i] = m_ben[m_nbBen - 1];
			m_nbBen--;
			i--;
		}

	return 0;
}

int e3ga_ben::lookupName(const char *name, e3gai &mv) const {
	int i;

	for (i = 0; i < m_nbBen; i++)
		if (m_ben[i]->compareName(name)) {
			mv.copy(m_ben[i]->m_mv);
			return 0;
		}

	return -1;
}

int e3ga_ben::setDelimiters(char startDelimiter, char endDelimiter) {
	if ((startDelimiter < 0) || (endDelimiter < 0)) return -1;
	m_startDelimiter = startDelimiter;
	m_endDelimiter = endDelimiter;
	return 0;
}

int e3ga_ben::setDefaults() {
	int err;
	removeAll();
	m_startDelimiter = m_endDelimiter = 0;
	if (err = addName("e1", e3gai::e1)) return err;
	if (err = addName("e2", e3gai::e2)) return err;
	if (err = addName("e3", e3gai::e3)) return err;
	return 0;
}


//Merging /usr/local/include/gaigen/gaigenhl.cpp into generated code:

// DO NOT TRY TO COMPILE THIS FILE DIRECTLY.
// IT IS MEANT TO BE INCLUDED BY GENERATED CODE!

/*
 *
 * Gaigen, Copyright (c) 2001-2004, University of Amsterdam
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above copyright
 *        notice, this list of conditions and the following disclaimer in
 *        the documentation and/or other materials provided with the
 *        distribution.
 *      * Neither the name of the University of Amsterdam nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
 * CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 */


#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#ifdef GAIM_NAMESPACE
namespace CLASSNAME_NS {
#endif // GAIM_NAMESPACE

CLASSNAME::CLASSNAME() {

}
/*
CLASSNAME::CLASSNAME(GAIM_CLASSNAME &a) {
	copy(a);
}
*/
CLASSNAME::~CLASSNAME() {

}

GAIM_RETURN_TYPE CLASSNAME::operator=(const CLASSNAME &a) {
	copy(a);
	return *this;
}

GAIM_RETURN_TYPE CLASSNAME::operator=(GAIM_FLOAT f) {
	set(GRADE0, &f);
	return *this;
}

#ifdef GAIM_FUNCTION_FASTTEMPVAR
GAIM_RETURN_TYPE CLASSNAME::getTemp() {
	// gets a temporary variable (based on Stroustup (heaven help you if you write an expression which requires more than MV_MAX_TEMP temporaries))
	static int idx = 0;
	static CLASSNAME *temp = NULL;
	if (!temp) {
		int i;
		temp = new CLASSNAME[MV_MAX_TEMP];
		for (i = 0; i < MV_MAX_TEMP; i++) {
			temp[i].setUsage(0xf | (0x7 << 4));
			temp[i].setUsage(0);
		}
	}
//	printf("Temp idx = %d\n", idx);
	if (idx == MV_MAX_TEMP) idx = 0;
	return temp[idx++];
}
#endif // GAIM_FUNCTION_FASTTEMPVAR

#ifdef GAIM_FUNCTION_TAKEGRADE
GAIM_RETURN_TYPE CLASSNAME::grade(int g) const {
	GAIM_RETURN_VAR(result);
//	GAIM_RETURN_VAR(result);
	result.takeGrade(*this, g);
	return result;
}
#endif // GAIM_FUNCTION_TAKEGRADE


#ifdef GAIM_FUNCTION_REVERSE
GAIM_RETURN_TYPE CLASSNAME::operator~() const {
	GAIM_RETURN_VAR(result);
	((GAIM_CLASSNAME&)result).reverse(*this);
	return result;
}
#endif // GAIM_FUNCTION_REVERSE

#ifdef GAIM_FUNCTION_CLIFFORDCONJUGATE
GAIM_RETURN_TYPE CLASSNAME::operator--() const {
	GAIM_RETURN_VAR(result);
	((GAIM_CLASSNAME&)result).cliffordConjugate(*this);
	return result;
}
#endif // GAIM_FUNCTION_CLIFFORDCONJUGATE

#ifdef GAIM_FUNCTION_GRADEINVOLUTION
GAIM_RETURN_TYPE CLASSNAME::operator++() const {
	GAIM_RETURN_VAR(result);
	((GAIM_CLASSNAME&)result).gradeInvolution(*this);
	return result;
}
#endif // GAIM_FUNCTION_GRADEINVOLUTION

#ifdef GAIM_PRODUCT_GP
GAIM_RETURN_TYPE CLASSNAME::operator*=(const CLASSNAME &a) {
	CLASSNAME tmp;
	tmp.gp(*this, a);
	this->copy(tmp);
	return *this;
}
GAIM_RETURN_TYPE CLASSNAME::operator*=(GAIM_FLOAT a) {
	CLASSNAME tmp;
	tmp.op(a, *this);
	this->copy(tmp);
	return *this;
}
GAIM_RETURN_TYPE gp(const CLASSNAME &a, const CLASSNAME &b) {
	GAIM_RETURN_VAR(result);
	result.gp(a, b);
	return result;
}
GAIM_RETURN_TYPE gp(GAIM_FLOAT a, const CLASSNAME &b) {
	GAIM_RETURN_VAR(result);
	result.op(a, b);
	return result;
}

#define USE_NEW_EXP

#ifdef USE_OLD_EXP
GAIM_RETURN_TYPE CLASSNAME::exp(int order /*= 9*/) const {
	int i, div = 1;
	GAIM_RETURN_VAR(result);

	result.setScalar(1.0);
	if (order == 0) return result;

	CLASSNAME tmp(*this);

	for (i = 1; i < order; i++) {
		result += tmp * (GAIM_FLOAT)(1.0 / (GAIM_FLOAT)div);

		if (i < order-1) {
			div *= (i+1);
			tmp *= *this;
		}
	}

	return result;
}
#endif /* USE_OLD_EXP */

#ifdef USE_NEW_EXP
GAIM_RETURN_TYPE CLASSNAME::exp(int order /*= 9*/) const {
	/*
	Improved version of exp thanks to Robert Valkenburg & students
	*/
    int i;
    CLASSNAME result;

    result.setScalar(1.0);
    if (order == 0) {
        GAIM_RETURN_VAR(r);
        r = result;
        return r;
    }

    // scale by power of 2 so that its norm is < 1
    unsigned long max = (unsigned long)largestCoordinate();
    unsigned long scale=1;
    if (max > 1) scale <<= 1;
    while (max)
    {
        max >>= 1;
        scale <<= 1;
    }

    CLASSNAME scaled = (*this) / (GAIM_FLOAT)(scale);

    // taylor approximation
    CLASSNAME tmp;

    tmp.setScalar(1.0);
    for (i = 1; i < order; i++) {
        tmp = tmp*scaled/(GAIM_FLOAT)(i);
        result += tmp;
    }

    // undo scaling
    while (scale > 1)
    {
        result *= result;
        scale >>= 1;
    }
    GAIM_RETURN_VAR(r);
    r = result;
    return r;
}
#endif /* USE_NEW_EXP */


#ifndef GAIM_FUNCTION_FASTDUAL
GAIM_RETURN_TYPE CLASSNAME::dual() const {
	GAIM_RETURN_VAR(result);
	result.gp(*this, Ii);
	return result;
}
#endif // GAIM_FUNCTION_FASTDUAL

#endif // GAIM_PRODUCT_GP

#ifdef GAIM_PRODUCT_GP_EM
GAIM_RETURN_TYPE gpem (const CLASSNAME &a, const CLASSNAME &b) {
	GAIM_RETURN_VAR(result);
	result. GAIM_PRODUCT_GP_EM (a, b);
	return result;
}
GAIM_RETURN_TYPE gpem (GAIM_FLOAT a, const CLASSNAME &b) {
	GAIM_RETURN_VAR(result);
	result.op(a, b);
	return result;
}
#endif // GAIM_PRODUCT_GP_EM


#ifdef GAIM_FUNCTION_FASTDUAL
GAIM_RETURN_TYPE CLASSNAME::fastDual() const {
	GAIM_RETURN_VAR(result);
	((GAIM_CLASSNAME&)result).fastDual(*this);
	return result;
}
#endif // GAIM_FUNCTION_FASTDUAL


#ifdef GAIM_FUNCTION_VERSORINVERSE
GAIM_RETURN_TYPE CLASSNAME::versorInverse() const {
	GAIM_RETURN_VAR(result);
	result.versorInverse(*this);
	return result;
}
#endif
#ifdef GAIM_FUNCTION_LOUNESTOINVERSE
GAIM_RETURN_TYPE CLASSNAME::lounestoInverse() const {
	GAIM_RETURN_VAR(result);
	result.lounestoInverse(*this);
	return result;
}
#endif
#ifdef GAIM_FUNCTION_GENERALINVERSE
GAIM_RETURN_TYPE CLASSNAME::generalInverse() const {
	GAIM_RETURN_VAR(result);
	result.generalInverse(*this);
	return result;
}
#endif

#ifdef GAIM_PRODUCT_IGP
GAIM_RETURN_TYPE CLASSNAME::inverse() const {
	GAIM_RETURN_VAR(result);
	result.inverse(*this);
	return result;
}

GAIM_RETURN_TYPE CLASSNAME::operator/=(const CLASSNAME &a) {
	CLASSNAME tmp, tmp2;
	tmp2.inverse(a);
	tmp.gp(*this, tmp2);
	this->copy(tmp);
	return *this;
}
GAIM_RETURN_TYPE CLASSNAME::operator/=(GAIM_FLOAT a) {
	CLASSNAME tmp;
	tmp.op(1.0f / a, *this);
	this->copy(tmp);
	return *this;
}
#endif // GAIM_PRODUCT_IGP

#ifdef GAIM_PRODUCT_SCP
GAIM_RETURN_TYPE CLASSNAME::operator%=(const CLASSNAME &a) {
	CLASSNAME tmp;
	tmp.scp(*this, a);
	this->copy(tmp);
	return *this;
}
GAIM_RETURN_TYPE CLASSNAME::operator%=(GAIM_FLOAT a) {
	GAIM_FLOAT f = scalar() * a;
	setScalar(&f);
	return *this;
}
GAIM_RETURN_TYPE scp(const CLASSNAME &a, const CLASSNAME &b) {
	GAIM_RETURN_VAR(result);
	result.scp(a, b);
	return result;
}
GAIM_RETURN_TYPE scp(GAIM_FLOAT a, const CLASSNAME &b) {
	GAIM_RETURN_VAR(result);
	result.set(GRADE0, mulScalar(a, b.scalar()));
	return result;
}
#endif // GAIM_PRODUCT_SCP

#ifdef GAIM_PRODUCT_LCONT
GAIM_RETURN_TYPE lcont(const CLASSNAME &a, const CLASSNAME &b) {
	GAIM_RETURN_VAR(result);
	result.lcont(a, b);
	return result;
}
GAIM_RETURN_TYPE CLASSNAME::operator<<=(const CLASSNAME &a) {
	CLASSNAME tmp;
	tmp.lcont(*this, a);
	this->copy(tmp);
	return *this;
}
#endif // GAIM_PRODUCT_LCONT

#ifdef GAIM_PRODUCT_LCONT_EM
GAIM_RETURN_TYPE lcem(const CLASSNAME &a, const CLASSNAME &b) {
	GAIM_RETURN_VAR(result);
	result. GAIM_PRODUCT_LCONT_EM (a, b);
	return result;
}
#endif // GAIM_PRODUCT_LCONT_EM

#ifdef GAIM_PRODUCT_RCONT
GAIM_RETURN_TYPE rcont(const CLASSNAME &a, const CLASSNAME &b) {
	GAIM_RETURN_VAR(result);
	result.rcont(a, b);
	return result;
}
GAIM_RETURN_TYPE CLASSNAME::operator>>=(const CLASSNAME &a) {
	CLASSNAME tmp;
	tmp.rcont(*this, a);
	this->copy(tmp);
	return *this;
}
#endif // GAIM_PRODUCT_RCONT

#ifdef GAIM_PRODUCT_HIP
GAIM_RETURN_TYPE hip(const CLASSNAME &a, const CLASSNAME &b) {
	GAIM_RETURN_VAR(result);
	result.hip(a, b);
	return result;
}
GAIM_RETURN_TYPE hip(GAIM_FLOAT a, const CLASSNAME &b) {
	GAIM_RETURN_VAR(result);
	CLASSNAME _a(a);
	result.hip(_a, b);
	return result;
}
GAIM_RETURN_TYPE hip(const CLASSNAME &a, GAIM_FLOAT b) {
	GAIM_RETURN_VAR(result);
	CLASSNAME _b(b);
	result.hip(a, _b);
	return result;
}
#endif // GAIM_PRODUCT_HIP

#ifdef GAIM_PRODUCT_MHIP
GAIM_RETURN_TYPE mhip(const CLASSNAME &a, const CLASSNAME &b) { // GAIM_RETURN_TYPE used to read CLASSNAME & (modified 10-10-2002)
	GAIM_RETURN_VAR(result);
	result.mhip(a, b);
	return result;
}
GAIM_RETURN_TYPE mhip(GAIM_FLOAT a, const CLASSNAME &b) {
	GAIM_RETURN_VAR(result);
	CLASSNAME _a(a);
	result.mhip(_a, b);
	return result;
}
GAIM_RETURN_TYPE mhip(const CLASSNAME &a, GAIM_FLOAT b) {
	GAIM_RETURN_VAR(result);
	CLASSNAME _b(b);
	result.mhip(a, _b);
	return result;
}
#endif // GAIM_PRODUCT_MHIP


#ifdef GAIM_PRODUCT_OP
GAIM_RETURN_TYPE op(GAIM_FLOAT a, const CLASSNAME &b) {
	GAIM_RETURN_VAR(result);
	result.op(a, b);
	return result;
}
GAIM_RETURN_TYPE op(const CLASSNAME &a, const CLASSNAME &b) {
	GAIM_RETURN_VAR(result);
	result.op(a, b);
	return result;
}
GAIM_RETURN_TYPE CLASSNAME::operator^=(const CLASSNAME &a) {
	CLASSNAME tmp;
	tmp.op(*this, a);
	this->copy(tmp);
	return *this;
}
GAIM_RETURN_TYPE CLASSNAME::operator^=(GAIM_FLOAT a) {
	CLASSNAME tmp;
	tmp.op(a, *this);
	this->copy(tmp);
	return *this;
}
#endif // GAIM_PRODUCT_OP

#ifdef GAIM_FUNCTION_MEETJOIN
GAIM_RETURN_TYPE meet(const CLASSNAME &a, const CLASSNAME &b) {
	GAIM_RETURN_VAR(result);
	result.meet(a, b);
	return result;
}

GAIM_RETURN_TYPE join(const CLASSNAME &a, const CLASSNAME &b) {
	GAIM_RETURN_VAR(result);
	result.join(a, b);
	return result;
}

#endif // GAIM_FUNCTION_MEETJOIN


#ifdef GAIM_FUNCTION_ADD
GAIM_RETURN_TYPE add(const CLASSNAME &a, const CLASSNAME &b) {
	GAIM_RETURN_VAR(result);
	result.add(a, b);
	return result;
}
GAIM_RETURN_TYPE add(GAIM_FLOAT a, const CLASSNAME &b) {
	GAIM_RETURN_VAR(result);
	result.add(a, b);
	return result;
}
GAIM_RETURN_TYPE CLASSNAME::operator+=(const CLASSNAME &a) {
	CLASSNAME tmp;
	tmp.add(*this, a);
	this->copy(tmp);
	return *this;
}
GAIM_RETURN_TYPE CLASSNAME::operator+=(GAIM_FLOAT a) {
	CLASSNAME tmp;
	tmp.add(a, *this);
	this->copy(tmp);
	return *this;
}
#endif // GAIM_FUNCTION_ADD

#ifdef GAIM_FUNCTION_SUBSTRACT
GAIM_RETURN_TYPE sub(const CLASSNAME &a, const CLASSNAME &b) {
	GAIM_RETURN_VAR(result);
	result.sub(a, b);
	return result;
}
GAIM_RETURN_TYPE sub(GAIM_FLOAT a, const CLASSNAME &b) {
	GAIM_RETURN_VAR(result);
	result.sub(a, b);
	return result;
}
GAIM_RETURN_TYPE CLASSNAME::operator-=(const CLASSNAME &a) {
	CLASSNAME tmp;
	tmp.sub(*this, a);
	this->copy(tmp);
	return *this;
}
GAIM_RETURN_TYPE CLASSNAME::operator-=(GAIM_FLOAT a) {
	CLASSNAME tmp;
	tmp.add(a, *this);
	this->copy(tmp);
	return *this;
}
#endif // GAIM_FUNCTION_SUBSTRACT

#ifdef GAIM_FUNCTION_NEGATE
GAIM_RETURN_TYPE negate(const CLASSNAME &a) {
	GAIM_RETURN_VAR(result);
	((GAIM_CLASSNAME&)result).negate(a);
	return result;
}
#endif //GAIM_FUNCTION_NEGATE



#ifdef GAIM_FUNCTION_NORMALIZE
GAIM_RETURN_TYPE CLASSNAME::normal(int norm /* = 1 */) const {
	GAIM_RETURN_VAR(result);
	result.normalize(*this, norm);
	return result;
}
#endif // GAIM_FUNCTION_NORMALIZE


#ifdef GAIM_PRODUCT_OM
CLASSNAME_OM::CLASSNAME_OM(const CLASSNAME *vectorImages[3]) {
	initVectorImages(vectorImages);
}

CLASSNAME_OM::CLASSNAME_OM(const CLASSNAME &spinor) {
	initSpinor(spinor);
}


int CLASSNAME_OM::initSpinor(const CLASSNAME &spinor) {
	CLASSNAME si(spinor.inverse()), v, vi[GA_MAX_DIM];
	GAIM_FLOAT coordinates[GA_MAX_DIM];
	int i;

	memset(coordinates, 0, sizeof(GAIM_FLOAT) * GA_MAX_DIM);

	for (i = 0; i < CLASSNAME::dim; i++) {
		coordinates[i] = 1.0;
		if (i > 0) coordinates[i-1] = 0.0;
		v.setVector(coordinates);
		vi[i] = ((spinor * v) * si)(GRADE1);

	}
	return initVectorImages(vi);
}


GAIM_RETURN_TYPE om(const CLASSNAME_OM &om, const CLASSNAME &a) {
	GAIM_RETURN_VAR(result);

	result.om(a, om);

	return result;
}


#ifdef GAIM_NAMESPACE
}
#endif // GAIM_NAMESPACE


#endif // GAIM_PRODUCT_OM


