
/*
Gaigen 1.0, Copyright (c) 2001-2010, University of Amsterdam

Copying, use and development for education and research purposes 
permitted as long as this license is not removed from the files.

All rights for commercial use reserved; for more information
contact Daniel Fontijne (fontijne@science.uva.nl)

This software is unsupported.
*/
#include <stdlib.h>
#include <string.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

void i2gai_null(double *dest, int length) {
	memset(dest, 0, length * sizeof(double));
}

void i2gai_pp_00_00_00_m0(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[0] ;
}

void i2gai_pp_00_01_01_m0(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[0] + a[1] * b[1] - a[3] * b[2] - a[2] * b[3] - a[5] * b[4] - a[4] * b[5] ;
}

void i2gai_pp_00_02_02_m0(const double *a, const double *b, double *c) {
	c[0] += - a[0] * b[0] + a[3] * b[1] + a[4] * b[2] + a[1] * b[3] + a[2] * b[4] + a[5] * b[5] + a[10] * b[6] + a[11] * b[7] - a[13] * b[8] - a[12] * b[9] + a[6] * b[10] + a[7] * b[11] - a[9] * b[12] - a[8] * b[13] + a[14] * b[14] ;
}

void i2gai_pp_00_03_03_m0(const double *a, const double *b, double *c) {
	c[0] += + a[1] * b[0] + a[0] * b[1] + a[2] * b[2] + a[3] * b[3] + a[10] * b[4] - a[13] * b[5] - a[14] * b[6] - a[11] * b[7] - a[12] * b[8] - a[15] * b[9] + a[4] * b[10] - a[7] * b[11] - a[8] * b[12] - a[5] * b[13] - a[6] * b[14] - a[9] * b[15] + a[16] * b[16] + a[17] * b[17] - a[19] * b[18] - a[18] * b[19] ;
}

void i2gai_pp_00_04_04_m0(const double *a, const double *b, double *c) {
	c[0] += - a[0] * b[0] + a[6] * b[1] + a[5] * b[2] + a[7] * b[3] + a[8] * b[4] + a[2] * b[5] + a[1] * b[6] + a[3] * b[7] + a[4] * b[8] - a[9] * b[9] + a[12] * b[10] + a[13] * b[11] + a[10] * b[12] + a[11] * b[13] + a[14] * b[14] ;
}

void i2gai_pp_00_05_05_m0(const double *a, const double *b, double *c) {
	c[0] += + a[1] * b[0] + a[0] * b[1] + a[3] * b[2] + a[2] * b[3] + a[4] * b[4] + a[5] * b[5] ;
}

void i2gai_pp_00_06_06_m0(const double *a, const double *b, double *c) {
	c[0] += - a[0] * b[0] ;
}

void i2gai_pp_01_01_00_m0(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[0] ;
	c[1] += + a[1] * b[0] ;
	c[2] += + a[2] * b[0] ;
	c[3] += + a[3] * b[0] ;
	c[4] += + a[4] * b[0] ;
	c[5] += + a[5] * b[0] ;
}

void i2gai_pp_01_00_01_m0(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[0] ;
	c[1] += + a[0] * b[1] ;
	c[2] += + a[0] * b[2] ;
	c[3] += + a[0] * b[3] ;
	c[4] += + a[0] * b[4] ;
	c[5] += + a[0] * b[5] ;
}

void i2gai_pp_01_02_01_m0(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[1] - a[3] * b[2] - a[1] * b[3] - a[10] * b[4] - a[6] * b[5] ;
	c[1] += - a[0] * b[0] - a[4] * b[2] - a[2] * b[3] - a[11] * b[4] - a[7] * b[5] ;
	c[2] += - a[1] * b[0] - a[2] * b[1] - a[5] * b[2] - a[12] * b[4] - a[8] * b[5] ;
	c[3] += - a[3] * b[0] - a[4] * b[1] + a[5] * b[3] - a[13] * b[4] - a[9] * b[5] ;
	c[4] += - a[6] * b[0] - a[7] * b[1] + a[9] * b[2] + a[8] * b[3] - a[14] * b[4] ;
	c[5] += - a[10] * b[0] - a[11] * b[1] + a[13] * b[2] + a[12] * b[3] + a[14] * b[5] ;
}

void i2gai_pp_01_01_02_m0(const double *a, const double *b, double *c) {
	c[0] += - a[1] * b[0] + a[3] * b[1] + a[2] * b[3] + a[5] * b[6] + a[4] * b[10] ;
	c[1] += + a[0] * b[0] + a[3] * b[2] + a[2] * b[4] + a[5] * b[7] + a[4] * b[11] ;
	c[2] += + a[0] * b[1] + a[1] * b[2] + a[2] * b[5] + a[5] * b[8] + a[4] * b[12] ;
	c[3] += + a[0] * b[3] + a[1] * b[4] - a[3] * b[5] + a[5] * b[9] + a[4] * b[13] ;
	c[4] += + a[0] * b[6] + a[1] * b[7] - a[3] * b[8] - a[2] * b[9] + a[4] * b[14] ;
	c[5] += + a[0] * b[10] + a[1] * b[11] - a[3] * b[12] - a[2] * b[13] - a[5] * b[14] ;
}

void i2gai_pp_01_03_02_m0(const double *a, const double *b, double *c) {
	c[0] += + a[1] * b[2] + a[0] * b[4] + a[2] * b[5] + a[10] * b[7] - a[13] * b[8] - a[11] * b[9] + a[4] * b[11] - a[7] * b[12] - a[5] * b[13] + a[16] * b[14] ;
	c[1] += - a[1] * b[1] - a[0] * b[3] + a[3] * b[5] - a[10] * b[6] - a[14] * b[8] - a[12] * b[9] - a[4] * b[10] - a[8] * b[12] - a[6] * b[13] + a[17] * b[14] ;
	c[2] += - a[0] * b[0] - a[2] * b[1] - a[3] * b[2] - a[11] * b[6] - a[12] * b[7] - a[15] * b[8] - a[5] * b[10] - a[6] * b[11] - a[9] * b[12] + a[18] * b[14] ;
	c[3] += - a[1] * b[0] + a[2] * b[3] + a[3] * b[4] - a[13] * b[6] - a[14] * b[7] + a[15] * b[9] - a[7] * b[10] - a[8] * b[11] + a[9] * b[13] + a[19] * b[14] ;
	c[4] += - a[4] * b[0] + a[7] * b[1] + a[8] * b[2] + a[5] * b[3] + a[6] * b[4] + a[9] * b[5] - a[16] * b[6] - a[17] * b[7] + a[19] * b[8] + a[18] * b[9] ;
	c[5] += - a[10] * b[0] + a[13] * b[1] + a[14] * b[2] + a[11] * b[3] + a[12] * b[4] + a[15] * b[5] + a[16] * b[10] + a[17] * b[11] - a[19] * b[12] - a[18] * b[13] ;
}

void i2gai_pp_01_02_03_m0(const double *a, const double *b, double *c) {
	c[0] += + a[4] * b[0] + a[2] * b[1] + a[5] * b[2] + a[11] * b[4] - a[13] * b[5] - a[12] * b[7] + a[7] * b[10] - a[9] * b[11] - a[8] * b[13] + a[14] * b[16] ;
	c[1] += - a[3] * b[0] - a[1] * b[1] + a[5] * b[3] - a[10] * b[4] - a[13] * b[6] - a[12] * b[8] - a[6] * b[10] - a[9] * b[12] - a[8] * b[14] + a[14] * b[17] ;
	c[2] += - a[0] * b[0] - a[1] * b[2] - a[2] * b[3] - a[10] * b[5] - a[11] * b[6] - a[12] * b[9] - a[6] * b[11] - a[7] * b[12] - a[8] * b[15] + a[14] * b[18] ;
	c[3] += - a[0] * b[1] + a[3] * b[2] + a[4] * b[3] - a[10] * b[7] - a[11] * b[8] + a[13] * b[9] - a[6] * b[13] - a[7] * b[14] + a[9] * b[15] + a[14] * b[19] ;
	c[4] += - a[0] * b[4] + a[3] * b[5] + a[4] * b[6] + a[1] * b[7] + a[2] * b[8] + a[5] * b[9] - a[6] * b[16] - a[7] * b[17] + a[9] * b[18] + a[8] * b[19] ;
	c[5] += - a[0] * b[10] + a[3] * b[11] + a[4] * b[12] + a[1] * b[13] + a[2] * b[14] + a[5] * b[15] + a[10] * b[16] + a[11] * b[17] - a[13] * b[18] - a[12] * b[19] ;
}

void i2gai_pp_01_04_03_m0(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[3] - a[6] * b[6] - a[5] * b[8] - a[7] * b[9] - a[2] * b[12] - a[1] * b[14] - a[3] * b[15] + a[9] * b[17] - a[12] * b[18] - a[10] * b[19] ;
	c[1] += - a[0] * b[2] + a[6] * b[5] + a[5] * b[7] - a[8] * b[9] + a[2] * b[11] + a[1] * b[13] - a[4] * b[15] - a[9] * b[16] - a[13] * b[18] - a[11] * b[19] ;
	c[2] += + a[0] * b[0] + a[5] * b[4] + a[7] * b[5] + a[8] * b[6] + a[1] * b[10] + a[3] * b[11] + a[4] * b[12] - a[10] * b[16] - a[11] * b[17] - a[14] * b[18] ;
	c[3] += - a[0] * b[1] + a[6] * b[4] - a[7] * b[7] - a[8] * b[8] + a[2] * b[10] - a[3] * b[13] - a[4] * b[14] - a[12] * b[16] - a[13] * b[17] + a[14] * b[19] ;
	c[4] += - a[2] * b[0] - a[1] * b[1] - a[3] * b[2] - a[4] * b[3] + a[9] * b[4] - a[12] * b[5] - a[13] * b[6] - a[10] * b[7] - a[11] * b[8] - a[14] * b[9] ;
	c[5] += - a[6] * b[0] - a[5] * b[1] - a[7] * b[2] - a[8] * b[3] - a[9] * b[10] + a[12] * b[11] + a[13] * b[12] + a[10] * b[13] + a[11] * b[14] + a[14] * b[15] ;
}

void i2gai_pp_01_03_04_m0(const double *a, const double *b, double *c) {
	c[0] += - a[3] * b[0] + a[14] * b[1] + a[12] * b[2] + a[15] * b[3] + a[8] * b[5] + a[6] * b[6] + a[9] * b[7] - a[17] * b[9] + a[19] * b[10] + a[18] * b[12] ;
	c[1] += + a[2] * b[0] - a[13] * b[1] - a[11] * b[2] + a[15] * b[4] - a[7] * b[5] - a[5] * b[6] + a[9] * b[8] + a[16] * b[9] + a[19] * b[11] + a[18] * b[13] ;
	c[2] += - a[0] * b[0] - a[10] * b[1] - a[11] * b[3] - a[12] * b[4] - a[4] * b[5] - a[5] * b[7] - a[6] * b[8] + a[16] * b[10] + a[17] * b[11] + a[18] * b[14] ;
	c[3] += + a[1] * b[0] - a[10] * b[2] + a[13] * b[3] + a[14] * b[4] - a[4] * b[6] + a[7] * b[7] + a[8] * b[8] + a[16] * b[12] + a[17] * b[13] - a[19] * b[14] ;
	c[4] += + a[1] * b[1] + a[0] * b[2] + a[2] * b[3] + a[3] * b[4] - a[4] * b[9] + a[7] * b[10] + a[8] * b[11] + a[5] * b[12] + a[6] * b[13] + a[9] * b[14] ;
	c[5] += + a[1] * b[5] + a[0] * b[6] + a[2] * b[7] + a[3] * b[8] + a[10] * b[9] - a[13] * b[10] - a[14] * b[11] - a[11] * b[12] - a[12] * b[13] - a[15] * b[14] ;
}

void i2gai_pp_01_05_04_m0(const double *a, const double *b, double *c) {
	c[0] += + a[1] * b[4] + a[0] * b[8] + a[3] * b[11] + a[2] * b[13] + a[4] * b[14] ;
	c[1] += - a[1] * b[3] - a[0] * b[7] - a[3] * b[10] - a[2] * b[12] + a[5] * b[14] ;
	c[2] += + a[1] * b[1] + a[0] * b[5] - a[2] * b[9] - a[4] * b[10] - a[5] * b[11] ;
	c[3] += - a[1] * b[2] - a[0] * b[6] - a[3] * b[9] + a[4] * b[12] + a[5] * b[13] ;
	c[4] += - a[0] * b[0] - a[3] * b[1] - a[2] * b[2] - a[4] * b[3] - a[5] * b[4] ;
	c[5] += - a[1] * b[0] + a[3] * b[5] + a[2] * b[6] + a[4] * b[7] + a[5] * b[8] ;
}

void i2gai_pp_01_04_05_m0(const double *a, const double *b, double *c) {
	c[0] += + a[8] * b[0] + a[4] * b[1] + a[13] * b[2] + a[11] * b[3] + a[14] * b[4] ;
	c[1] += - a[7] * b[0] - a[3] * b[1] - a[12] * b[2] - a[10] * b[3] + a[14] * b[5] ;
	c[2] += + a[5] * b[0] + a[1] * b[1] - a[9] * b[2] - a[10] * b[4] - a[11] * b[5] ;
	c[3] += - a[6] * b[0] - a[2] * b[1] - a[9] * b[3] + a[12] * b[4] + a[13] * b[5] ;
	c[4] += - a[0] * b[0] - a[2] * b[2] - a[1] * b[3] - a[3] * b[4] - a[4] * b[5] ;
	c[5] += - a[0] * b[1] + a[6] * b[2] + a[5] * b[3] + a[7] * b[4] + a[8] * b[5] ;
}

void i2gai_pp_01_06_05_m0(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[5] ;
	c[1] += - a[0] * b[4] ;
	c[2] += + a[0] * b[2] ;
	c[3] += - a[0] * b[3] ;
	c[4] += + a[0] * b[0] ;
	c[5] += - a[0] * b[1] ;
}

void i2gai_pp_01_05_06_m0(const double *a, const double *b, double *c) {
	c[0] += - a[5] * b[0] ;
	c[1] += + a[4] * b[0] ;
	c[2] += - a[2] * b[0] ;
	c[3] += + a[3] * b[0] ;
	c[4] += - a[0] * b[0] ;
	c[5] += + a[1] * b[0] ;
}

void i2gai_pp_02_02_00_m0(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[0] ;
	c[1] += + a[1] * b[0] ;
	c[2] += + a[2] * b[0] ;
	c[3] += + a[3] * b[0] ;
	c[4] += + a[4] * b[0] ;
	c[5] += + a[5] * b[0] ;
	c[6] += + a[6] * b[0] ;
	c[7] += + a[7] * b[0] ;
	c[8] += + a[8] * b[0] ;
	c[9] += + a[9] * b[0] ;
	c[10] += + a[10] * b[0] ;
	c[11] += + a[11] * b[0] ;
	c[12] += + a[12] * b[0] ;
	c[13] += + a[13] * b[0] ;
	c[14] += + a[14] * b[0] ;
}

void i2gai_pp_02_01_01_m0(const double *a, const double *b, double *c) {
	c[0] += - a[1] * b[0] + a[0] * b[1] ;
	c[1] += - a[2] * b[0] + a[0] * b[2] ;
	c[2] += - a[2] * b[1] + a[1] * b[2] ;
	c[3] += - a[3] * b[0] + a[0] * b[3] ;
	c[4] += - a[3] * b[1] + a[1] * b[3] ;
	c[5] += - a[3] * b[2] + a[2] * b[3] ;
	c[6] += - a[4] * b[0] + a[0] * b[4] ;
	c[7] += - a[4] * b[1] + a[1] * b[4] ;
	c[8] += - a[4] * b[2] + a[2] * b[4] ;
	c[9] += - a[4] * b[3] + a[3] * b[4] ;
	c[10] += - a[5] * b[0] + a[0] * b[5] ;
	c[11] += - a[5] * b[1] + a[1] * b[5] ;
	c[12] += - a[5] * b[2] + a[2] * b[5] ;
	c[13] += - a[5] * b[3] + a[3] * b[5] ;
	c[14] += - a[5] * b[4] + a[4] * b[5] ;
}

void i2gai_pp_02_00_02_m0(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[0] ;
	c[1] += + a[0] * b[1] ;
	c[2] += + a[0] * b[2] ;
	c[3] += + a[0] * b[3] ;
	c[4] += + a[0] * b[4] ;
	c[5] += + a[0] * b[5] ;
	c[6] += + a[0] * b[6] ;
	c[7] += + a[0] * b[7] ;
	c[8] += + a[0] * b[8] ;
	c[9] += + a[0] * b[9] ;
	c[10] += + a[0] * b[10] ;
	c[11] += + a[0] * b[11] ;
	c[12] += + a[0] * b[12] ;
	c[13] += + a[0] * b[13] ;
	c[14] += + a[0] * b[14] ;
}

void i2gai_pp_02_03_01_m0(const double *a, const double *b, double *c) {
	c[0] += - a[1] * b[2] - a[0] * b[3] - a[10] * b[4] - a[4] * b[5] ;
	c[1] += - a[0] * b[1] - a[2] * b[2] - a[11] * b[4] - a[5] * b[5] ;
	c[2] += + a[0] * b[0] - a[3] * b[2] - a[12] * b[4] - a[6] * b[5] ;
	c[3] += - a[1] * b[1] + a[2] * b[3] - a[13] * b[4] - a[7] * b[5] ;
	c[4] += + a[1] * b[0] + a[3] * b[3] - a[14] * b[4] - a[8] * b[5] ;
	c[5] += + a[2] * b[0] + a[3] * b[1] - a[15] * b[4] - a[9] * b[5] ;
	c[6] += - a[4] * b[1] + a[7] * b[2] + a[5] * b[3] - a[16] * b[4] ;
	c[7] += + a[4] * b[0] + a[8] * b[2] + a[6] * b[3] - a[17] * b[4] ;
	c[8] += + a[5] * b[0] + a[6] * b[1] + a[9] * b[2] - a[18] * b[4] ;
	c[9] += + a[7] * b[0] + a[8] * b[1] - a[9] * b[3] - a[19] * b[4] ;
	c[10] += - a[10] * b[1] + a[13] * b[2] + a[11] * b[3] + a[16] * b[5] ;
	c[11] += + a[10] * b[0] + a[14] * b[2] + a[12] * b[3] + a[17] * b[5] ;
	c[12] += + a[11] * b[0] + a[12] * b[1] + a[15] * b[2] + a[18] * b[5] ;
	c[13] += + a[13] * b[0] + a[14] * b[1] - a[15] * b[3] + a[19] * b[5] ;
	c[14] += + a[16] * b[0] + a[17] * b[1] - a[19] * b[2] - a[18] * b[3] ;
}

void i2gai_pp_02_02_02_m0(const double *a, const double *b, double *c) {
	c[0] += - a[4] * b[1] + a[3] * b[2] - a[2] * b[3] + a[1] * b[4] - a[11] * b[6] + a[10] * b[7] - a[7] * b[10] + a[6] * b[11] ;
	c[1] += - a[2] * b[0] - a[5] * b[1] + a[0] * b[2] + a[1] * b[5] - a[12] * b[6] + a[10] * b[8] - a[8] * b[10] + a[6] * b[12] ;
	c[2] += + a[1] * b[0] - a[0] * b[1] - a[5] * b[2] + a[2] * b[5] - a[12] * b[7] + a[11] * b[8] - a[8] * b[11] + a[7] * b[12] ;
	c[3] += - a[4] * b[0] + a[5] * b[3] + a[0] * b[4] - a[3] * b[5] - a[13] * b[6] + a[10] * b[9] - a[9] * b[10] + a[6] * b[13] ;
	c[4] += + a[3] * b[0] - a[0] * b[3] + a[5] * b[4] - a[4] * b[5] - a[13] * b[7] + a[11] * b[9] - a[9] * b[11] + a[7] * b[13] ;
	c[5] += + a[3] * b[1] + a[4] * b[2] - a[1] * b[3] - a[2] * b[4] - a[13] * b[8] + a[12] * b[9] - a[9] * b[12] + a[8] * b[13] ;
	c[6] += - a[7] * b[0] + a[9] * b[1] + a[8] * b[3] - a[14] * b[6] + a[0] * b[7] - a[3] * b[8] - a[1] * b[9] + a[6] * b[14] ;
	c[7] += + a[6] * b[0] + a[9] * b[2] + a[8] * b[4] - a[0] * b[6] - a[14] * b[7] - a[4] * b[8] - a[2] * b[9] + a[7] * b[14] ;
	c[8] += + a[6] * b[1] + a[7] * b[2] + a[8] * b[5] - a[1] * b[6] - a[2] * b[7] - a[5] * b[8] - a[14] * b[8] + a[8] * b[14] ;
	c[9] += + a[6] * b[3] + a[7] * b[4] - a[9] * b[5] - a[3] * b[6] - a[4] * b[7] + a[5] * b[9] - a[14] * b[9] + a[9] * b[14] ;
	c[10] += - a[11] * b[0] + a[13] * b[1] + a[12] * b[3] + a[14] * b[10] + a[0] * b[11] - a[3] * b[12] - a[1] * b[13] - a[10] * b[14] ;
	c[11] += + a[10] * b[0] + a[13] * b[2] + a[12] * b[4] - a[0] * b[10] + a[14] * b[11] - a[4] * b[12] - a[2] * b[13] - a[11] * b[14] ;
	c[12] += + a[10] * b[1] + a[11] * b[2] + a[12] * b[5] - a[1] * b[10] - a[2] * b[11] - a[5] * b[12] + a[14] * b[12] - a[12] * b[14] ;
	c[13] += + a[10] * b[3] + a[11] * b[4] - a[13] * b[5] - a[3] * b[10] - a[4] * b[11] + a[5] * b[13] + a[14] * b[13] - a[13] * b[14] ;
	c[14] += + a[10] * b[6] + a[11] * b[7] - a[13] * b[8] - a[12] * b[9] - a[6] * b[10] - a[7] * b[11] + a[9] * b[12] + a[8] * b[13] ;
}

void i2gai_pp_02_01_03_m0(const double *a, const double *b, double *c) {
	c[0] += - a[3] * b[0] - a[2] * b[1] - a[5] * b[4] - a[4] * b[10] ;
	c[1] += - a[1] * b[0] - a[2] * b[2] - a[5] * b[5] - a[4] * b[11] ;
	c[2] += + a[0] * b[0] - a[2] * b[3] - a[5] * b[6] - a[4] * b[12] ;
	c[3] += - a[1] * b[1] + a[3] * b[2] - a[5] * b[7] - a[4] * b[13] ;
	c[4] += + a[0] * b[1] + a[3] * b[3] - a[5] * b[8] - a[4] * b[14] ;
	c[5] += + a[0] * b[2] + a[1] * b[3] - a[5] * b[9] - a[4] * b[15] ;
	c[6] += - a[1] * b[4] + a[3] * b[5] + a[2] * b[7] - a[4] * b[16] ;
	c[7] += + a[0] * b[4] + a[3] * b[6] + a[2] * b[8] - a[4] * b[17] ;
	c[8] += + a[0] * b[5] + a[1] * b[6] + a[2] * b[9] - a[4] * b[18] ;
	c[9] += + a[0] * b[7] + a[1] * b[8] - a[3] * b[9] - a[4] * b[19] ;
	c[10] += - a[1] * b[10] + a[3] * b[11] + a[2] * b[13] + a[5] * b[16] ;
	c[11] += + a[0] * b[10] + a[3] * b[12] + a[2] * b[14] + a[5] * b[17] ;
	c[12] += + a[0] * b[11] + a[1] * b[12] + a[2] * b[15] + a[5] * b[18] ;
	c[13] += + a[0] * b[13] + a[1] * b[14] - a[3] * b[15] + a[5] * b[19] ;
	c[14] += + a[0] * b[16] + a[1] * b[17] - a[3] * b[18] - a[2] * b[19] ;
}

void i2gai_pp_02_04_02_m0(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[5] - a[6] * b[8] - a[5] * b[9] - a[2] * b[12] - a[1] * b[13] + a[9] * b[14] ;
	c[1] += - a[0] * b[2] - a[5] * b[7] - a[7] * b[8] - a[1] * b[11] - a[3] * b[12] + a[10] * b[14] ;
	c[2] += + a[0] * b[1] + a[5] * b[6] - a[8] * b[8] + a[1] * b[10] - a[4] * b[12] + a[11] * b[14] ;
	c[3] += + a[0] * b[4] - a[6] * b[7] + a[7] * b[9] - a[2] * b[11] + a[3] * b[13] + a[12] * b[14] ;
	c[4] += - a[0] * b[3] + a[6] * b[6] + a[8] * b[9] + a[2] * b[10] + a[4] * b[13] + a[13] * b[14] ;
	c[5] += - a[0] * b[0] + a[7] * b[6] + a[8] * b[7] + a[3] * b[10] + a[4] * b[11] + a[14] * b[14] ;
	c[6] += + a[2] * b[2] + a[1] * b[4] + a[3] * b[5] - a[9] * b[7] + a[12] * b[8] + a[10] * b[9] ;
	c[7] += - a[2] * b[1] - a[1] * b[3] + a[4] * b[5] + a[9] * b[6] + a[13] * b[8] + a[11] * b[9] ;
	c[8] += - a[1] * b[0] - a[3] * b[1] - a[4] * b[2] + a[10] * b[6] + a[11] * b[7] + a[14] * b[8] ;
	c[9] += - a[2] * b[0] + a[3] * b[3] + a[4] * b[4] + a[12] * b[6] + a[13] * b[7] - a[14] * b[9] ;
	c[10] += + a[6] * b[2] + a[5] * b[4] + a[7] * b[5] + a[9] * b[11] - a[12] * b[12] - a[10] * b[13] ;
	c[11] += - a[6] * b[1] - a[5] * b[3] + a[8] * b[5] - a[9] * b[10] - a[13] * b[12] - a[11] * b[13] ;
	c[12] += - a[5] * b[0] - a[7] * b[1] - a[8] * b[2] - a[10] * b[10] - a[11] * b[11] - a[14] * b[12] ;
	c[13] += - a[6] * b[0] + a[7] * b[3] + a[8] * b[4] - a[12] * b[10] - a[13] * b[11] + a[14] * b[13] ;
	c[14] += - a[9] * b[0] + a[12] * b[1] + a[13] * b[2] + a[10] * b[3] + a[11] * b[4] + a[14] * b[5] ;
}

void i2gai_pp_02_03_03_m0(const double *a, const double *b, double *c) {
	c[0] += - a[3] * b[2] + a[2] * b[3] + a[14] * b[5] - a[13] * b[6] + a[12] * b[7] - a[11] * b[8] + a[8] * b[11] - a[7] * b[12] + a[6] * b[13] - a[5] * b[14] - a[17] * b[16] + a[16] * b[17] ;
	c[1] += + a[3] * b[0] - a[0] * b[3] + a[12] * b[4] + a[15] * b[5] - a[10] * b[6] - a[11] * b[9] + a[6] * b[10] + a[9] * b[11] - a[4] * b[12] - a[5] * b[15] - a[18] * b[16] + a[16] * b[18] ;
	c[2] += - a[2] * b[0] + a[0] * b[2] - a[11] * b[4] + a[10] * b[5] + a[15] * b[6] - a[12] * b[9] - a[5] * b[10] + a[4] * b[11] + a[9] * b[12] - a[6] * b[15] - a[18] * b[17] + a[17] * b[18] ;
	c[3] += - a[3] * b[1] + a[1] * b[3] + a[14] * b[4] - a[15] * b[7] - a[10] * b[8] + a[13] * b[9] + a[8] * b[10] - a[9] * b[13] - a[4] * b[14] + a[7] * b[15] - a[19] * b[16] + a[16] * b[19] ;
	c[4] += + a[2] * b[1] - a[1] * b[2] - a[13] * b[4] + a[10] * b[7] - a[15] * b[8] + a[14] * b[9] - a[7] * b[10] + a[4] * b[13] - a[9] * b[14] + a[8] * b[15] - a[19] * b[17] + a[17] * b[19] ;
	c[5] += + a[1] * b[0] - a[0] * b[1] - a[13] * b[5] - a[14] * b[6] + a[11] * b[7] + a[12] * b[8] - a[7] * b[11] - a[8] * b[12] + a[5] * b[13] + a[6] * b[14] - a[19] * b[18] + a[18] * b[19] ;
	c[6] += - a[8] * b[0] - a[6] * b[1] - a[9] * b[2] + a[17] * b[4] - a[19] * b[5] + a[1] * b[6] - a[18] * b[7] + a[0] * b[8] + a[2] * b[9] - a[4] * b[17] + a[7] * b[18] + a[5] * b[19] ;
	c[7] += + a[7] * b[0] + a[5] * b[1] - a[9] * b[3] - a[16] * b[4] - a[1] * b[5] - a[19] * b[6] - a[0] * b[7] - a[18] * b[8] + a[3] * b[9] + a[4] * b[16] + a[8] * b[18] + a[6] * b[19] ;
	c[8] += + a[4] * b[0] + a[5] * b[2] + a[6] * b[3] - a[0] * b[4] - a[2] * b[5] - a[16] * b[5] - a[3] * b[6] - a[17] * b[6] - a[18] * b[9] + a[5] * b[16] + a[6] * b[17] + a[9] * b[18] ;
	c[9] += + a[4] * b[1] - a[7] * b[2] - a[8] * b[3] - a[1] * b[4] + a[2] * b[7] - a[16] * b[7] + a[3] * b[8] - a[17] * b[8] + a[19] * b[9] + a[7] * b[16] + a[8] * b[17] - a[9] * b[19] ;
	c[10] += - a[14] * b[0] - a[12] * b[1] - a[15] * b[2] - a[17] * b[10] + a[19] * b[11] + a[1] * b[12] + a[18] * b[13] + a[0] * b[14] + a[2] * b[15] + a[10] * b[17] - a[13] * b[18] - a[11] * b[19] ;
	c[11] += + a[13] * b[0] + a[11] * b[1] - a[15] * b[3] + a[16] * b[10] - a[1] * b[11] + a[19] * b[12] - a[0] * b[13] + a[18] * b[14] + a[3] * b[15] - a[10] * b[16] - a[14] * b[18] - a[12] * b[19] ;
	c[12] += + a[10] * b[0] + a[11] * b[2] + a[12] * b[3] - a[0] * b[10] - a[2] * b[11] + a[16] * b[11] - a[3] * b[12] + a[17] * b[12] + a[18] * b[15] - a[11] * b[16] - a[12] * b[17] - a[15] * b[18] ;
	c[13] += + a[10] * b[1] - a[13] * b[2] - a[14] * b[3] - a[1] * b[10] + a[2] * b[13] + a[16] * b[13] + a[3] * b[14] + a[17] * b[14] - a[19] * b[15] - a[13] * b[16] - a[14] * b[17] + a[15] * b[19] ;
	c[14] += + a[10] * b[4] - a[13] * b[5] - a[14] * b[6] - a[11] * b[7] - a[12] * b[8] - a[15] * b[9] - a[4] * b[10] + a[7] * b[11] + a[8] * b[12] + a[5] * b[13] + a[6] * b[14] + a[9] * b[15] ;
}

void i2gai_pp_02_02_04_m0(const double *a, const double *b, double *c) {
	c[0] += + a[5] * b[0] - a[13] * b[1] - a[12] * b[2] - a[9] * b[5] - a[8] * b[6] + a[14] * b[9] ;
	c[1] += - a[2] * b[0] - a[11] * b[1] - a[12] * b[3] - a[7] * b[5] - a[8] * b[7] + a[14] * b[10] ;
	c[2] += + a[1] * b[0] + a[10] * b[1] - a[12] * b[4] + a[6] * b[5] - a[8] * b[8] + a[14] * b[11] ;
	c[3] += + a[4] * b[0] - a[11] * b[2] + a[13] * b[3] - a[7] * b[6] + a[9] * b[7] + a[14] * b[12] ;
	c[4] += - a[3] * b[0] + a[10] * b[2] + a[13] * b[4] + a[6] * b[6] + a[9] * b[8] + a[14] * b[13] ;
	c[5] += - a[0] * b[0] + a[10] * b[3] + a[11] * b[4] + a[6] * b[7] + a[7] * b[8] + a[14] * b[14] ;
	c[6] += + a[4] * b[1] + a[2] * b[2] + a[5] * b[3] - a[7] * b[9] + a[9] * b[10] + a[8] * b[12] ;
	c[7] += - a[3] * b[1] - a[1] * b[2] + a[5] * b[4] + a[6] * b[9] + a[9] * b[11] + a[8] * b[13] ;
	c[8] += - a[0] * b[1] - a[1] * b[3] - a[2] * b[4] + a[6] * b[10] + a[7] * b[11] + a[8] * b[14] ;
	c[9] += - a[0] * b[2] + a[3] * b[3] + a[4] * b[4] + a[6] * b[12] + a[7] * b[13] - a[9] * b[14] ;
	c[10] += + a[4] * b[5] + a[2] * b[6] + a[5] * b[7] + a[11] * b[9] - a[13] * b[10] - a[12] * b[12] ;
	c[11] += - a[3] * b[5] - a[1] * b[6] + a[5] * b[8] - a[10] * b[9] - a[13] * b[11] - a[12] * b[13] ;
	c[12] += - a[0] * b[5] - a[1] * b[7] - a[2] * b[8] - a[10] * b[10] - a[11] * b[11] - a[12] * b[14] ;
	c[13] += - a[0] * b[6] + a[3] * b[7] + a[4] * b[8] - a[10] * b[12] - a[11] * b[13] + a[13] * b[14] ;
	c[14] += - a[0] * b[9] + a[3] * b[10] + a[4] * b[11] + a[1] * b[12] + a[2] * b[13] + a[5] * b[14] ;
}

void i2gai_pp_02_05_03_m0(const double *a, const double *b, double *c) {
	c[0] += - a[1] * b[9] - a[0] * b[15] - a[3] * b[18] - a[2] * b[19] ;
	c[1] += + a[1] * b[6] + a[0] * b[12] - a[2] * b[17] - a[4] * b[18] ;
	c[2] += - a[1] * b[5] - a[0] * b[11] + a[2] * b[16] - a[5] * b[18] ;
	c[3] += - a[1] * b[8] - a[0] * b[14] - a[3] * b[17] + a[4] * b[19] ;
	c[4] += + a[1] * b[7] + a[0] * b[13] + a[3] * b[16] + a[5] * b[19] ;
	c[5] += + a[1] * b[4] + a[0] * b[10] + a[4] * b[16] + a[5] * b[17] ;
	c[6] += - a[0] * b[3] - a[3] * b[6] - a[2] * b[8] - a[4] * b[9] ;
	c[7] += + a[0] * b[2] + a[3] * b[5] + a[2] * b[7] - a[5] * b[9] ;
	c[8] += - a[0] * b[0] + a[2] * b[4] + a[4] * b[5] + a[5] * b[6] ;
	c[9] += + a[0] * b[1] + a[3] * b[4] - a[4] * b[7] - a[5] * b[8] ;
	c[10] += - a[1] * b[3] + a[3] * b[12] + a[2] * b[14] + a[4] * b[15] ;
	c[11] += + a[1] * b[2] - a[3] * b[11] - a[2] * b[13] + a[5] * b[15] ;
	c[12] += - a[1] * b[0] - a[2] * b[10] - a[4] * b[11] - a[5] * b[12] ;
	c[13] += + a[1] * b[1] - a[3] * b[10] + a[4] * b[13] + a[5] * b[14] ;
	c[14] += + a[3] * b[0] + a[2] * b[1] + a[4] * b[2] + a[5] * b[3] ;
}

void i2gai_pp_02_04_04_m0(const double *a, const double *b, double *c) {
	c[0] += - a[8] * b[3] + a[7] * b[4] - a[4] * b[7] + a[3] * b[8] - a[13] * b[10] + a[12] * b[11] - a[11] * b[12] + a[10] * b[13] ;
	c[1] += + a[8] * b[1] - a[5] * b[4] + a[4] * b[5] - a[1] * b[8] - a[11] * b[9] - a[14] * b[10] + a[9] * b[11] + a[10] * b[14] ;
	c[2] += - a[7] * b[1] + a[5] * b[3] - a[3] * b[5] + a[1] * b[7] + a[10] * b[9] - a[9] * b[10] - a[14] * b[11] + a[11] * b[14] ;
	c[3] += - a[8] * b[2] + a[6] * b[4] - a[4] * b[6] + a[2] * b[8] - a[13] * b[9] + a[14] * b[12] + a[9] * b[13] - a[12] * b[14] ;
	c[4] += + a[7] * b[2] - a[6] * b[3] + a[3] * b[6] - a[2] * b[7] + a[12] * b[9] - a[9] * b[12] + a[14] * b[13] - a[13] * b[14] ;
	c[5] += + a[6] * b[1] - a[5] * b[2] + a[2] * b[5] - a[1] * b[6] + a[12] * b[10] + a[13] * b[11] - a[10] * b[12] - a[11] * b[13] ;
	c[6] += - a[4] * b[0] - a[13] * b[1] - a[11] * b[2] - a[14] * b[3] + a[0] * b[4] + a[2] * b[11] + a[1] * b[13] + a[3] * b[14] ;
	c[7] += + a[3] * b[0] + a[12] * b[1] + a[10] * b[2] - a[0] * b[3] - a[14] * b[4] - a[2] * b[10] - a[1] * b[12] + a[4] * b[14] ;
	c[8] += - a[1] * b[0] + a[0] * b[1] + a[9] * b[1] + a[10] * b[3] + a[11] * b[4] - a[1] * b[9] - a[3] * b[10] - a[4] * b[11] ;
	c[9] += + a[2] * b[0] - a[0] * b[2] + a[9] * b[2] - a[12] * b[3] - a[13] * b[4] - a[2] * b[9] + a[3] * b[12] + a[4] * b[13] ;
	c[10] += - a[8] * b[0] + a[13] * b[5] + a[11] * b[6] + a[14] * b[7] + a[0] * b[8] - a[6] * b[11] - a[5] * b[13] - a[7] * b[14] ;
	c[11] += + a[7] * b[0] - a[12] * b[5] - a[10] * b[6] - a[0] * b[7] + a[14] * b[8] + a[6] * b[10] + a[5] * b[12] - a[8] * b[14] ;
	c[12] += - a[5] * b[0] + a[0] * b[5] - a[9] * b[5] - a[10] * b[7] - a[11] * b[8] + a[5] * b[9] + a[7] * b[10] + a[8] * b[11] ;
	c[13] += + a[6] * b[0] - a[0] * b[6] - a[9] * b[6] + a[12] * b[7] + a[13] * b[8] + a[6] * b[9] - a[7] * b[12] - a[8] * b[13] ;
	c[14] += + a[6] * b[1] + a[5] * b[2] + a[7] * b[3] + a[8] * b[4] - a[2] * b[5] - a[1] * b[6] - a[3] * b[7] - a[4] * b[8] ;
}

void i2gai_pp_02_03_05_m0(const double *a, const double *b, double *c) {
	c[0] += - a[15] * b[0] - a[9] * b[1] - a[19] * b[2] - a[18] * b[3] ;
	c[1] += + a[12] * b[0] + a[6] * b[1] - a[17] * b[2] - a[18] * b[4] ;
	c[2] += - a[11] * b[0] - a[5] * b[1] + a[16] * b[2] - a[18] * b[5] ;
	c[3] += - a[14] * b[0] - a[8] * b[1] - a[17] * b[3] + a[19] * b[4] ;
	c[4] += + a[13] * b[0] + a[7] * b[1] + a[16] * b[3] + a[19] * b[5] ;
	c[5] += + a[10] * b[0] + a[4] * b[1] + a[16] * b[4] + a[17] * b[5] ;
	c[6] += - a[3] * b[0] - a[8] * b[2] - a[6] * b[3] - a[9] * b[4] ;
	c[7] += + a[2] * b[0] + a[7] * b[2] + a[5] * b[3] - a[9] * b[5] ;
	c[8] += - a[0] * b[0] + a[4] * b[2] + a[5] * b[4] + a[6] * b[5] ;
	c[9] += + a[1] * b[0] + a[4] * b[3] - a[7] * b[4] - a[8] * b[5] ;
	c[10] += - a[3] * b[1] + a[14] * b[2] + a[12] * b[3] + a[15] * b[4] ;
	c[11] += + a[2] * b[1] - a[13] * b[2] - a[11] * b[3] + a[15] * b[5] ;
	c[12] += - a[0] * b[1] - a[10] * b[2] - a[11] * b[4] - a[12] * b[5] ;
	c[13] += + a[1] * b[1] - a[10] * b[3] + a[13] * b[4] + a[14] * b[5] ;
	c[14] += + a[1] * b[2] + a[0] * b[3] + a[2] * b[4] + a[3] * b[5] ;
}

void i2gai_pp_02_06_04_m0(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[14] ;
	c[1] += - a[0] * b[11] ;
	c[2] += + a[0] * b[10] ;
	c[3] += + a[0] * b[13] ;
	c[4] += - a[0] * b[12] ;
	c[5] += - a[0] * b[9] ;
	c[6] += - a[0] * b[4] ;
	c[7] += + a[0] * b[3] ;
	c[8] += - a[0] * b[1] ;
	c[9] += + a[0] * b[2] ;
	c[10] += + a[0] * b[8] ;
	c[11] += - a[0] * b[7] ;
	c[12] += + a[0] * b[5] ;
	c[13] += - a[0] * b[6] ;
	c[14] += - a[0] * b[0] ;
}

void i2gai_pp_02_05_05_m0(const double *a, const double *b, double *c) {
	c[0] += - a[5] * b[4] + a[4] * b[5] ;
	c[1] += + a[5] * b[2] - a[2] * b[5] ;
	c[2] += - a[4] * b[2] + a[2] * b[4] ;
	c[3] += - a[5] * b[3] + a[3] * b[5] ;
	c[4] += + a[4] * b[3] - a[3] * b[4] ;
	c[5] += + a[3] * b[2] - a[2] * b[3] ;
	c[6] += + a[5] * b[0] - a[0] * b[5] ;
	c[7] += - a[4] * b[0] + a[0] * b[4] ;
	c[8] += + a[2] * b[0] - a[0] * b[2] ;
	c[9] += - a[3] * b[0] + a[0] * b[3] ;
	c[10] += - a[5] * b[1] + a[1] * b[5] ;
	c[11] += + a[4] * b[1] - a[1] * b[4] ;
	c[12] += - a[2] * b[1] + a[1] * b[2] ;
	c[13] += + a[3] * b[1] - a[1] * b[3] ;
	c[14] += + a[1] * b[0] - a[0] * b[1] ;
}

void i2gai_pp_02_04_06_m0(const double *a, const double *b, double *c) {
	c[0] += + a[14] * b[0] ;
	c[1] += - a[11] * b[0] ;
	c[2] += + a[10] * b[0] ;
	c[3] += + a[13] * b[0] ;
	c[4] += - a[12] * b[0] ;
	c[5] += - a[9] * b[0] ;
	c[6] += - a[4] * b[0] ;
	c[7] += + a[3] * b[0] ;
	c[8] += - a[1] * b[0] ;
	c[9] += + a[2] * b[0] ;
	c[10] += + a[8] * b[0] ;
	c[11] += - a[7] * b[0] ;
	c[12] += + a[5] * b[0] ;
	c[13] += - a[6] * b[0] ;
	c[14] += - a[0] * b[0] ;
}

void i2gai_pp_03_03_00_m0(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[0] ;
	c[1] += + a[1] * b[0] ;
	c[2] += + a[2] * b[0] ;
	c[3] += + a[3] * b[0] ;
	c[4] += + a[4] * b[0] ;
	c[5] += + a[5] * b[0] ;
	c[6] += + a[6] * b[0] ;
	c[7] += + a[7] * b[0] ;
	c[8] += + a[8] * b[0] ;
	c[9] += + a[9] * b[0] ;
	c[10] += + a[10] * b[0] ;
	c[11] += + a[11] * b[0] ;
	c[12] += + a[12] * b[0] ;
	c[13] += + a[13] * b[0] ;
	c[14] += + a[14] * b[0] ;
	c[15] += + a[15] * b[0] ;
	c[16] += + a[16] * b[0] ;
	c[17] += + a[17] * b[0] ;
	c[18] += + a[18] * b[0] ;
	c[19] += + a[19] * b[0] ;
}

void i2gai_pp_03_02_01_m0(const double *a, const double *b, double *c) {
	c[0] += + a[2] * b[0] - a[1] * b[1] + a[0] * b[2] ;
	c[1] += + a[4] * b[0] - a[3] * b[1] + a[0] * b[3] ;
	c[2] += + a[5] * b[0] - a[3] * b[2] + a[1] * b[3] ;
	c[3] += + a[5] * b[1] - a[4] * b[2] + a[2] * b[3] ;
	c[4] += + a[7] * b[0] - a[6] * b[1] + a[0] * b[4] ;
	c[5] += + a[8] * b[0] - a[6] * b[2] + a[1] * b[4] ;
	c[6] += + a[8] * b[1] - a[7] * b[2] + a[2] * b[4] ;
	c[7] += + a[9] * b[0] - a[6] * b[3] + a[3] * b[4] ;
	c[8] += + a[9] * b[1] - a[7] * b[3] + a[4] * b[4] ;
	c[9] += + a[9] * b[2] - a[8] * b[3] + a[5] * b[4] ;
	c[10] += + a[11] * b[0] - a[10] * b[1] + a[0] * b[5] ;
	c[11] += + a[12] * b[0] - a[10] * b[2] + a[1] * b[5] ;
	c[12] += + a[12] * b[1] - a[11] * b[2] + a[2] * b[5] ;
	c[13] += + a[13] * b[0] - a[10] * b[3] + a[3] * b[5] ;
	c[14] += + a[13] * b[1] - a[11] * b[3] + a[4] * b[5] ;
	c[15] += + a[13] * b[2] - a[12] * b[3] + a[5] * b[5] ;
	c[16] += + a[14] * b[0] - a[10] * b[4] + a[6] * b[5] ;
	c[17] += + a[14] * b[1] - a[11] * b[4] + a[7] * b[5] ;
	c[18] += + a[14] * b[2] - a[12] * b[4] + a[8] * b[5] ;
	c[19] += + a[14] * b[3] - a[13] * b[4] + a[9] * b[5] ;
}

void i2gai_pp_03_01_02_m0(const double *a, const double *b, double *c) {
	c[0] += + a[2] * b[0] - a[1] * b[1] + a[0] * b[2] ;
	c[1] += + a[3] * b[0] - a[1] * b[3] + a[0] * b[4] ;
	c[2] += + a[3] * b[1] - a[2] * b[3] + a[0] * b[5] ;
	c[3] += + a[3] * b[2] - a[2] * b[4] + a[1] * b[5] ;
	c[4] += + a[4] * b[0] - a[1] * b[6] + a[0] * b[7] ;
	c[5] += + a[4] * b[1] - a[2] * b[6] + a[0] * b[8] ;
	c[6] += + a[4] * b[2] - a[2] * b[7] + a[1] * b[8] ;
	c[7] += + a[4] * b[3] - a[3] * b[6] + a[0] * b[9] ;
	c[8] += + a[4] * b[4] - a[3] * b[7] + a[1] * b[9] ;
	c[9] += + a[4] * b[5] - a[3] * b[8] + a[2] * b[9] ;
	c[10] += + a[5] * b[0] - a[1] * b[10] + a[0] * b[11] ;
	c[11] += + a[5] * b[1] - a[2] * b[10] + a[0] * b[12] ;
	c[12] += + a[5] * b[2] - a[2] * b[11] + a[1] * b[12] ;
	c[13] += + a[5] * b[3] - a[3] * b[10] + a[0] * b[13] ;
	c[14] += + a[5] * b[4] - a[3] * b[11] + a[1] * b[13] ;
	c[15] += + a[5] * b[5] - a[3] * b[12] + a[2] * b[13] ;
	c[16] += + a[5] * b[6] - a[4] * b[10] + a[0] * b[14] ;
	c[17] += + a[5] * b[7] - a[4] * b[11] + a[1] * b[14] ;
	c[18] += + a[5] * b[8] - a[4] * b[12] + a[2] * b[14] ;
	c[19] += + a[5] * b[9] - a[4] * b[13] + a[3] * b[14] ;
}

void i2gai_pp_03_04_01_m0(const double *a, const double *b, double *c) {
	c[0] += - a[0] * b[2] - a[5] * b[4] - a[1] * b[5] ;
	c[1] += + a[0] * b[3] - a[6] * b[4] - a[2] * b[5] ;
	c[2] += + a[0] * b[1] - a[7] * b[4] - a[3] * b[5] ;
	c[3] += - a[0] * b[0] - a[8] * b[4] - a[4] * b[5] ;
	c[4] += + a[2] * b[2] + a[1] * b[3] - a[9] * b[4] ;
	c[5] += + a[1] * b[1] + a[3] * b[2] - a[10] * b[4] ;
	c[6] += - a[1] * b[0] + a[4] * b[2] - a[11] * b[4] ;
	c[7] += + a[2] * b[1] - a[3] * b[3] - a[12] * b[4] ;
	c[8] += - a[2] * b[0] - a[4] * b[3] - a[13] * b[4] ;
	c[9] += - a[3] * b[0] - a[4] * b[1] - a[14] * b[4] ;
	c[10] += + a[6] * b[2] + a[5] * b[3] + a[9] * b[5] ;
	c[11] += + a[5] * b[1] + a[7] * b[2] + a[10] * b[5] ;
	c[12] += - a[5] * b[0] + a[8] * b[2] + a[11] * b[5] ;
	c[13] += + a[6] * b[1] - a[7] * b[3] + a[12] * b[5] ;
	c[14] += - a[6] * b[0] - a[8] * b[3] + a[13] * b[5] ;
	c[15] += - a[7] * b[0] - a[8] * b[1] + a[14] * b[5] ;
	c[16] += + a[9] * b[1] - a[12] * b[2] - a[10] * b[3] ;
	c[17] += - a[9] * b[0] - a[13] * b[2] - a[11] * b[3] ;
	c[18] += - a[10] * b[0] - a[11] * b[1] - a[14] * b[2] ;
	c[19] += - a[12] * b[0] - a[13] * b[1] + a[14] * b[3] ;
}

void i2gai_pp_03_03_02_m0(const double *a, const double *b, double *c) {
	c[0] += + a[3] * b[1] - a[2] * b[2] + a[0] * b[5] + a[12] * b[6] - a[11] * b[7] + a[10] * b[8] + a[6] * b[10] - a[5] * b[11] + a[4] * b[12] ;
	c[1] += - a[3] * b[3] + a[2] * b[4] - a[1] * b[5] + a[14] * b[6] - a[13] * b[7] + a[10] * b[9] + a[8] * b[10] - a[7] * b[11] + a[4] * b[13] ;
	c[2] += - a[3] * b[0] + a[1] * b[2] - a[0] * b[4] + a[15] * b[6] - a[13] * b[8] + a[11] * b[9] + a[9] * b[10] - a[7] * b[12] + a[5] * b[13] ;
	c[3] += + a[2] * b[0] - a[1] * b[1] + a[0] * b[3] + a[15] * b[7] - a[14] * b[8] + a[12] * b[9] + a[9] * b[11] - a[8] * b[12] + a[6] * b[13] ;
	c[4] += - a[8] * b[1] + a[7] * b[2] - a[6] * b[3] + a[5] * b[4] + a[17] * b[6] - a[16] * b[7] - a[1] * b[8] - a[0] * b[9] + a[4] * b[14] ;
	c[5] += - a[6] * b[0] - a[9] * b[1] + a[4] * b[2] + a[5] * b[5] + a[18] * b[6] - a[0] * b[7] - a[2] * b[8] - a[16] * b[8] + a[5] * b[14] ;
	c[6] += + a[5] * b[0] - a[4] * b[1] - a[9] * b[2] + a[6] * b[5] + a[0] * b[6] + a[18] * b[7] - a[3] * b[8] - a[17] * b[8] + a[6] * b[14] ;
	c[7] += - a[8] * b[0] + a[9] * b[3] + a[4] * b[4] - a[7] * b[5] + a[19] * b[6] - a[1] * b[7] + a[2] * b[9] - a[16] * b[9] + a[7] * b[14] ;
	c[8] += + a[7] * b[0] - a[4] * b[3] + a[9] * b[4] - a[8] * b[5] + a[1] * b[6] + a[19] * b[7] + a[3] * b[9] - a[17] * b[9] + a[8] * b[14] ;
	c[9] += + a[7] * b[1] + a[8] * b[2] - a[5] * b[3] - a[6] * b[4] + a[2] * b[6] + a[3] * b[7] + a[19] * b[8] - a[18] * b[9] + a[9] * b[14] ;
	c[10] += - a[14] * b[1] + a[13] * b[2] - a[12] * b[3] + a[11] * b[4] - a[17] * b[10] + a[16] * b[11] - a[1] * b[12] - a[0] * b[13] - a[10] * b[14] ;
	c[11] += - a[12] * b[0] - a[15] * b[1] + a[10] * b[2] + a[11] * b[5] - a[18] * b[10] - a[0] * b[11] - a[2] * b[12] + a[16] * b[12] - a[11] * b[14] ;
	c[12] += + a[11] * b[0] - a[10] * b[1] - a[15] * b[2] + a[12] * b[5] + a[0] * b[10] - a[18] * b[11] - a[3] * b[12] + a[17] * b[12] - a[12] * b[14] ;
	c[13] += - a[14] * b[0] + a[15] * b[3] + a[10] * b[4] - a[13] * b[5] - a[19] * b[10] - a[1] * b[11] + a[2] * b[13] + a[16] * b[13] - a[13] * b[14] ;
	c[14] += + a[13] * b[0] - a[10] * b[3] + a[15] * b[4] - a[14] * b[5] + a[1] * b[10] - a[19] * b[11] + a[3] * b[13] + a[17] * b[13] - a[14] * b[14] ;
	c[15] += + a[13] * b[1] + a[14] * b[2] - a[11] * b[3] - a[12] * b[4] + a[2] * b[10] + a[3] * b[11] - a[19] * b[12] + a[18] * b[13] - a[15] * b[14] ;
	c[16] += - a[17] * b[0] + a[19] * b[1] + a[18] * b[3] + a[10] * b[7] - a[13] * b[8] - a[11] * b[9] - a[4] * b[11] + a[7] * b[12] + a[5] * b[13] ;
	c[17] += + a[16] * b[0] + a[19] * b[2] + a[18] * b[4] - a[10] * b[6] - a[14] * b[8] - a[12] * b[9] + a[4] * b[10] + a[8] * b[12] + a[6] * b[13] ;
	c[18] += + a[16] * b[1] + a[17] * b[2] + a[18] * b[5] - a[11] * b[6] - a[12] * b[7] - a[15] * b[8] + a[5] * b[10] + a[6] * b[11] + a[9] * b[12] ;
	c[19] += + a[16] * b[3] + a[17] * b[4] - a[19] * b[5] - a[13] * b[6] - a[14] * b[7] + a[15] * b[9] + a[7] * b[10] + a[8] * b[11] - a[9] * b[13] ;
}

void i2gai_pp_03_00_03_m0(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[0] ;
	c[1] += + a[0] * b[1] ;
	c[2] += + a[0] * b[2] ;
	c[3] += + a[0] * b[3] ;
	c[4] += + a[0] * b[4] ;
	c[5] += + a[0] * b[5] ;
	c[6] += + a[0] * b[6] ;
	c[7] += + a[0] * b[7] ;
	c[8] += + a[0] * b[8] ;
	c[9] += + a[0] * b[9] ;
	c[10] += + a[0] * b[10] ;
	c[11] += + a[0] * b[11] ;
	c[12] += + a[0] * b[12] ;
	c[13] += + a[0] * b[13] ;
	c[14] += + a[0] * b[14] ;
	c[15] += + a[0] * b[15] ;
	c[16] += + a[0] * b[16] ;
	c[17] += + a[0] * b[17] ;
	c[18] += + a[0] * b[18] ;
	c[19] += + a[0] * b[19] ;
}

void i2gai_pp_03_02_03_m0(const double *a, const double *b, double *c) {
	c[0] += - a[5] * b[0] + a[2] * b[2] - a[1] * b[3] - a[12] * b[4] + a[11] * b[5] - a[10] * b[6] - a[8] * b[10] + a[7] * b[11] - a[6] * b[12] ;
	c[1] += + a[5] * b[1] - a[4] * b[2] + a[3] * b[3] - a[13] * b[4] + a[11] * b[7] - a[10] * b[8] - a[9] * b[10] + a[7] * b[13] - a[6] * b[14] ;
	c[2] += + a[4] * b[0] - a[2] * b[1] + a[0] * b[3] - a[13] * b[5] + a[12] * b[7] - a[10] * b[9] - a[9] * b[11] + a[8] * b[13] - a[6] * b[15] ;
	c[3] += - a[3] * b[0] + a[1] * b[1] - a[0] * b[2] - a[13] * b[6] + a[12] * b[8] - a[11] * b[9] - a[9] * b[12] + a[8] * b[14] - a[7] * b[15] ;
	c[4] += + a[9] * b[0] + a[8] * b[1] - a[14] * b[4] - a[4] * b[5] + a[3] * b[6] - a[2] * b[7] + a[1] * b[8] + a[7] * b[16] - a[6] * b[17] ;
	c[5] += + a[7] * b[0] + a[8] * b[2] - a[2] * b[4] - a[5] * b[5] - a[14] * b[5] + a[0] * b[6] + a[1] * b[9] + a[8] * b[16] - a[6] * b[18] ;
	c[6] += - a[6] * b[0] + a[8] * b[3] + a[1] * b[4] - a[0] * b[5] - a[5] * b[6] - a[14] * b[6] + a[2] * b[9] + a[8] * b[17] - a[7] * b[18] ;
	c[7] += + a[7] * b[1] - a[9] * b[2] - a[4] * b[4] + a[5] * b[7] - a[14] * b[7] + a[0] * b[8] - a[3] * b[9] + a[9] * b[16] - a[6] * b[19] ;
	c[8] += - a[6] * b[1] - a[9] * b[3] + a[3] * b[4] - a[0] * b[7] + a[5] * b[8] - a[14] * b[8] - a[4] * b[9] + a[9] * b[17] - a[7] * b[19] ;
	c[9] += - a[6] * b[2] - a[7] * b[3] + a[3] * b[5] + a[4] * b[6] - a[1] * b[7] - a[2] * b[8] - a[14] * b[9] + a[9] * b[18] - a[8] * b[19] ;
	c[10] += + a[13] * b[0] + a[12] * b[1] + a[14] * b[10] - a[4] * b[11] + a[3] * b[12] - a[2] * b[13] + a[1] * b[14] - a[11] * b[16] + a[10] * b[17] ;
	c[11] += + a[11] * b[0] + a[12] * b[2] - a[2] * b[10] - a[5] * b[11] + a[14] * b[11] + a[0] * b[12] + a[1] * b[15] - a[12] * b[16] + a[10] * b[18] ;
	c[12] += - a[10] * b[0] + a[12] * b[3] + a[1] * b[10] - a[0] * b[11] - a[5] * b[12] + a[14] * b[12] + a[2] * b[15] - a[12] * b[17] + a[11] * b[18] ;
	c[13] += + a[11] * b[1] - a[13] * b[2] - a[4] * b[10] + a[5] * b[13] + a[14] * b[13] + a[0] * b[14] - a[3] * b[15] - a[13] * b[16] + a[10] * b[19] ;
	c[14] += - a[10] * b[1] - a[13] * b[3] + a[3] * b[10] - a[0] * b[13] + a[5] * b[14] + a[14] * b[14] - a[4] * b[15] - a[13] * b[17] + a[11] * b[19] ;
	c[15] += - a[10] * b[2] - a[11] * b[3] + a[3] * b[11] + a[4] * b[12] - a[1] * b[13] - a[2] * b[14] + a[14] * b[15] - a[13] * b[18] + a[12] * b[19] ;
	c[16] += + a[11] * b[4] - a[13] * b[5] - a[12] * b[7] - a[7] * b[10] + a[9] * b[11] + a[8] * b[13] + a[0] * b[17] - a[3] * b[18] - a[1] * b[19] ;
	c[17] += - a[10] * b[4] - a[13] * b[6] - a[12] * b[8] + a[6] * b[10] + a[9] * b[12] + a[8] * b[14] - a[0] * b[16] - a[4] * b[18] - a[2] * b[19] ;
	c[18] += - a[10] * b[5] - a[11] * b[6] - a[12] * b[9] + a[6] * b[11] + a[7] * b[12] + a[8] * b[15] - a[1] * b[16] - a[2] * b[17] - a[5] * b[18] ;
	c[19] += - a[10] * b[7] - a[11] * b[8] + a[13] * b[9] + a[6] * b[13] + a[7] * b[14] - a[9] * b[15] - a[3] * b[16] - a[4] * b[17] + a[5] * b[19] ;
}

void i2gai_pp_03_01_04_m0(const double *a, const double *b, double *c) {
	c[0] += + a[2] * b[0] + a[5] * b[1] + a[4] * b[5] ;
	c[1] += - a[3] * b[0] + a[5] * b[2] + a[4] * b[6] ;
	c[2] += - a[1] * b[0] + a[5] * b[3] + a[4] * b[7] ;
	c[3] += + a[0] * b[0] + a[5] * b[4] + a[4] * b[8] ;
	c[4] += - a[3] * b[1] - a[2] * b[2] + a[4] * b[9] ;
	c[5] += - a[1] * b[1] - a[2] * b[3] + a[4] * b[10] ;
	c[6] += + a[0] * b[1] - a[2] * b[4] + a[4] * b[11] ;
	c[7] += - a[1] * b[2] + a[3] * b[3] + a[4] * b[12] ;
	c[8] += + a[0] * b[2] + a[3] * b[4] + a[4] * b[13] ;
	c[9] += + a[0] * b[3] + a[1] * b[4] + a[4] * b[14] ;
	c[10] += - a[3] * b[5] - a[2] * b[6] - a[5] * b[9] ;
	c[11] += - a[1] * b[5] - a[2] * b[7] - a[5] * b[10] ;
	c[12] += + a[0] * b[5] - a[2] * b[8] - a[5] * b[11] ;
	c[13] += - a[1] * b[6] + a[3] * b[7] - a[5] * b[12] ;
	c[14] += + a[0] * b[6] + a[3] * b[8] - a[5] * b[13] ;
	c[15] += + a[0] * b[7] + a[1] * b[8] - a[5] * b[14] ;
	c[16] += - a[1] * b[9] + a[3] * b[10] + a[2] * b[12] ;
	c[17] += + a[0] * b[9] + a[3] * b[11] + a[2] * b[13] ;
	c[18] += + a[0] * b[10] + a[1] * b[11] + a[2] * b[14] ;
	c[19] += + a[0] * b[12] + a[1] * b[13] - a[3] * b[14] ;
}

void i2gai_pp_03_05_02_m0(const double *a, const double *b, double *c) {
	c[0] += - a[1] * b[8] - a[0] * b[12] + a[2] * b[14] ;
	c[1] += + a[1] * b[9] + a[0] * b[13] + a[3] * b[14] ;
	c[2] += + a[1] * b[7] + a[0] * b[11] + a[4] * b[14] ;
	c[3] += - a[1] * b[6] - a[0] * b[10] + a[5] * b[14] ;
	c[4] += + a[0] * b[5] + a[3] * b[8] + a[2] * b[9] ;
	c[5] += - a[0] * b[2] + a[2] * b[7] + a[4] * b[8] ;
	c[6] += + a[0] * b[1] - a[2] * b[6] + a[5] * b[8] ;
	c[7] += + a[0] * b[4] + a[3] * b[7] - a[4] * b[9] ;
	c[8] += - a[0] * b[3] - a[3] * b[6] - a[5] * b[9] ;
	c[9] += - a[0] * b[0] - a[4] * b[6] - a[5] * b[7] ;
	c[10] += + a[1] * b[5] - a[3] * b[12] - a[2] * b[13] ;
	c[11] += - a[1] * b[2] - a[2] * b[11] - a[4] * b[12] ;
	c[12] += + a[1] * b[1] + a[2] * b[10] - a[5] * b[12] ;
	c[13] += + a[1] * b[4] - a[3] * b[11] + a[4] * b[13] ;
	c[14] += - a[1] * b[3] + a[3] * b[10] + a[5] * b[13] ;
	c[15] += - a[1] * b[0] + a[4] * b[10] + a[5] * b[11] ;
	c[16] += + a[3] * b[2] + a[2] * b[4] + a[4] * b[5] ;
	c[17] += - a[3] * b[1] - a[2] * b[3] + a[5] * b[5] ;
	c[18] += - a[2] * b[0] - a[4] * b[1] - a[5] * b[2] ;
	c[19] += - a[3] * b[0] + a[4] * b[3] + a[5] * b[4] ;
}

void i2gai_pp_03_04_03_m0(const double *a, const double *b, double *c) {
	c[0] += - a[8] * b[5] + a[7] * b[6] - a[5] * b[9] - a[4] * b[11] + a[3] * b[12] - a[1] * b[15] + a[11] * b[16] - a[10] * b[17] + a[9] * b[18] ;
	c[1] += + a[8] * b[7] - a[7] * b[8] + a[6] * b[9] + a[4] * b[13] - a[3] * b[14] + a[2] * b[15] + a[13] * b[16] - a[12] * b[17] + a[9] * b[19] ;
	c[2] += + a[8] * b[4] - a[6] * b[6] + a[5] * b[8] + a[4] * b[10] - a[2] * b[12] + a[1] * b[14] + a[14] * b[16] - a[12] * b[18] + a[10] * b[19] ;
	c[3] += - a[7] * b[4] + a[6] * b[5] - a[5] * b[7] - a[3] * b[10] + a[2] * b[11] - a[1] * b[13] + a[14] * b[17] - a[13] * b[18] + a[11] * b[19] ;
	c[4] += + a[4] * b[2] - a[3] * b[3] + a[13] * b[5] - a[12] * b[6] + a[11] * b[7] - a[10] * b[8] + a[0] * b[9] + a[2] * b[18] + a[1] * b[19] ;
	c[5] += - a[4] * b[0] + a[1] * b[3] + a[11] * b[4] + a[14] * b[5] - a[0] * b[6] - a[9] * b[6] - a[10] * b[9] + a[1] * b[17] + a[3] * b[18] ;
	c[6] += + a[3] * b[0] - a[1] * b[2] - a[10] * b[4] + a[0] * b[5] + a[9] * b[5] + a[14] * b[6] - a[11] * b[9] - a[1] * b[16] + a[4] * b[18] ;
	c[7] += + a[4] * b[1] - a[2] * b[3] + a[13] * b[4] - a[14] * b[7] + a[0] * b[8] - a[9] * b[8] + a[12] * b[9] + a[2] * b[17] - a[3] * b[19] ;
	c[8] += - a[3] * b[1] + a[2] * b[2] - a[12] * b[4] - a[0] * b[7] + a[9] * b[7] - a[14] * b[8] + a[13] * b[9] - a[2] * b[16] - a[4] * b[19] ;
	c[9] += - a[2] * b[0] + a[1] * b[1] - a[0] * b[4] - a[12] * b[5] - a[13] * b[6] + a[10] * b[7] + a[11] * b[8] - a[3] * b[16] - a[4] * b[17] ;
	c[10] += + a[8] * b[2] - a[7] * b[3] - a[13] * b[11] + a[12] * b[12] - a[11] * b[13] + a[10] * b[14] + a[0] * b[15] - a[6] * b[18] - a[5] * b[19] ;
	c[11] += - a[8] * b[0] + a[5] * b[3] - a[11] * b[10] - a[14] * b[11] - a[0] * b[12] + a[9] * b[12] + a[10] * b[15] - a[5] * b[17] - a[7] * b[18] ;
	c[12] += + a[7] * b[0] - a[5] * b[2] + a[10] * b[10] + a[0] * b[11] - a[9] * b[11] - a[14] * b[12] + a[11] * b[15] + a[5] * b[16] - a[8] * b[18] ;
	c[13] += + a[8] * b[1] - a[6] * b[3] - a[13] * b[10] + a[14] * b[13] + a[0] * b[14] + a[9] * b[14] - a[12] * b[15] - a[6] * b[17] + a[7] * b[19] ;
	c[14] += - a[7] * b[1] + a[6] * b[2] + a[12] * b[10] - a[0] * b[13] - a[9] * b[13] + a[14] * b[14] - a[13] * b[15] + a[6] * b[16] + a[8] * b[19] ;
	c[15] += - a[6] * b[0] + a[5] * b[1] - a[0] * b[10] + a[12] * b[11] + a[13] * b[12] - a[10] * b[13] - a[11] * b[14] + a[7] * b[16] + a[8] * b[17] ;
	c[16] += + a[13] * b[0] + a[11] * b[1] + a[14] * b[2] - a[6] * b[6] - a[5] * b[8] - a[7] * b[9] + a[2] * b[12] + a[1] * b[14] + a[3] * b[15] ;
	c[17] += - a[12] * b[0] - a[10] * b[1] + a[14] * b[3] + a[6] * b[5] + a[5] * b[7] - a[8] * b[9] - a[2] * b[11] - a[1] * b[13] + a[4] * b[15] ;
	c[18] += - a[9] * b[0] - a[10] * b[2] - a[11] * b[3] + a[5] * b[4] + a[7] * b[5] + a[8] * b[6] - a[1] * b[10] - a[3] * b[11] - a[4] * b[12] ;
	c[19] += - a[9] * b[1] + a[12] * b[2] + a[13] * b[3] + a[6] * b[4] - a[7] * b[7] - a[8] * b[8] - a[2] * b[10] + a[3] * b[13] + a[4] * b[14] ;
}

void i2gai_pp_03_03_04_m0(const double *a, const double *b, double *c) {
	c[0] += - a[15] * b[1] + a[12] * b[3] - a[11] * b[4] - a[9] * b[5] + a[6] * b[7] - a[5] * b[8] + a[18] * b[9] - a[17] * b[10] + a[16] * b[11] ;
	c[1] += + a[15] * b[2] - a[14] * b[3] + a[13] * b[4] + a[9] * b[6] - a[8] * b[7] + a[7] * b[8] + a[19] * b[9] - a[17] * b[12] + a[16] * b[13] ;
	c[2] += + a[14] * b[1] - a[12] * b[2] + a[10] * b[4] + a[8] * b[5] - a[6] * b[6] + a[4] * b[8] + a[19] * b[10] - a[18] * b[12] + a[16] * b[14] ;
	c[3] += - a[13] * b[1] + a[11] * b[2] - a[10] * b[3] - a[7] * b[5] + a[5] * b[6] - a[4] * b[7] + a[19] * b[11] - a[18] * b[13] + a[17] * b[14] ;
	c[4] += + a[9] * b[0] + a[19] * b[1] + a[18] * b[2] - a[3] * b[3] + a[2] * b[4] - a[8] * b[10] + a[7] * b[11] - a[6] * b[12] + a[5] * b[13] ;
	c[5] += - a[6] * b[0] + a[3] * b[1] + a[17] * b[1] + a[18] * b[3] - a[0] * b[4] - a[6] * b[9] - a[9] * b[10] + a[4] * b[11] + a[5] * b[14] ;
	c[6] += + a[5] * b[0] - a[2] * b[1] - a[16] * b[1] + a[0] * b[3] + a[18] * b[4] + a[5] * b[9] - a[4] * b[10] - a[9] * b[11] + a[6] * b[14] ;
	c[7] += + a[8] * b[0] - a[3] * b[2] + a[17] * b[2] - a[19] * b[3] + a[1] * b[4] - a[8] * b[9] + a[9] * b[12] + a[4] * b[13] - a[7] * b[14] ;
	c[8] += - a[7] * b[0] + a[2] * b[2] - a[16] * b[2] - a[1] * b[3] - a[19] * b[4] + a[7] * b[9] - a[4] * b[12] + a[9] * b[13] - a[8] * b[14] ;
	c[9] += - a[4] * b[0] + a[1] * b[1] - a[0] * b[2] - a[16] * b[3] - a[17] * b[4] + a[7] * b[10] + a[8] * b[11] - a[5] * b[12] - a[6] * b[13] ;
	c[10] += + a[15] * b[0] - a[19] * b[5] - a[18] * b[6] - a[3] * b[7] + a[2] * b[8] + a[14] * b[10] - a[13] * b[11] + a[12] * b[12] - a[11] * b[13] ;
	c[11] += - a[12] * b[0] + a[3] * b[5] - a[17] * b[5] - a[18] * b[7] - a[0] * b[8] + a[12] * b[9] + a[15] * b[10] - a[10] * b[11] - a[11] * b[14] ;
	c[12] += + a[11] * b[0] - a[2] * b[5] + a[16] * b[5] + a[0] * b[7] - a[18] * b[8] - a[11] * b[9] + a[10] * b[10] + a[15] * b[11] - a[12] * b[14] ;
	c[13] += + a[14] * b[0] - a[3] * b[6] - a[17] * b[6] + a[19] * b[7] + a[1] * b[8] + a[14] * b[9] - a[15] * b[12] - a[10] * b[13] + a[13] * b[14] ;
	c[14] += - a[13] * b[0] + a[2] * b[6] + a[16] * b[6] - a[1] * b[7] + a[19] * b[8] - a[13] * b[9] + a[10] * b[12] - a[15] * b[13] + a[14] * b[14] ;
	c[15] += - a[10] * b[0] + a[1] * b[5] - a[0] * b[6] + a[16] * b[7] + a[17] * b[8] - a[13] * b[10] - a[14] * b[11] + a[11] * b[12] + a[12] * b[13] ;
	c[16] += + a[14] * b[1] + a[12] * b[2] + a[15] * b[3] - a[8] * b[5] - a[6] * b[6] - a[9] * b[7] + a[1] * b[11] + a[0] * b[13] + a[2] * b[14] ;
	c[17] += - a[13] * b[1] - a[11] * b[2] + a[15] * b[4] + a[7] * b[5] + a[5] * b[6] - a[9] * b[8] - a[1] * b[10] - a[0] * b[12] + a[3] * b[14] ;
	c[18] += - a[10] * b[1] - a[11] * b[3] - a[12] * b[4] + a[4] * b[5] + a[5] * b[7] + a[6] * b[8] - a[0] * b[9] - a[2] * b[10] - a[3] * b[11] ;
	c[19] += - a[10] * b[2] + a[13] * b[3] + a[14] * b[4] + a[4] * b[6] - a[7] * b[7] - a[8] * b[8] - a[1] * b[9] + a[2] * b[12] + a[3] * b[13] ;
}

void i2gai_pp_03_02_05_m0(const double *a, const double *b, double *c) {
	c[0] += - a[12] * b[0] - a[8] * b[1] + a[14] * b[2] ;
	c[1] += + a[13] * b[0] + a[9] * b[1] + a[14] * b[3] ;
	c[2] += + a[11] * b[0] + a[7] * b[1] + a[14] * b[4] ;
	c[3] += - a[10] * b[0] - a[6] * b[1] + a[14] * b[5] ;
	c[4] += + a[5] * b[0] + a[9] * b[2] + a[8] * b[3] ;
	c[5] += - a[2] * b[0] + a[7] * b[2] + a[8] * b[4] ;
	c[6] += + a[1] * b[0] - a[6] * b[2] + a[8] * b[5] ;
	c[7] += + a[4] * b[0] + a[7] * b[3] - a[9] * b[4] ;
	c[8] += - a[3] * b[0] - a[6] * b[3] - a[9] * b[5] ;
	c[9] += - a[0] * b[0] - a[6] * b[4] - a[7] * b[5] ;
	c[10] += + a[5] * b[1] - a[13] * b[2] - a[12] * b[3] ;
	c[11] += - a[2] * b[1] - a[11] * b[2] - a[12] * b[4] ;
	c[12] += + a[1] * b[1] + a[10] * b[2] - a[12] * b[5] ;
	c[13] += + a[4] * b[1] - a[11] * b[3] + a[13] * b[4] ;
	c[14] += - a[3] * b[1] + a[10] * b[3] + a[13] * b[5] ;
	c[15] += - a[0] * b[1] + a[10] * b[4] + a[11] * b[5] ;
	c[16] += + a[4] * b[2] + a[2] * b[3] + a[5] * b[4] ;
	c[17] += - a[3] * b[2] - a[1] * b[3] + a[5] * b[5] ;
	c[18] += - a[0] * b[2] - a[1] * b[4] - a[2] * b[5] ;
	c[19] += - a[0] * b[3] + a[3] * b[4] + a[4] * b[5] ;
}

void i2gai_pp_03_06_03_m0(const double *a, const double *b, double *c) {
	c[0] += - a[0] * b[18] ;
	c[1] += + a[0] * b[19] ;
	c[2] += + a[0] * b[17] ;
	c[3] += - a[0] * b[16] ;
	c[4] += - a[0] * b[9] ;
	c[5] += + a[0] * b[6] ;
	c[6] += - a[0] * b[5] ;
	c[7] += - a[0] * b[8] ;
	c[8] += + a[0] * b[7] ;
	c[9] += + a[0] * b[4] ;
	c[10] += + a[0] * b[15] ;
	c[11] += - a[0] * b[12] ;
	c[12] += + a[0] * b[11] ;
	c[13] += + a[0] * b[14] ;
	c[14] += - a[0] * b[13] ;
	c[15] += - a[0] * b[10] ;
	c[16] += + a[0] * b[3] ;
	c[17] += - a[0] * b[2] ;
	c[18] += + a[0] * b[0] ;
	c[19] += - a[0] * b[1] ;
}

void i2gai_pp_03_05_04_m0(const double *a, const double *b, double *c) {
	c[0] += + a[5] * b[10] - a[4] * b[11] + a[2] * b[14] ;
	c[1] += - a[5] * b[12] + a[4] * b[13] - a[3] * b[14] ;
	c[2] += - a[5] * b[9] + a[3] * b[11] - a[2] * b[13] ;
	c[3] += + a[4] * b[9] - a[3] * b[10] + a[2] * b[12] ;
	c[4] += + a[5] * b[3] - a[4] * b[4] + a[0] * b[14] ;
	c[5] += - a[5] * b[1] + a[2] * b[4] - a[0] * b[11] ;
	c[6] += + a[4] * b[1] - a[2] * b[3] + a[0] * b[10] ;
	c[7] += + a[5] * b[2] - a[3] * b[4] + a[0] * b[13] ;
	c[8] += - a[4] * b[2] + a[3] * b[3] - a[0] * b[12] ;
	c[9] += - a[3] * b[1] + a[2] * b[2] - a[0] * b[9] ;
	c[10] += - a[5] * b[7] + a[4] * b[8] - a[1] * b[14] ;
	c[11] += + a[5] * b[5] - a[2] * b[8] + a[1] * b[11] ;
	c[12] += - a[4] * b[5] + a[2] * b[7] - a[1] * b[10] ;
	c[13] += - a[5] * b[6] + a[3] * b[8] - a[1] * b[13] ;
	c[14] += + a[4] * b[6] - a[3] * b[7] + a[1] * b[12] ;
	c[15] += + a[3] * b[5] - a[2] * b[6] + a[1] * b[9] ;
	c[16] += - a[5] * b[0] + a[1] * b[4] - a[0] * b[8] ;
	c[17] += + a[4] * b[0] - a[1] * b[3] + a[0] * b[7] ;
	c[18] += - a[2] * b[0] + a[1] * b[1] - a[0] * b[5] ;
	c[19] += + a[3] * b[0] - a[1] * b[2] + a[0] * b[6] ;
}

void i2gai_pp_03_04_05_m0(const double *a, const double *b, double *c) {
	c[0] += - a[14] * b[2] + a[11] * b[4] - a[10] * b[5] ;
	c[1] += + a[14] * b[3] - a[13] * b[4] + a[12] * b[5] ;
	c[2] += + a[13] * b[2] - a[11] * b[3] + a[9] * b[5] ;
	c[3] += - a[12] * b[2] + a[10] * b[3] - a[9] * b[4] ;
	c[4] += - a[14] * b[0] + a[4] * b[4] - a[3] * b[5] ;
	c[5] += + a[11] * b[0] - a[4] * b[2] + a[1] * b[5] ;
	c[6] += - a[10] * b[0] + a[3] * b[2] - a[1] * b[4] ;
	c[7] += - a[13] * b[0] + a[4] * b[3] - a[2] * b[5] ;
	c[8] += + a[12] * b[0] - a[3] * b[3] + a[2] * b[4] ;
	c[9] += + a[9] * b[0] - a[2] * b[2] + a[1] * b[3] ;
	c[10] += + a[14] * b[1] - a[8] * b[4] + a[7] * b[5] ;
	c[11] += - a[11] * b[1] + a[8] * b[2] - a[5] * b[5] ;
	c[12] += + a[10] * b[1] - a[7] * b[2] + a[5] * b[4] ;
	c[13] += + a[13] * b[1] - a[8] * b[3] + a[6] * b[5] ;
	c[14] += - a[12] * b[1] + a[7] * b[3] - a[6] * b[4] ;
	c[15] += - a[9] * b[1] + a[6] * b[2] - a[5] * b[3] ;
	c[16] += + a[8] * b[0] - a[4] * b[1] + a[0] * b[5] ;
	c[17] += - a[7] * b[0] + a[3] * b[1] - a[0] * b[4] ;
	c[18] += + a[5] * b[0] - a[1] * b[1] + a[0] * b[2] ;
	c[19] += - a[6] * b[0] + a[2] * b[1] - a[0] * b[3] ;
}

void i2gai_pp_03_03_06_m0(const double *a, const double *b, double *c) {
	c[0] += + a[18] * b[0] ;
	c[1] += - a[19] * b[0] ;
	c[2] += - a[17] * b[0] ;
	c[3] += + a[16] * b[0] ;
	c[4] += + a[9] * b[0] ;
	c[5] += - a[6] * b[0] ;
	c[6] += + a[5] * b[0] ;
	c[7] += + a[8] * b[0] ;
	c[8] += - a[7] * b[0] ;
	c[9] += - a[4] * b[0] ;
	c[10] += - a[15] * b[0] ;
	c[11] += + a[12] * b[0] ;
	c[12] += - a[11] * b[0] ;
	c[13] += - a[14] * b[0] ;
	c[14] += + a[13] * b[0] ;
	c[15] += + a[10] * b[0] ;
	c[16] += - a[3] * b[0] ;
	c[17] += + a[2] * b[0] ;
	c[18] += - a[0] * b[0] ;
	c[19] += + a[1] * b[0] ;
}

void i2gai_pp_04_04_00_m0(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[0] ;
	c[1] += + a[1] * b[0] ;
	c[2] += + a[2] * b[0] ;
	c[3] += + a[3] * b[0] ;
	c[4] += + a[4] * b[0] ;
	c[5] += + a[5] * b[0] ;
	c[6] += + a[6] * b[0] ;
	c[7] += + a[7] * b[0] ;
	c[8] += + a[8] * b[0] ;
	c[9] += + a[9] * b[0] ;
	c[10] += + a[10] * b[0] ;
	c[11] += + a[11] * b[0] ;
	c[12] += + a[12] * b[0] ;
	c[13] += + a[13] * b[0] ;
	c[14] += + a[14] * b[0] ;
}

void i2gai_pp_04_03_01_m0(const double *a, const double *b, double *c) {
	c[0] += - a[3] * b[0] + a[2] * b[1] - a[1] * b[2] + a[0] * b[3] ;
	c[1] += - a[6] * b[0] + a[5] * b[1] - a[4] * b[2] + a[0] * b[4] ;
	c[2] += - a[8] * b[0] + a[7] * b[1] - a[4] * b[3] + a[1] * b[4] ;
	c[3] += - a[9] * b[0] + a[7] * b[2] - a[5] * b[3] + a[2] * b[4] ;
	c[4] += - a[9] * b[1] + a[8] * b[2] - a[6] * b[3] + a[3] * b[4] ;
	c[5] += - a[12] * b[0] + a[11] * b[1] - a[10] * b[2] + a[0] * b[5] ;
	c[6] += - a[14] * b[0] + a[13] * b[1] - a[10] * b[3] + a[1] * b[5] ;
	c[7] += - a[15] * b[0] + a[13] * b[2] - a[11] * b[3] + a[2] * b[5] ;
	c[8] += - a[15] * b[1] + a[14] * b[2] - a[12] * b[3] + a[3] * b[5] ;
	c[9] += - a[17] * b[0] + a[16] * b[1] - a[10] * b[4] + a[4] * b[5] ;
	c[10] += - a[18] * b[0] + a[16] * b[2] - a[11] * b[4] + a[5] * b[5] ;
	c[11] += - a[18] * b[1] + a[17] * b[2] - a[12] * b[4] + a[6] * b[5] ;
	c[12] += - a[19] * b[0] + a[16] * b[3] - a[13] * b[4] + a[7] * b[5] ;
	c[13] += - a[19] * b[1] + a[17] * b[3] - a[14] * b[4] + a[8] * b[5] ;
	c[14] += - a[19] * b[2] + a[18] * b[3] - a[15] * b[4] + a[9] * b[5] ;
}

void i2gai_pp_04_02_02_m0(const double *a, const double *b, double *c) {
	c[0] += + a[5] * b[0] - a[4] * b[1] + a[3] * b[2] + a[2] * b[3] - a[1] * b[4] + a[0] * b[5] ;
	c[1] += + a[8] * b[0] - a[7] * b[1] + a[6] * b[2] + a[2] * b[6] - a[1] * b[7] + a[0] * b[8] ;
	c[2] += + a[9] * b[0] - a[7] * b[3] + a[6] * b[4] + a[4] * b[6] - a[3] * b[7] + a[0] * b[9] ;
	c[3] += + a[9] * b[1] - a[8] * b[3] + a[6] * b[5] + a[5] * b[6] - a[3] * b[8] + a[1] * b[9] ;
	c[4] += + a[9] * b[2] - a[8] * b[4] + a[7] * b[5] + a[5] * b[7] - a[4] * b[8] + a[2] * b[9] ;
	c[5] += + a[12] * b[0] - a[11] * b[1] + a[10] * b[2] + a[2] * b[10] - a[1] * b[11] + a[0] * b[12] ;
	c[6] += + a[13] * b[0] - a[11] * b[3] + a[10] * b[4] + a[4] * b[10] - a[3] * b[11] + a[0] * b[13] ;
	c[7] += + a[13] * b[1] - a[12] * b[3] + a[10] * b[5] + a[5] * b[10] - a[3] * b[12] + a[1] * b[13] ;
	c[8] += + a[13] * b[2] - a[12] * b[4] + a[11] * b[5] + a[5] * b[11] - a[4] * b[12] + a[2] * b[13] ;
	c[9] += + a[14] * b[0] - a[11] * b[6] + a[10] * b[7] + a[7] * b[10] - a[6] * b[11] + a[0] * b[14] ;
	c[10] += + a[14] * b[1] - a[12] * b[6] + a[10] * b[8] + a[8] * b[10] - a[6] * b[12] + a[1] * b[14] ;
	c[11] += + a[14] * b[2] - a[12] * b[7] + a[11] * b[8] + a[8] * b[11] - a[7] * b[12] + a[2] * b[14] ;
	c[12] += + a[14] * b[3] - a[13] * b[6] + a[10] * b[9] + a[9] * b[10] - a[6] * b[13] + a[3] * b[14] ;
	c[13] += + a[14] * b[4] - a[13] * b[7] + a[11] * b[9] + a[9] * b[11] - a[7] * b[13] + a[4] * b[14] ;
	c[14] += + a[14] * b[5] - a[13] * b[8] + a[12] * b[9] + a[9] * b[12] - a[8] * b[13] + a[5] * b[14] ;
}

void i2gai_pp_04_01_03_m0(const double *a, const double *b, double *c) {
	c[0] += - a[3] * b[0] + a[2] * b[1] - a[1] * b[2] + a[0] * b[3] ;
	c[1] += - a[4] * b[0] + a[2] * b[4] - a[1] * b[5] + a[0] * b[6] ;
	c[2] += - a[4] * b[1] + a[3] * b[4] - a[1] * b[7] + a[0] * b[8] ;
	c[3] += - a[4] * b[2] + a[3] * b[5] - a[2] * b[7] + a[0] * b[9] ;
	c[4] += - a[4] * b[3] + a[3] * b[6] - a[2] * b[8] + a[1] * b[9] ;
	c[5] += - a[5] * b[0] + a[2] * b[10] - a[1] * b[11] + a[0] * b[12] ;
	c[6] += - a[5] * b[1] + a[3] * b[10] - a[1] * b[13] + a[0] * b[14] ;
	c[7] += - a[5] * b[2] + a[3] * b[11] - a[2] * b[13] + a[0] * b[15] ;
	c[8] += - a[5] * b[3] + a[3] * b[12] - a[2] * b[14] + a[1] * b[15] ;
	c[9] += - a[5] * b[4] + a[4] * b[10] - a[1] * b[16] + a[0] * b[17] ;
	c[10] += - a[5] * b[5] + a[4] * b[11] - a[2] * b[16] + a[0] * b[18] ;
	c[11] += - a[5] * b[6] + a[4] * b[12] - a[2] * b[17] + a[1] * b[18] ;
	c[12] += - a[5] * b[7] + a[4] * b[13] - a[3] * b[16] + a[0] * b[19] ;
	c[13] += - a[5] * b[8] + a[4] * b[14] - a[3] * b[17] + a[1] * b[19] ;
	c[14] += - a[5] * b[9] + a[4] * b[15] - a[3] * b[18] + a[2] * b[19] ;
}

void i2gai_pp_04_00_04_m0(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[0] ;
	c[1] += + a[0] * b[1] ;
	c[2] += + a[0] * b[2] ;
	c[3] += + a[0] * b[3] ;
	c[4] += + a[0] * b[4] ;
	c[5] += + a[0] * b[5] ;
	c[6] += + a[0] * b[6] ;
	c[7] += + a[0] * b[7] ;
	c[8] += + a[0] * b[8] ;
	c[9] += + a[0] * b[9] ;
	c[10] += + a[0] * b[10] ;
	c[11] += + a[0] * b[11] ;
	c[12] += + a[0] * b[12] ;
	c[13] += + a[0] * b[13] ;
	c[14] += + a[0] * b[14] ;
}

void i2gai_pp_04_05_01_m0(const double *a, const double *b, double *c) {
	c[0] += - a[1] * b[4] - a[0] * b[5] ;
	c[1] += + a[0] * b[2] - a[2] * b[4] ;
	c[2] += - a[0] * b[3] - a[3] * b[4] ;
	c[3] += - a[0] * b[1] - a[4] * b[4] ;
	c[4] += + a[0] * b[0] - a[5] * b[4] ;
	c[5] += + a[1] * b[2] + a[2] * b[5] ;
	c[6] += - a[1] * b[3] + a[3] * b[5] ;
	c[7] += - a[1] * b[1] + a[4] * b[5] ;
	c[8] += + a[1] * b[0] + a[5] * b[5] ;
	c[9] += - a[3] * b[2] - a[2] * b[3] ;
	c[10] += - a[2] * b[1] - a[4] * b[2] ;
	c[11] += + a[2] * b[0] - a[5] * b[2] ;
	c[12] += - a[3] * b[1] + a[4] * b[3] ;
	c[13] += + a[3] * b[0] + a[5] * b[3] ;
	c[14] += + a[4] * b[0] + a[5] * b[1] ;
}

void i2gai_pp_04_04_02_m0(const double *a, const double *b, double *c) {
	c[0] += - a[8] * b[6] + a[7] * b[7] - a[6] * b[8] + a[5] * b[9] - a[4] * b[10] + a[3] * b[11] - a[2] * b[12] + a[1] * b[13] ;
	c[1] += + a[4] * b[1] - a[3] * b[2] + a[1] * b[5] - a[11] * b[6] + a[10] * b[7] - a[0] * b[8] - a[9] * b[8] + a[1] * b[14] ;
	c[2] += - a[4] * b[3] + a[3] * b[4] - a[2] * b[5] - a[13] * b[6] + a[12] * b[7] + a[0] * b[9] - a[9] * b[9] + a[2] * b[14] ;
	c[3] += - a[4] * b[0] + a[2] * b[2] - a[1] * b[4] - a[14] * b[6] + a[0] * b[7] + a[12] * b[8] - a[10] * b[9] + a[3] * b[14] ;
	c[4] += + a[3] * b[0] - a[2] * b[1] + a[1] * b[3] - a[0] * b[6] - a[14] * b[7] + a[13] * b[8] - a[11] * b[9] + a[4] * b[14] ;
	c[5] += + a[8] * b[1] - a[7] * b[2] + a[5] * b[5] + a[11] * b[10] - a[10] * b[11] - a[0] * b[12] + a[9] * b[12] - a[5] * b[14] ;
	c[6] += - a[8] * b[3] + a[7] * b[4] - a[6] * b[5] + a[13] * b[10] - a[12] * b[11] + a[0] * b[13] + a[9] * b[13] - a[6] * b[14] ;
	c[7] += - a[8] * b[0] + a[6] * b[2] - a[5] * b[4] + a[14] * b[10] + a[0] * b[11] - a[12] * b[12] + a[10] * b[13] - a[7] * b[14] ;
	c[8] += + a[7] * b[0] - a[6] * b[1] + a[5] * b[3] - a[0] * b[10] + a[14] * b[11] - a[13] * b[12] + a[11] * b[13] - a[8] * b[14] ;
	c[9] += - a[13] * b[1] + a[12] * b[2] - a[11] * b[3] + a[10] * b[4] - a[6] * b[8] - a[5] * b[9] + a[2] * b[12] + a[1] * b[13] ;
	c[10] += - a[11] * b[0] - a[14] * b[1] + a[9] * b[2] + a[10] * b[5] - a[5] * b[7] - a[7] * b[8] + a[1] * b[11] + a[3] * b[12] ;
	c[11] += + a[10] * b[0] - a[9] * b[1] - a[14] * b[2] + a[11] * b[5] + a[5] * b[6] - a[8] * b[8] - a[1] * b[10] + a[4] * b[12] ;
	c[12] += - a[13] * b[0] + a[14] * b[3] + a[9] * b[4] - a[12] * b[5] - a[6] * b[7] + a[7] * b[9] + a[2] * b[11] - a[3] * b[13] ;
	c[13] += + a[12] * b[0] - a[9] * b[3] + a[14] * b[4] - a[13] * b[5] + a[6] * b[6] + a[8] * b[9] - a[2] * b[10] - a[4] * b[13] ;
	c[14] += + a[12] * b[1] + a[13] * b[2] - a[10] * b[3] - a[11] * b[4] + a[7] * b[6] + a[8] * b[7] - a[3] * b[10] - a[4] * b[11] ;
}

void i2gai_pp_04_03_03_m0(const double *a, const double *b, double *c) {
	c[0] += - a[15] * b[4] + a[14] * b[5] - a[13] * b[6] - a[12] * b[7] + a[11] * b[8] - a[10] * b[9] - a[9] * b[10] + a[8] * b[11] - a[7] * b[12] - a[6] * b[13] + a[5] * b[14] - a[4] * b[15] ;
	c[1] += + a[9] * b[0] - a[6] * b[2] + a[5] * b[3] - a[18] * b[4] + a[3] * b[5] + a[17] * b[5] - a[2] * b[6] - a[16] * b[6] + a[0] * b[9] - a[6] * b[16] + a[5] * b[17] - a[4] * b[18] ;
	c[2] += - a[9] * b[1] + a[8] * b[2] - a[7] * b[3] - a[19] * b[4] - a[3] * b[7] + a[17] * b[7] + a[2] * b[8] - a[16] * b[8] - a[1] * b[9] - a[8] * b[16] + a[7] * b[17] - a[4] * b[19] ;
	c[3] += - a[8] * b[0] + a[6] * b[1] - a[4] * b[3] - a[3] * b[4] - a[19] * b[5] + a[1] * b[6] + a[18] * b[7] - a[0] * b[8] - a[16] * b[9] - a[9] * b[16] + a[7] * b[18] - a[5] * b[19] ;
	c[4] += + a[7] * b[0] - a[5] * b[1] + a[4] * b[2] + a[2] * b[4] - a[1] * b[5] - a[19] * b[6] + a[0] * b[7] + a[18] * b[8] - a[17] * b[9] - a[9] * b[17] + a[8] * b[18] - a[6] * b[19] ;
	c[5] += + a[15] * b[0] - a[12] * b[2] + a[11] * b[3] + a[18] * b[10] + a[3] * b[11] - a[17] * b[11] - a[2] * b[12] + a[16] * b[12] + a[0] * b[15] + a[12] * b[16] - a[11] * b[17] + a[10] * b[18] ;
	c[6] += - a[15] * b[1] + a[14] * b[2] - a[13] * b[3] + a[19] * b[10] - a[3] * b[13] - a[17] * b[13] + a[2] * b[14] + a[16] * b[14] - a[1] * b[15] + a[14] * b[16] - a[13] * b[17] + a[10] * b[19] ;
	c[7] += - a[14] * b[0] + a[12] * b[1] - a[10] * b[3] - a[3] * b[10] + a[19] * b[11] + a[1] * b[12] - a[18] * b[13] - a[0] * b[14] + a[16] * b[15] + a[15] * b[16] - a[13] * b[18] + a[11] * b[19] ;
	c[8] += + a[13] * b[0] - a[11] * b[1] + a[10] * b[2] + a[2] * b[10] - a[1] * b[11] + a[19] * b[12] + a[0] * b[13] - a[18] * b[14] + a[17] * b[15] + a[15] * b[17] - a[14] * b[18] + a[12] * b[19] ;
	c[9] += - a[19] * b[0] - a[18] * b[1] + a[14] * b[5] - a[13] * b[6] + a[12] * b[7] - a[11] * b[8] - a[8] * b[11] + a[7] * b[12] - a[6] * b[13] + a[5] * b[14] - a[1] * b[18] - a[0] * b[19] ;
	c[10] += - a[17] * b[0] - a[18] * b[2] + a[12] * b[4] + a[15] * b[5] - a[10] * b[6] - a[11] * b[9] - a[6] * b[10] - a[9] * b[11] + a[4] * b[12] + a[5] * b[15] - a[0] * b[17] - a[2] * b[18] ;
	c[11] += + a[16] * b[0] - a[18] * b[3] - a[11] * b[4] + a[10] * b[5] + a[15] * b[6] - a[12] * b[9] + a[5] * b[10] - a[4] * b[11] - a[9] * b[12] + a[6] * b[15] + a[0] * b[16] - a[3] * b[18] ;
	c[12] += - a[17] * b[1] + a[19] * b[2] + a[14] * b[4] - a[15] * b[7] - a[10] * b[8] + a[13] * b[9] - a[8] * b[10] + a[9] * b[13] + a[4] * b[14] - a[7] * b[15] - a[1] * b[17] + a[2] * b[19] ;
	c[13] += + a[16] * b[1] + a[19] * b[3] - a[13] * b[4] + a[10] * b[7] - a[15] * b[8] + a[14] * b[9] + a[7] * b[10] - a[4] * b[13] + a[9] * b[14] - a[8] * b[15] + a[1] * b[16] + a[3] * b[19] ;
	c[14] += + a[16] * b[2] + a[17] * b[3] - a[13] * b[5] - a[14] * b[6] + a[11] * b[7] + a[12] * b[8] + a[7] * b[11] + a[8] * b[12] - a[5] * b[13] - a[6] * b[14] + a[2] * b[16] + a[3] * b[17] ;
}

void i2gai_pp_04_02_04_m0(const double *a, const double *b, double *c) {
	c[0] += - a[13] * b[1] + a[12] * b[2] - a[11] * b[3] + a[10] * b[4] - a[9] * b[5] + a[8] * b[6] - a[7] * b[7] + a[6] * b[8] ;
	c[1] += + a[8] * b[0] - a[5] * b[1] - a[14] * b[1] + a[2] * b[3] - a[1] * b[4] + a[8] * b[9] - a[7] * b[10] + a[6] * b[11] ;
	c[2] += - a[9] * b[0] + a[5] * b[2] - a[14] * b[2] - a[4] * b[3] + a[3] * b[4] + a[9] * b[9] - a[7] * b[12] + a[6] * b[13] ;
	c[3] += - a[7] * b[0] + a[4] * b[1] - a[2] * b[2] - a[14] * b[3] + a[0] * b[4] + a[9] * b[10] - a[8] * b[12] + a[6] * b[14] ;
	c[4] += + a[6] * b[0] - a[3] * b[1] + a[1] * b[2] - a[0] * b[3] - a[14] * b[4] + a[9] * b[11] - a[8] * b[13] + a[7] * b[14] ;
	c[5] += + a[12] * b[0] - a[5] * b[5] + a[14] * b[5] + a[2] * b[7] - a[1] * b[8] - a[12] * b[9] + a[11] * b[10] - a[10] * b[11] ;
	c[6] += - a[13] * b[0] + a[5] * b[6] + a[14] * b[6] - a[4] * b[7] + a[3] * b[8] - a[13] * b[9] + a[11] * b[12] - a[10] * b[13] ;
	c[7] += - a[11] * b[0] + a[4] * b[5] - a[2] * b[6] + a[14] * b[7] + a[0] * b[8] - a[13] * b[10] + a[12] * b[12] - a[10] * b[14] ;
	c[8] += + a[10] * b[0] - a[3] * b[5] + a[1] * b[6] - a[0] * b[7] + a[14] * b[8] - a[13] * b[11] + a[12] * b[13] - a[11] * b[14] ;
	c[9] += - a[13] * b[1] - a[12] * b[2] + a[9] * b[5] + a[8] * b[6] - a[4] * b[10] + a[3] * b[11] - a[2] * b[12] + a[1] * b[13] ;
	c[10] += - a[11] * b[1] - a[12] * b[3] + a[7] * b[5] + a[8] * b[7] - a[2] * b[9] - a[5] * b[10] + a[0] * b[11] + a[1] * b[14] ;
	c[11] += + a[10] * b[1] - a[12] * b[4] - a[6] * b[5] + a[8] * b[8] + a[1] * b[9] - a[0] * b[10] - a[5] * b[11] + a[2] * b[14] ;
	c[12] += - a[11] * b[2] + a[13] * b[3] + a[7] * b[6] - a[9] * b[7] - a[4] * b[9] + a[5] * b[12] + a[0] * b[13] - a[3] * b[14] ;
	c[13] += + a[10] * b[2] + a[13] * b[4] - a[6] * b[6] - a[9] * b[8] + a[3] * b[9] - a[0] * b[12] + a[5] * b[13] - a[4] * b[14] ;
	c[14] += + a[10] * b[3] + a[11] * b[4] - a[6] * b[7] - a[7] * b[8] + a[3] * b[10] + a[4] * b[11] - a[1] * b[12] - a[2] * b[13] ;
}

void i2gai_pp_04_01_05_m0(const double *a, const double *b, double *c) {
	c[0] += - a[5] * b[0] - a[4] * b[1] ;
	c[1] += + a[2] * b[0] - a[4] * b[2] ;
	c[2] += - a[3] * b[0] - a[4] * b[3] ;
	c[3] += - a[1] * b[0] - a[4] * b[4] ;
	c[4] += + a[0] * b[0] - a[4] * b[5] ;
	c[5] += + a[2] * b[1] + a[5] * b[2] ;
	c[6] += - a[3] * b[1] + a[5] * b[3] ;
	c[7] += - a[1] * b[1] + a[5] * b[4] ;
	c[8] += + a[0] * b[1] + a[5] * b[5] ;
	c[9] += - a[3] * b[2] - a[2] * b[3] ;
	c[10] += - a[1] * b[2] - a[2] * b[4] ;
	c[11] += + a[0] * b[2] - a[2] * b[5] ;
	c[12] += - a[1] * b[3] + a[3] * b[4] ;
	c[13] += + a[0] * b[3] + a[3] * b[5] ;
	c[14] += + a[0] * b[4] + a[1] * b[5] ;
}

void i2gai_pp_04_06_02_m0(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[14] ;
	c[1] += + a[0] * b[8] ;
	c[2] += - a[0] * b[9] ;
	c[3] += - a[0] * b[7] ;
	c[4] += + a[0] * b[6] ;
	c[5] += - a[0] * b[12] ;
	c[6] += + a[0] * b[13] ;
	c[7] += + a[0] * b[11] ;
	c[8] += - a[0] * b[10] ;
	c[9] += + a[0] * b[5] ;
	c[10] += - a[0] * b[2] ;
	c[11] += + a[0] * b[1] ;
	c[12] += + a[0] * b[4] ;
	c[13] += - a[0] * b[3] ;
	c[14] += - a[0] * b[0] ;
}

void i2gai_pp_04_05_03_m0(const double *a, const double *b, double *c) {
	c[0] += - a[5] * b[16] + a[4] * b[17] - a[3] * b[18] + a[2] * b[19] ;
	c[1] += - a[5] * b[5] + a[4] * b[6] - a[2] * b[9] + a[0] * b[18] ;
	c[2] += + a[5] * b[7] - a[4] * b[8] + a[3] * b[9] - a[0] * b[19] ;
	c[3] += + a[5] * b[4] - a[3] * b[6] + a[2] * b[8] - a[0] * b[17] ;
	c[4] += - a[4] * b[4] + a[3] * b[5] - a[2] * b[7] + a[0] * b[16] ;
	c[5] += + a[5] * b[11] - a[4] * b[12] + a[2] * b[15] - a[1] * b[18] ;
	c[6] += - a[5] * b[13] + a[4] * b[14] - a[3] * b[15] + a[1] * b[19] ;
	c[7] += - a[5] * b[10] + a[3] * b[12] - a[2] * b[14] + a[1] * b[17] ;
	c[8] += + a[4] * b[10] - a[3] * b[11] + a[2] * b[13] - a[1] * b[16] ;
	c[9] += - a[5] * b[2] + a[4] * b[3] - a[1] * b[9] + a[0] * b[15] ;
	c[10] += + a[5] * b[0] - a[2] * b[3] + a[1] * b[6] - a[0] * b[12] ;
	c[11] += - a[4] * b[0] + a[2] * b[2] - a[1] * b[5] + a[0] * b[11] ;
	c[12] += - a[5] * b[1] + a[3] * b[3] - a[1] * b[8] + a[0] * b[14] ;
	c[13] += + a[4] * b[1] - a[3] * b[2] + a[1] * b[7] - a[0] * b[13] ;
	c[14] += + a[3] * b[0] - a[2] * b[1] + a[1] * b[4] - a[0] * b[10] ;
}

void i2gai_pp_04_04_04_m0(const double *a, const double *b, double *c) {
	c[0] += + a[14] * b[9] - a[13] * b[10] + a[12] * b[11] + a[11] * b[12] - a[10] * b[13] + a[9] * b[14] ;
	c[1] += + a[14] * b[1] - a[11] * b[3] + a[10] * b[4] + a[4] * b[10] - a[3] * b[11] + a[1] * b[14] ;
	c[2] += - a[14] * b[2] + a[13] * b[3] - a[12] * b[4] - a[4] * b[12] + a[3] * b[13] - a[2] * b[14] ;
	c[3] += - a[13] * b[1] + a[11] * b[2] - a[9] * b[4] - a[4] * b[9] + a[2] * b[11] - a[1] * b[13] ;
	c[4] += + a[12] * b[1] - a[10] * b[2] + a[9] * b[3] + a[3] * b[9] - a[2] * b[10] + a[1] * b[12] ;
	c[5] += - a[14] * b[5] + a[11] * b[7] - a[10] * b[8] - a[8] * b[10] + a[7] * b[11] - a[5] * b[14] ;
	c[6] += + a[14] * b[6] - a[13] * b[7] + a[12] * b[8] + a[8] * b[12] - a[7] * b[13] + a[6] * b[14] ;
	c[7] += + a[13] * b[5] - a[11] * b[6] + a[9] * b[8] + a[8] * b[9] - a[6] * b[11] + a[5] * b[13] ;
	c[8] += - a[12] * b[5] + a[10] * b[6] - a[9] * b[7] - a[7] * b[9] + a[6] * b[10] - a[5] * b[12] ;
	c[9] += + a[14] * b[0] - a[8] * b[3] + a[7] * b[4] + a[4] * b[7] - a[3] * b[8] + a[0] * b[14] ;
	c[10] += - a[11] * b[0] + a[8] * b[1] - a[5] * b[4] - a[4] * b[5] + a[1] * b[8] - a[0] * b[11] ;
	c[11] += + a[10] * b[0] - a[7] * b[1] + a[5] * b[3] + a[3] * b[5] - a[1] * b[7] + a[0] * b[10] ;
	c[12] += + a[13] * b[0] - a[8] * b[2] + a[6] * b[4] + a[4] * b[6] - a[2] * b[8] + a[0] * b[13] ;
	c[13] += - a[12] * b[0] + a[7] * b[2] - a[6] * b[3] - a[3] * b[6] + a[2] * b[7] - a[0] * b[12] ;
	c[14] += - a[9] * b[0] + a[6] * b[1] - a[5] * b[2] - a[2] * b[5] + a[1] * b[6] - a[0] * b[9] ;
}

void i2gai_pp_04_03_05_m0(const double *a, const double *b, double *c) {
	c[0] += - a[19] * b[2] + a[18] * b[3] - a[17] * b[4] + a[16] * b[5] ;
	c[1] += - a[18] * b[0] + a[9] * b[2] - a[6] * b[4] + a[5] * b[5] ;
	c[2] += + a[19] * b[0] - a[9] * b[3] + a[8] * b[4] - a[7] * b[5] ;
	c[3] += + a[17] * b[0] - a[8] * b[2] + a[6] * b[3] - a[4] * b[5] ;
	c[4] += - a[16] * b[0] + a[7] * b[2] - a[5] * b[3] + a[4] * b[4] ;
	c[5] += + a[18] * b[1] - a[15] * b[2] + a[12] * b[4] - a[11] * b[5] ;
	c[6] += - a[19] * b[1] + a[15] * b[3] - a[14] * b[4] + a[13] * b[5] ;
	c[7] += - a[17] * b[1] + a[14] * b[2] - a[12] * b[3] + a[10] * b[5] ;
	c[8] += + a[16] * b[1] - a[13] * b[2] + a[11] * b[3] - a[10] * b[4] ;
	c[9] += - a[15] * b[0] + a[9] * b[1] - a[3] * b[4] + a[2] * b[5] ;
	c[10] += + a[12] * b[0] - a[6] * b[1] + a[3] * b[2] - a[0] * b[5] ;
	c[11] += - a[11] * b[0] + a[5] * b[1] - a[2] * b[2] + a[0] * b[4] ;
	c[12] += - a[14] * b[0] + a[8] * b[1] - a[3] * b[3] + a[1] * b[5] ;
	c[13] += + a[13] * b[0] - a[7] * b[1] + a[2] * b[3] - a[1] * b[4] ;
	c[14] += + a[10] * b[0] - a[4] * b[1] + a[1] * b[2] - a[0] * b[3] ;
}

void i2gai_pp_04_02_06_m0(const double *a, const double *b, double *c) {
	c[0] += + a[14] * b[0] ;
	c[1] += + a[8] * b[0] ;
	c[2] += - a[9] * b[0] ;
	c[3] += - a[7] * b[0] ;
	c[4] += + a[6] * b[0] ;
	c[5] += - a[12] * b[0] ;
	c[6] += + a[13] * b[0] ;
	c[7] += + a[11] * b[0] ;
	c[8] += - a[10] * b[0] ;
	c[9] += + a[5] * b[0] ;
	c[10] += - a[2] * b[0] ;
	c[11] += + a[1] * b[0] ;
	c[12] += + a[4] * b[0] ;
	c[13] += - a[3] * b[0] ;
	c[14] += - a[0] * b[0] ;
}

void i2gai_pp_05_05_00_m0(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[0] ;
	c[1] += + a[1] * b[0] ;
	c[2] += + a[2] * b[0] ;
	c[3] += + a[3] * b[0] ;
	c[4] += + a[4] * b[0] ;
	c[5] += + a[5] * b[0] ;
}

void i2gai_pp_05_04_01_m0(const double *a, const double *b, double *c) {
	c[0] += + a[4] * b[0] - a[3] * b[1] + a[2] * b[2] - a[1] * b[3] + a[0] * b[4] ;
	c[1] += + a[8] * b[0] - a[7] * b[1] + a[6] * b[2] - a[5] * b[3] + a[0] * b[5] ;
	c[2] += + a[11] * b[0] - a[10] * b[1] + a[9] * b[2] - a[5] * b[4] + a[1] * b[5] ;
	c[3] += + a[13] * b[0] - a[12] * b[1] + a[9] * b[3] - a[6] * b[4] + a[2] * b[5] ;
	c[4] += + a[14] * b[0] - a[12] * b[2] + a[10] * b[3] - a[7] * b[4] + a[3] * b[5] ;
	c[5] += + a[14] * b[1] - a[13] * b[2] + a[11] * b[3] - a[8] * b[4] + a[4] * b[5] ;
}

void i2gai_pp_05_03_02_m0(const double *a, const double *b, double *c) {
	c[0] += + a[9] * b[0] - a[8] * b[1] + a[7] * b[2] + a[6] * b[3] - a[5] * b[4] + a[4] * b[5] - a[3] * b[6] + a[2] * b[7] - a[1] * b[8] + a[0] * b[9] ;
	c[1] += + a[15] * b[0] - a[14] * b[1] + a[13] * b[2] + a[12] * b[3] - a[11] * b[4] + a[10] * b[5] - a[3] * b[10] + a[2] * b[11] - a[1] * b[12] + a[0] * b[13] ;
	c[2] += + a[18] * b[0] - a[17] * b[1] + a[16] * b[2] + a[12] * b[6] - a[11] * b[7] + a[10] * b[8] - a[6] * b[10] + a[5] * b[11] - a[4] * b[12] + a[0] * b[14] ;
	c[3] += + a[19] * b[0] - a[17] * b[3] + a[16] * b[4] + a[14] * b[6] - a[13] * b[7] + a[10] * b[9] - a[8] * b[10] + a[7] * b[11] - a[4] * b[13] + a[1] * b[14] ;
	c[4] += + a[19] * b[1] - a[18] * b[3] + a[16] * b[5] + a[15] * b[6] - a[13] * b[8] + a[11] * b[9] - a[9] * b[10] + a[7] * b[12] - a[5] * b[13] + a[2] * b[14] ;
	c[5] += + a[19] * b[2] - a[18] * b[4] + a[17] * b[5] + a[15] * b[7] - a[14] * b[8] + a[12] * b[9] - a[9] * b[11] + a[8] * b[12] - a[6] * b[13] + a[3] * b[14] ;
}

void i2gai_pp_05_02_03_m0(const double *a, const double *b, double *c) {
	c[0] += + a[9] * b[0] - a[8] * b[1] + a[7] * b[2] - a[6] * b[3] + a[5] * b[4] - a[4] * b[5] + a[3] * b[6] + a[2] * b[7] - a[1] * b[8] + a[0] * b[9] ;
	c[1] += + a[13] * b[0] - a[12] * b[1] + a[11] * b[2] - a[10] * b[3] + a[5] * b[10] - a[4] * b[11] + a[3] * b[12] + a[2] * b[13] - a[1] * b[14] + a[0] * b[15] ;
	c[2] += + a[14] * b[0] - a[12] * b[4] + a[11] * b[5] - a[10] * b[6] + a[8] * b[10] - a[7] * b[11] + a[6] * b[12] + a[2] * b[16] - a[1] * b[17] + a[0] * b[18] ;
	c[3] += + a[14] * b[1] - a[13] * b[4] + a[11] * b[7] - a[10] * b[8] + a[9] * b[10] - a[7] * b[13] + a[6] * b[14] + a[4] * b[16] - a[3] * b[17] + a[0] * b[19] ;
	c[4] += + a[14] * b[2] - a[13] * b[5] + a[12] * b[7] - a[10] * b[9] + a[9] * b[11] - a[8] * b[13] + a[6] * b[15] + a[5] * b[16] - a[3] * b[18] + a[1] * b[19] ;
	c[5] += + a[14] * b[3] - a[13] * b[6] + a[12] * b[8] - a[11] * b[9] + a[9] * b[12] - a[8] * b[14] + a[7] * b[15] + a[5] * b[17] - a[4] * b[18] + a[2] * b[19] ;
}

void i2gai_pp_05_01_04_m0(const double *a, const double *b, double *c) {
	c[0] += + a[4] * b[0] - a[3] * b[1] + a[2] * b[2] - a[1] * b[3] + a[0] * b[4] ;
	c[1] += + a[5] * b[0] - a[3] * b[5] + a[2] * b[6] - a[1] * b[7] + a[0] * b[8] ;
	c[2] += + a[5] * b[1] - a[4] * b[5] + a[2] * b[9] - a[1] * b[10] + a[0] * b[11] ;
	c[3] += + a[5] * b[2] - a[4] * b[6] + a[3] * b[9] - a[1] * b[12] + a[0] * b[13] ;
	c[4] += + a[5] * b[3] - a[4] * b[7] + a[3] * b[10] - a[2] * b[12] + a[0] * b[14] ;
	c[5] += + a[5] * b[4] - a[4] * b[8] + a[3] * b[11] - a[2] * b[13] + a[1] * b[14] ;
}

void i2gai_pp_05_06_01_m0(const double *a, const double *b, double *c) {
	c[0] += - a[0] * b[4] ;
	c[1] += + a[0] * b[5] ;
	c[2] += - a[0] * b[2] ;
	c[3] += + a[0] * b[3] ;
	c[4] += + a[0] * b[1] ;
	c[5] += - a[0] * b[0] ;
}

void i2gai_pp_05_05_02_m0(const double *a, const double *b, double *c) {
	c[0] += + a[5] * b[6] - a[4] * b[7] + a[3] * b[8] - a[2] * b[9] + a[0] * b[14] ;
	c[1] += - a[5] * b[10] + a[4] * b[11] - a[3] * b[12] + a[2] * b[13] - a[1] * b[14] ;
	c[2] += + a[5] * b[1] - a[4] * b[2] + a[2] * b[5] - a[1] * b[8] + a[0] * b[12] ;
	c[3] += - a[5] * b[3] + a[4] * b[4] - a[3] * b[5] + a[1] * b[9] - a[0] * b[13] ;
	c[4] += - a[5] * b[0] + a[3] * b[2] - a[2] * b[4] + a[1] * b[7] - a[0] * b[11] ;
	c[5] += + a[4] * b[0] - a[3] * b[1] + a[2] * b[3] - a[1] * b[6] + a[0] * b[10] ;
}

void i2gai_pp_05_04_03_m0(const double *a, const double *b, double *c) {
	c[0] += - a[14] * b[4] + a[13] * b[5] - a[12] * b[6] - a[11] * b[7] + a[10] * b[8] - a[9] * b[9] + a[4] * b[16] - a[3] * b[17] + a[2] * b[18] - a[1] * b[19] ;
	c[1] += + a[14] * b[10] - a[13] * b[11] + a[12] * b[12] + a[11] * b[13] - a[10] * b[14] + a[9] * b[15] - a[8] * b[16] + a[7] * b[17] - a[6] * b[18] + a[5] * b[19] ;
	c[2] += - a[14] * b[0] + a[11] * b[2] - a[10] * b[3] - a[8] * b[5] + a[7] * b[6] - a[5] * b[9] + a[4] * b[11] - a[3] * b[12] + a[1] * b[15] - a[0] * b[18] ;
	c[3] += + a[14] * b[1] - a[13] * b[2] + a[12] * b[3] + a[8] * b[7] - a[7] * b[8] + a[6] * b[9] - a[4] * b[13] + a[3] * b[14] - a[2] * b[15] + a[0] * b[19] ;
	c[4] += + a[13] * b[0] - a[11] * b[1] + a[9] * b[3] + a[8] * b[4] - a[6] * b[6] + a[5] * b[8] - a[4] * b[10] + a[2] * b[12] - a[1] * b[14] + a[0] * b[17] ;
	c[5] += - a[12] * b[0] + a[10] * b[1] - a[9] * b[2] - a[7] * b[4] + a[6] * b[5] - a[5] * b[7] + a[3] * b[10] - a[2] * b[11] + a[1] * b[13] - a[0] * b[16] ;
}

void i2gai_pp_05_03_04_m0(const double *a, const double *b, double *c) {
	c[0] += + a[19] * b[1] - a[18] * b[2] + a[17] * b[3] - a[16] * b[4] + a[9] * b[9] - a[8] * b[10] + a[7] * b[11] + a[6] * b[12] - a[5] * b[13] + a[4] * b[14] ;
	c[1] += - a[19] * b[5] + a[18] * b[6] - a[17] * b[7] + a[16] * b[8] - a[15] * b[9] + a[14] * b[10] - a[13] * b[11] - a[12] * b[12] + a[11] * b[13] - a[10] * b[14] ;
	c[2] += + a[18] * b[0] - a[15] * b[1] + a[12] * b[3] - a[11] * b[4] + a[9] * b[5] - a[6] * b[7] + a[5] * b[8] + a[3] * b[10] - a[2] * b[11] + a[0] * b[14] ;
	c[3] += - a[19] * b[0] + a[15] * b[2] - a[14] * b[3] + a[13] * b[4] - a[9] * b[6] + a[8] * b[7] - a[7] * b[8] - a[3] * b[12] + a[2] * b[13] - a[1] * b[14] ;
	c[4] += - a[17] * b[0] + a[14] * b[1] - a[12] * b[2] + a[10] * b[4] - a[8] * b[5] + a[6] * b[6] - a[4] * b[8] - a[3] * b[9] + a[1] * b[11] - a[0] * b[13] ;
	c[5] += + a[16] * b[0] - a[13] * b[1] + a[11] * b[2] - a[10] * b[3] + a[7] * b[5] - a[5] * b[6] + a[4] * b[7] + a[2] * b[9] - a[1] * b[10] + a[0] * b[12] ;
}

void i2gai_pp_05_00_05_m0(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[0] ;
	c[1] += + a[0] * b[1] ;
	c[2] += + a[0] * b[2] ;
	c[3] += + a[0] * b[3] ;
	c[4] += + a[0] * b[4] ;
	c[5] += + a[0] * b[5] ;
}

void i2gai_pp_05_02_05_m0(const double *a, const double *b, double *c) {
	c[0] += - a[14] * b[0] + a[9] * b[2] - a[8] * b[3] + a[7] * b[4] - a[6] * b[5] ;
	c[1] += + a[14] * b[1] - a[13] * b[2] + a[12] * b[3] - a[11] * b[4] + a[10] * b[5] ;
	c[2] += - a[12] * b[0] + a[8] * b[1] - a[5] * b[2] + a[2] * b[4] - a[1] * b[5] ;
	c[3] += + a[13] * b[0] - a[9] * b[1] + a[5] * b[3] - a[4] * b[4] + a[3] * b[5] ;
	c[4] += + a[11] * b[0] - a[7] * b[1] + a[4] * b[2] - a[2] * b[3] + a[0] * b[5] ;
	c[5] += - a[10] * b[0] + a[6] * b[1] - a[3] * b[2] + a[1] * b[3] - a[0] * b[4] ;
}

void i2gai_pp_05_01_06_m0(const double *a, const double *b, double *c) {
	c[0] += + a[4] * b[0] ;
	c[1] += - a[5] * b[0] ;
	c[2] += + a[2] * b[0] ;
	c[3] += - a[3] * b[0] ;
	c[4] += - a[1] * b[0] ;
	c[5] += + a[0] * b[0] ;
}

void i2gai_pp_06_06_00_m0(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[0] ;
}

void i2gai_pp_06_05_01_m0(const double *a, const double *b, double *c) {
	c[0] += - a[5] * b[0] + a[4] * b[1] - a[3] * b[2] + a[2] * b[3] - a[1] * b[4] + a[0] * b[5] ;
}

void i2gai_pp_06_04_02_m0(const double *a, const double *b, double *c) {
	c[0] += + a[14] * b[0] - a[13] * b[1] + a[12] * b[2] + a[11] * b[3] - a[10] * b[4] + a[9] * b[5] - a[8] * b[6] + a[7] * b[7] - a[6] * b[8] + a[5] * b[9] + a[4] * b[10] - a[3] * b[11] + a[2] * b[12] - a[1] * b[13] + a[0] * b[14] ;
}

void i2gai_pp_06_03_03_m0(const double *a, const double *b, double *c) {
	c[0] += - a[19] * b[0] + a[18] * b[1] - a[17] * b[2] + a[16] * b[3] - a[15] * b[4] + a[14] * b[5] - a[13] * b[6] - a[12] * b[7] + a[11] * b[8] - a[10] * b[9] + a[9] * b[10] - a[8] * b[11] + a[7] * b[12] + a[6] * b[13] - a[5] * b[14] + a[4] * b[15] - a[3] * b[16] + a[2] * b[17] - a[1] * b[18] + a[0] * b[19] ;
}

void i2gai_pp_06_02_04_m0(const double *a, const double *b, double *c) {
	c[0] += + a[14] * b[0] - a[13] * b[1] + a[12] * b[2] - a[11] * b[3] + a[10] * b[4] + a[9] * b[5] - a[8] * b[6] + a[7] * b[7] - a[6] * b[8] + a[5] * b[9] - a[4] * b[10] + a[3] * b[11] + a[2] * b[12] - a[1] * b[13] + a[0] * b[14] ;
}

void i2gai_pp_06_01_05_m0(const double *a, const double *b, double *c) {
	c[0] += - a[5] * b[0] + a[4] * b[1] - a[3] * b[2] + a[2] * b[3] - a[1] * b[4] + a[0] * b[5] ;
}

void i2gai_pp_06_00_06_m0(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[0] ;
}

void i2gai_pp_00_00_00_m1(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[0] ;
}

void i2gai_pp_00_01_01_m1(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[0] + a[1] * b[1] + a[2] * b[2] + a[3] * b[3] + a[4] * b[4] + a[5] * b[5] ;
}

void i2gai_pp_00_02_02_m1(const double *a, const double *b, double *c) {
	c[0] += - a[0] * b[0] - a[1] * b[1] - a[2] * b[2] - a[3] * b[3] - a[4] * b[4] - a[5] * b[5] - a[6] * b[6] - a[7] * b[7] - a[8] * b[8] - a[9] * b[9] - a[10] * b[10] - a[11] * b[11] - a[12] * b[12] - a[13] * b[13] - a[14] * b[14] ;
}

void i2gai_pp_00_03_03_m1(const double *a, const double *b, double *c) {
	c[0] += - a[0] * b[0] - a[1] * b[1] - a[2] * b[2] - a[3] * b[3] - a[4] * b[4] - a[5] * b[5] - a[6] * b[6] - a[7] * b[7] - a[8] * b[8] - a[9] * b[9] - a[10] * b[10] - a[11] * b[11] - a[12] * b[12] - a[13] * b[13] - a[14] * b[14] - a[15] * b[15] - a[16] * b[16] - a[17] * b[17] - a[18] * b[18] - a[19] * b[19] ;
}

void i2gai_pp_00_04_04_m1(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[0] + a[1] * b[1] + a[2] * b[2] + a[3] * b[3] + a[4] * b[4] + a[5] * b[5] + a[6] * b[6] + a[7] * b[7] + a[8] * b[8] + a[9] * b[9] + a[10] * b[10] + a[11] * b[11] + a[12] * b[12] + a[13] * b[13] + a[14] * b[14] ;
}

void i2gai_pp_00_05_05_m1(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[0] + a[1] * b[1] + a[2] * b[2] + a[3] * b[3] + a[4] * b[4] + a[5] * b[5] ;
}

void i2gai_pp_00_06_06_m1(const double *a, const double *b, double *c) {
	c[0] += - a[0] * b[0] ;
}

void i2gai_pp_01_01_00_m1(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[0] ;
	c[1] += + a[1] * b[0] ;
	c[2] += + a[2] * b[0] ;
	c[3] += + a[3] * b[0] ;
	c[4] += + a[4] * b[0] ;
	c[5] += + a[5] * b[0] ;
}

void i2gai_pp_01_00_01_m1(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[0] ;
	c[1] += + a[0] * b[1] ;
	c[2] += + a[0] * b[2] ;
	c[3] += + a[0] * b[3] ;
	c[4] += + a[0] * b[4] ;
	c[5] += + a[0] * b[5] ;
}

void i2gai_pp_01_02_01_m1(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[1] + a[1] * b[2] + a[3] * b[3] + a[6] * b[4] + a[10] * b[5] ;
	c[1] += - a[0] * b[0] + a[2] * b[2] + a[4] * b[3] + a[7] * b[4] + a[11] * b[5] ;
	c[2] += - a[1] * b[0] - a[2] * b[1] + a[5] * b[3] + a[8] * b[4] + a[12] * b[5] ;
	c[3] += - a[3] * b[0] - a[4] * b[1] - a[5] * b[2] + a[9] * b[4] + a[13] * b[5] ;
	c[4] += - a[6] * b[0] - a[7] * b[1] - a[8] * b[2] - a[9] * b[3] + a[14] * b[5] ;
	c[5] += - a[10] * b[0] - a[11] * b[1] - a[12] * b[2] - a[13] * b[3] - a[14] * b[4] ;
}

void i2gai_pp_01_01_02_m1(const double *a, const double *b, double *c) {
	c[0] += - a[1] * b[0] - a[2] * b[1] - a[3] * b[3] - a[4] * b[6] - a[5] * b[10] ;
	c[1] += + a[0] * b[0] - a[2] * b[2] - a[3] * b[4] - a[4] * b[7] - a[5] * b[11] ;
	c[2] += + a[0] * b[1] + a[1] * b[2] - a[3] * b[5] - a[4] * b[8] - a[5] * b[12] ;
	c[3] += + a[0] * b[3] + a[1] * b[4] + a[2] * b[5] - a[4] * b[9] - a[5] * b[13] ;
	c[4] += + a[0] * b[6] + a[1] * b[7] + a[2] * b[8] + a[3] * b[9] - a[5] * b[14] ;
	c[5] += + a[0] * b[10] + a[1] * b[11] + a[2] * b[12] + a[3] * b[13] + a[4] * b[14] ;
}

void i2gai_pp_01_03_02_m1(const double *a, const double *b, double *c) {
	c[0] += - a[0] * b[2] - a[1] * b[4] - a[2] * b[5] - a[4] * b[7] - a[5] * b[8] - a[7] * b[9] - a[10] * b[11] - a[11] * b[12] - a[13] * b[13] - a[16] * b[14] ;
	c[1] += + a[0] * b[1] + a[1] * b[3] - a[3] * b[5] + a[4] * b[6] - a[6] * b[8] - a[8] * b[9] + a[10] * b[10] - a[12] * b[12] - a[14] * b[13] - a[17] * b[14] ;
	c[2] += - a[0] * b[0] + a[2] * b[3] + a[3] * b[4] + a[5] * b[6] + a[6] * b[7] - a[9] * b[9] + a[11] * b[10] + a[12] * b[11] - a[15] * b[13] - a[18] * b[14] ;
	c[3] += - a[1] * b[0] - a[2] * b[1] - a[3] * b[2] + a[7] * b[6] + a[8] * b[7] + a[9] * b[8] + a[13] * b[10] + a[14] * b[11] + a[15] * b[12] - a[19] * b[14] ;
	c[4] += - a[4] * b[0] - a[5] * b[1] - a[6] * b[2] - a[7] * b[3] - a[8] * b[4] - a[9] * b[5] + a[16] * b[10] + a[17] * b[11] + a[18] * b[12] + a[19] * b[13] ;
	c[5] += - a[10] * b[0] - a[11] * b[1] - a[12] * b[2] - a[13] * b[3] - a[14] * b[4] - a[15] * b[5] - a[16] * b[6] - a[17] * b[7] - a[18] * b[8] - a[19] * b[9] ;
}

void i2gai_pp_01_02_03_m1(const double *a, const double *b, double *c) {
	c[0] += - a[2] * b[0] - a[4] * b[1] - a[5] * b[2] - a[7] * b[4] - a[8] * b[5] - a[9] * b[7] - a[11] * b[10] - a[12] * b[11] - a[13] * b[13] - a[14] * b[16] ;
	c[1] += + a[1] * b[0] + a[3] * b[1] - a[5] * b[3] + a[6] * b[4] - a[8] * b[6] - a[9] * b[8] + a[10] * b[10] - a[12] * b[12] - a[13] * b[14] - a[14] * b[17] ;
	c[2] += - a[0] * b[0] + a[3] * b[2] + a[4] * b[3] + a[6] * b[5] + a[7] * b[6] - a[9] * b[9] + a[10] * b[11] + a[11] * b[12] - a[13] * b[15] - a[14] * b[18] ;
	c[3] += - a[0] * b[1] - a[1] * b[2] - a[2] * b[3] + a[6] * b[7] + a[7] * b[8] + a[8] * b[9] + a[10] * b[13] + a[11] * b[14] + a[12] * b[15] - a[14] * b[19] ;
	c[4] += - a[0] * b[4] - a[1] * b[5] - a[2] * b[6] - a[3] * b[7] - a[4] * b[8] - a[5] * b[9] + a[10] * b[16] + a[11] * b[17] + a[12] * b[18] + a[13] * b[19] ;
	c[5] += - a[0] * b[10] - a[1] * b[11] - a[2] * b[12] - a[3] * b[13] - a[4] * b[14] - a[5] * b[15] - a[6] * b[16] - a[7] * b[17] - a[8] * b[18] - a[9] * b[19] ;
}

void i2gai_pp_01_04_03_m1(const double *a, const double *b, double *c) {
	c[0] += - a[0] * b[3] - a[1] * b[6] - a[2] * b[8] - a[3] * b[9] - a[5] * b[12] - a[6] * b[14] - a[7] * b[15] - a[9] * b[17] - a[10] * b[18] - a[12] * b[19] ;
	c[1] += + a[0] * b[2] + a[1] * b[5] + a[2] * b[7] - a[4] * b[9] + a[5] * b[11] + a[6] * b[13] - a[8] * b[15] + a[9] * b[16] - a[11] * b[18] - a[13] * b[19] ;
	c[2] += - a[0] * b[1] - a[1] * b[4] + a[3] * b[7] + a[4] * b[8] - a[5] * b[10] + a[7] * b[13] + a[8] * b[14] + a[10] * b[16] + a[11] * b[17] - a[14] * b[19] ;
	c[3] += + a[0] * b[0] - a[2] * b[4] - a[3] * b[5] - a[4] * b[6] - a[6] * b[10] - a[7] * b[11] - a[8] * b[12] + a[12] * b[16] + a[13] * b[17] + a[14] * b[18] ;
	c[4] += + a[1] * b[0] + a[2] * b[1] + a[3] * b[2] + a[4] * b[3] - a[9] * b[10] - a[10] * b[11] - a[11] * b[12] - a[12] * b[13] - a[13] * b[14] - a[14] * b[15] ;
	c[5] += + a[5] * b[0] + a[6] * b[1] + a[7] * b[2] + a[8] * b[3] + a[9] * b[4] + a[10] * b[5] + a[11] * b[6] + a[12] * b[7] + a[13] * b[8] + a[14] * b[9] ;
}

void i2gai_pp_01_03_04_m1(const double *a, const double *b, double *c) {
	c[0] += + a[3] * b[0] + a[6] * b[1] + a[8] * b[2] + a[9] * b[3] + a[12] * b[5] + a[14] * b[6] + a[15] * b[7] + a[17] * b[9] + a[18] * b[10] + a[19] * b[12] ;
	c[1] += - a[2] * b[0] - a[5] * b[1] - a[7] * b[2] + a[9] * b[4] - a[11] * b[5] - a[13] * b[6] + a[15] * b[8] - a[16] * b[9] + a[18] * b[11] + a[19] * b[13] ;
	c[2] += + a[1] * b[0] + a[4] * b[1] - a[7] * b[3] - a[8] * b[4] + a[10] * b[5] - a[13] * b[7] - a[14] * b[8] - a[16] * b[10] - a[17] * b[11] + a[19] * b[14] ;
	c[3] += - a[0] * b[0] + a[4] * b[2] + a[5] * b[3] + a[6] * b[4] + a[10] * b[6] + a[11] * b[7] + a[12] * b[8] - a[16] * b[12] - a[17] * b[13] - a[18] * b[14] ;
	c[4] += - a[0] * b[1] - a[1] * b[2] - a[2] * b[3] - a[3] * b[4] + a[10] * b[9] + a[11] * b[10] + a[12] * b[11] + a[13] * b[12] + a[14] * b[13] + a[15] * b[14] ;
	c[5] += - a[0] * b[5] - a[1] * b[6] - a[2] * b[7] - a[3] * b[8] - a[4] * b[9] - a[5] * b[10] - a[6] * b[11] - a[7] * b[12] - a[8] * b[13] - a[9] * b[14] ;
}

void i2gai_pp_01_05_04_m1(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[4] + a[1] * b[8] + a[2] * b[11] + a[3] * b[13] + a[4] * b[14] ;
	c[1] += - a[0] * b[3] - a[1] * b[7] - a[2] * b[10] - a[3] * b[12] + a[5] * b[14] ;
	c[2] += + a[0] * b[2] + a[1] * b[6] + a[2] * b[9] - a[4] * b[12] - a[5] * b[13] ;
	c[3] += - a[0] * b[1] - a[1] * b[5] + a[3] * b[9] + a[4] * b[10] + a[5] * b[11] ;
	c[4] += + a[0] * b[0] - a[2] * b[5] - a[3] * b[6] - a[4] * b[7] - a[5] * b[8] ;
	c[5] += + a[1] * b[0] + a[2] * b[1] + a[3] * b[2] + a[4] * b[3] + a[5] * b[4] ;
}

void i2gai_pp_01_04_05_m1(const double *a, const double *b, double *c) {
	c[0] += + a[4] * b[0] + a[8] * b[1] + a[11] * b[2] + a[13] * b[3] + a[14] * b[4] ;
	c[1] += - a[3] * b[0] - a[7] * b[1] - a[10] * b[2] - a[12] * b[3] + a[14] * b[5] ;
	c[2] += + a[2] * b[0] + a[6] * b[1] + a[9] * b[2] - a[12] * b[4] - a[13] * b[5] ;
	c[3] += - a[1] * b[0] - a[5] * b[1] + a[9] * b[3] + a[10] * b[4] + a[11] * b[5] ;
	c[4] += + a[0] * b[0] - a[5] * b[2] - a[6] * b[3] - a[7] * b[4] - a[8] * b[5] ;
	c[5] += + a[0] * b[1] + a[1] * b[2] + a[2] * b[3] + a[3] * b[4] + a[4] * b[5] ;
}

void i2gai_pp_01_06_05_m1(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[5] ;
	c[1] += - a[0] * b[4] ;
	c[2] += + a[0] * b[3] ;
	c[3] += - a[0] * b[2] ;
	c[4] += + a[0] * b[1] ;
	c[5] += - a[0] * b[0] ;
}

void i2gai_pp_01_05_06_m1(const double *a, const double *b, double *c) {
	c[0] += - a[5] * b[0] ;
	c[1] += + a[4] * b[0] ;
	c[2] += - a[3] * b[0] ;
	c[3] += + a[2] * b[0] ;
	c[4] += - a[1] * b[0] ;
	c[5] += + a[0] * b[0] ;
}

void i2gai_pp_02_02_00_m1(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[0] ;
	c[1] += + a[1] * b[0] ;
	c[2] += + a[2] * b[0] ;
	c[3] += + a[3] * b[0] ;
	c[4] += + a[4] * b[0] ;
	c[5] += + a[5] * b[0] ;
	c[6] += + a[6] * b[0] ;
	c[7] += + a[7] * b[0] ;
	c[8] += + a[8] * b[0] ;
	c[9] += + a[9] * b[0] ;
	c[10] += + a[10] * b[0] ;
	c[11] += + a[11] * b[0] ;
	c[12] += + a[12] * b[0] ;
	c[13] += + a[13] * b[0] ;
	c[14] += + a[14] * b[0] ;
}

void i2gai_pp_02_01_01_m1(const double *a, const double *b, double *c) {
	c[0] += - a[1] * b[0] + a[0] * b[1] ;
	c[1] += - a[2] * b[0] + a[0] * b[2] ;
	c[2] += - a[2] * b[1] + a[1] * b[2] ;
	c[3] += - a[3] * b[0] + a[0] * b[3] ;
	c[4] += - a[3] * b[1] + a[1] * b[3] ;
	c[5] += - a[3] * b[2] + a[2] * b[3] ;
	c[6] += - a[4] * b[0] + a[0] * b[4] ;
	c[7] += - a[4] * b[1] + a[1] * b[4] ;
	c[8] += - a[4] * b[2] + a[2] * b[4] ;
	c[9] += - a[4] * b[3] + a[3] * b[4] ;
	c[10] += - a[5] * b[0] + a[0] * b[5] ;
	c[11] += - a[5] * b[1] + a[1] * b[5] ;
	c[12] += - a[5] * b[2] + a[2] * b[5] ;
	c[13] += - a[5] * b[3] + a[3] * b[5] ;
	c[14] += - a[5] * b[4] + a[4] * b[5] ;
}

void i2gai_pp_02_00_02_m1(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[0] ;
	c[1] += + a[0] * b[1] ;
	c[2] += + a[0] * b[2] ;
	c[3] += + a[0] * b[3] ;
	c[4] += + a[0] * b[4] ;
	c[5] += + a[0] * b[5] ;
	c[6] += + a[0] * b[6] ;
	c[7] += + a[0] * b[7] ;
	c[8] += + a[0] * b[8] ;
	c[9] += + a[0] * b[9] ;
	c[10] += + a[0] * b[10] ;
	c[11] += + a[0] * b[11] ;
	c[12] += + a[0] * b[12] ;
	c[13] += + a[0] * b[13] ;
	c[14] += + a[0] * b[14] ;
}

void i2gai_pp_02_03_01_m1(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[2] + a[1] * b[3] + a[4] * b[4] + a[10] * b[5] ;
	c[1] += - a[0] * b[1] + a[2] * b[3] + a[5] * b[4] + a[11] * b[5] ;
	c[2] += + a[0] * b[0] + a[3] * b[3] + a[6] * b[4] + a[12] * b[5] ;
	c[3] += - a[1] * b[1] - a[2] * b[2] + a[7] * b[4] + a[13] * b[5] ;
	c[4] += + a[1] * b[0] - a[3] * b[2] + a[8] * b[4] + a[14] * b[5] ;
	c[5] += + a[2] * b[0] + a[3] * b[1] + a[9] * b[4] + a[15] * b[5] ;
	c[6] += - a[4] * b[1] - a[5] * b[2] - a[7] * b[3] + a[16] * b[5] ;
	c[7] += + a[4] * b[0] - a[6] * b[2] - a[8] * b[3] + a[17] * b[5] ;
	c[8] += + a[5] * b[0] + a[6] * b[1] - a[9] * b[3] + a[18] * b[5] ;
	c[9] += + a[7] * b[0] + a[8] * b[1] + a[9] * b[2] + a[19] * b[5] ;
	c[10] += - a[10] * b[1] - a[11] * b[2] - a[13] * b[3] - a[16] * b[4] ;
	c[11] += + a[10] * b[0] - a[12] * b[2] - a[14] * b[3] - a[17] * b[4] ;
	c[12] += + a[11] * b[0] + a[12] * b[1] - a[15] * b[3] - a[18] * b[4] ;
	c[13] += + a[13] * b[0] + a[14] * b[1] + a[15] * b[2] - a[19] * b[4] ;
	c[14] += + a[16] * b[0] + a[17] * b[1] + a[18] * b[2] + a[19] * b[3] ;
}

void i2gai_pp_02_02_02_m1(const double *a, const double *b, double *c) {
	c[0] += + a[2] * b[1] - a[1] * b[2] + a[4] * b[3] - a[3] * b[4] + a[7] * b[6] - a[6] * b[7] + a[11] * b[10] - a[10] * b[11] ;
	c[1] += - a[2] * b[0] + a[0] * b[2] + a[5] * b[3] - a[3] * b[5] + a[8] * b[6] - a[6] * b[8] + a[12] * b[10] - a[10] * b[12] ;
	c[2] += + a[1] * b[0] - a[0] * b[1] + a[5] * b[4] - a[4] * b[5] + a[8] * b[7] - a[7] * b[8] + a[12] * b[11] - a[11] * b[12] ;
	c[3] += - a[4] * b[0] - a[5] * b[1] + a[0] * b[4] + a[1] * b[5] + a[9] * b[6] - a[6] * b[9] + a[13] * b[10] - a[10] * b[13] ;
	c[4] += + a[3] * b[0] - a[5] * b[2] - a[0] * b[3] + a[2] * b[5] + a[9] * b[7] - a[7] * b[9] + a[13] * b[11] - a[11] * b[13] ;
	c[5] += + a[3] * b[1] + a[4] * b[2] - a[1] * b[3] - a[2] * b[4] + a[9] * b[8] - a[8] * b[9] + a[13] * b[12] - a[12] * b[13] ;
	c[6] += - a[7] * b[0] - a[8] * b[1] - a[9] * b[3] + a[0] * b[7] + a[1] * b[8] + a[3] * b[9] + a[14] * b[10] - a[10] * b[14] ;
	c[7] += + a[6] * b[0] - a[8] * b[2] - a[9] * b[4] - a[0] * b[6] + a[2] * b[8] + a[4] * b[9] + a[14] * b[11] - a[11] * b[14] ;
	c[8] += + a[6] * b[1] + a[7] * b[2] - a[9] * b[5] - a[1] * b[6] - a[2] * b[7] + a[5] * b[9] + a[14] * b[12] - a[12] * b[14] ;
	c[9] += + a[6] * b[3] + a[7] * b[4] + a[8] * b[5] - a[3] * b[6] - a[4] * b[7] - a[5] * b[8] + a[14] * b[13] - a[13] * b[14] ;
	c[10] += - a[11] * b[0] - a[12] * b[1] - a[13] * b[3] - a[14] * b[6] + a[0] * b[11] + a[1] * b[12] + a[3] * b[13] + a[6] * b[14] ;
	c[11] += + a[10] * b[0] - a[12] * b[2] - a[13] * b[4] - a[14] * b[7] - a[0] * b[10] + a[2] * b[12] + a[4] * b[13] + a[7] * b[14] ;
	c[12] += + a[10] * b[1] + a[11] * b[2] - a[13] * b[5] - a[14] * b[8] - a[1] * b[10] - a[2] * b[11] + a[5] * b[13] + a[8] * b[14] ;
	c[13] += + a[10] * b[3] + a[11] * b[4] + a[12] * b[5] - a[14] * b[9] - a[3] * b[10] - a[4] * b[11] - a[5] * b[12] + a[9] * b[14] ;
	c[14] += + a[10] * b[6] + a[11] * b[7] + a[12] * b[8] + a[13] * b[9] - a[6] * b[10] - a[7] * b[11] - a[8] * b[12] - a[9] * b[13] ;
}

void i2gai_pp_02_01_03_m1(const double *a, const double *b, double *c) {
	c[0] += + a[2] * b[0] + a[3] * b[1] + a[4] * b[4] + a[5] * b[10] ;
	c[1] += - a[1] * b[0] + a[3] * b[2] + a[4] * b[5] + a[5] * b[11] ;
	c[2] += + a[0] * b[0] + a[3] * b[3] + a[4] * b[6] + a[5] * b[12] ;
	c[3] += - a[1] * b[1] - a[2] * b[2] + a[4] * b[7] + a[5] * b[13] ;
	c[4] += + a[0] * b[1] - a[2] * b[3] + a[4] * b[8] + a[5] * b[14] ;
	c[5] += + a[0] * b[2] + a[1] * b[3] + a[4] * b[9] + a[5] * b[15] ;
	c[6] += - a[1] * b[4] - a[2] * b[5] - a[3] * b[7] + a[5] * b[16] ;
	c[7] += + a[0] * b[4] - a[2] * b[6] - a[3] * b[8] + a[5] * b[17] ;
	c[8] += + a[0] * b[5] + a[1] * b[6] - a[3] * b[9] + a[5] * b[18] ;
	c[9] += + a[0] * b[7] + a[1] * b[8] + a[2] * b[9] + a[5] * b[19] ;
	c[10] += - a[1] * b[10] - a[2] * b[11] - a[3] * b[13] - a[4] * b[16] ;
	c[11] += + a[0] * b[10] - a[2] * b[12] - a[3] * b[14] - a[4] * b[17] ;
	c[12] += + a[0] * b[11] + a[1] * b[12] - a[3] * b[15] - a[4] * b[18] ;
	c[13] += + a[0] * b[13] + a[1] * b[14] + a[2] * b[15] - a[4] * b[19] ;
	c[14] += + a[0] * b[16] + a[1] * b[17] + a[2] * b[18] + a[3] * b[19] ;
}

void i2gai_pp_02_04_02_m1(const double *a, const double *b, double *c) {
	c[0] += - a[0] * b[5] - a[1] * b[8] - a[2] * b[9] - a[5] * b[12] - a[6] * b[13] - a[9] * b[14] ;
	c[1] += + a[0] * b[4] + a[1] * b[7] - a[3] * b[9] + a[5] * b[11] - a[7] * b[13] - a[10] * b[14] ;
	c[2] += - a[0] * b[3] - a[1] * b[6] - a[4] * b[9] - a[5] * b[10] - a[8] * b[13] - a[11] * b[14] ;
	c[3] += - a[0] * b[2] + a[2] * b[7] + a[3] * b[8] + a[6] * b[11] + a[7] * b[12] - a[12] * b[14] ;
	c[4] += + a[0] * b[1] - a[2] * b[6] + a[4] * b[8] - a[6] * b[10] + a[8] * b[12] - a[13] * b[14] ;
	c[5] += - a[0] * b[0] - a[3] * b[6] - a[4] * b[7] - a[7] * b[10] - a[8] * b[11] - a[14] * b[14] ;
	c[6] += - a[1] * b[2] - a[2] * b[4] - a[3] * b[5] + a[9] * b[11] + a[10] * b[12] + a[12] * b[13] ;
	c[7] += + a[1] * b[1] + a[2] * b[3] - a[4] * b[5] - a[9] * b[10] + a[11] * b[12] + a[13] * b[13] ;
	c[8] += - a[1] * b[0] + a[3] * b[3] + a[4] * b[4] - a[10] * b[10] - a[11] * b[11] + a[14] * b[13] ;
	c[9] += - a[2] * b[0] - a[3] * b[1] - a[4] * b[2] - a[12] * b[10] - a[13] * b[11] - a[14] * b[12] ;
	c[10] += - a[5] * b[2] - a[6] * b[4] - a[7] * b[5] - a[9] * b[7] - a[10] * b[8] - a[12] * b[9] ;
	c[11] += + a[5] * b[1] + a[6] * b[3] - a[8] * b[5] + a[9] * b[6] - a[11] * b[8] - a[13] * b[9] ;
	c[12] += - a[5] * b[0] + a[7] * b[3] + a[8] * b[4] + a[10] * b[6] + a[11] * b[7] - a[14] * b[9] ;
	c[13] += - a[6] * b[0] - a[7] * b[1] - a[8] * b[2] + a[12] * b[6] + a[13] * b[7] + a[14] * b[8] ;
	c[14] += - a[9] * b[0] - a[10] * b[1] - a[11] * b[2] - a[12] * b[3] - a[13] * b[4] - a[14] * b[5] ;
}

void i2gai_pp_02_03_03_m1(const double *a, const double *b, double *c) {
	c[0] += + a[3] * b[2] - a[2] * b[3] + a[6] * b[5] - a[5] * b[6] + a[8] * b[7] - a[7] * b[8] + a[12] * b[11] - a[11] * b[12] + a[14] * b[13] - a[13] * b[14] + a[17] * b[16] - a[16] * b[17] ;
	c[1] += - a[3] * b[1] + a[1] * b[3] - a[6] * b[4] + a[4] * b[6] + a[9] * b[7] - a[7] * b[9] - a[12] * b[10] + a[10] * b[12] + a[15] * b[13] - a[13] * b[15] + a[18] * b[16] - a[16] * b[18] ;
	c[2] += + a[2] * b[1] - a[1] * b[2] + a[5] * b[4] - a[4] * b[5] + a[9] * b[8] - a[8] * b[9] + a[11] * b[10] - a[10] * b[11] + a[15] * b[14] - a[14] * b[15] + a[18] * b[17] - a[17] * b[18] ;
	c[3] += + a[3] * b[0] - a[0] * b[3] - a[8] * b[4] - a[9] * b[5] + a[4] * b[8] + a[5] * b[9] - a[14] * b[10] - a[15] * b[11] + a[10] * b[14] + a[11] * b[15] + a[19] * b[16] - a[16] * b[19] ;
	c[4] += - a[2] * b[0] + a[0] * b[2] + a[7] * b[4] - a[9] * b[6] - a[4] * b[7] + a[6] * b[9] + a[13] * b[10] - a[15] * b[12] - a[10] * b[13] + a[12] * b[15] + a[19] * b[17] - a[17] * b[19] ;
	c[5] += + a[1] * b[0] - a[0] * b[1] + a[7] * b[5] + a[8] * b[6] - a[5] * b[7] - a[6] * b[8] + a[13] * b[11] + a[14] * b[12] - a[11] * b[13] - a[12] * b[14] + a[19] * b[18] - a[18] * b[19] ;
	c[6] += + a[6] * b[0] + a[8] * b[1] + a[9] * b[2] - a[0] * b[6] - a[1] * b[8] - a[2] * b[9] - a[17] * b[10] - a[18] * b[11] - a[19] * b[13] + a[10] * b[17] + a[11] * b[18] + a[13] * b[19] ;
	c[7] += - a[5] * b[0] - a[7] * b[1] + a[9] * b[3] + a[0] * b[5] + a[1] * b[7] - a[3] * b[9] + a[16] * b[10] - a[18] * b[12] - a[19] * b[14] - a[10] * b[16] + a[12] * b[18] + a[14] * b[19] ;
	c[8] += + a[4] * b[0] - a[7] * b[2] - a[8] * b[3] - a[0] * b[4] + a[2] * b[7] + a[3] * b[8] + a[16] * b[11] + a[17] * b[12] - a[19] * b[15] - a[11] * b[16] - a[12] * b[17] + a[15] * b[19] ;
	c[9] += + a[4] * b[1] + a[5] * b[2] + a[6] * b[3] - a[1] * b[4] - a[2] * b[5] - a[3] * b[6] + a[16] * b[13] + a[17] * b[14] + a[18] * b[15] - a[13] * b[16] - a[14] * b[17] - a[15] * b[18] ;
	c[10] += + a[12] * b[0] + a[14] * b[1] + a[15] * b[2] + a[17] * b[4] + a[18] * b[5] + a[19] * b[7] - a[0] * b[12] - a[1] * b[14] - a[2] * b[15] - a[4] * b[17] - a[5] * b[18] - a[7] * b[19] ;
	c[11] += - a[11] * b[0] - a[13] * b[1] + a[15] * b[3] - a[16] * b[4] + a[18] * b[6] + a[19] * b[8] + a[0] * b[11] + a[1] * b[13] - a[3] * b[15] + a[4] * b[16] - a[6] * b[18] - a[8] * b[19] ;
	c[12] += + a[10] * b[0] - a[13] * b[2] - a[14] * b[3] - a[16] * b[5] - a[17] * b[6] + a[19] * b[9] - a[0] * b[10] + a[2] * b[13] + a[3] * b[14] + a[5] * b[16] + a[6] * b[17] - a[9] * b[19] ;
	c[13] += + a[10] * b[1] + a[11] * b[2] + a[12] * b[3] - a[16] * b[7] - a[17] * b[8] - a[18] * b[9] - a[1] * b[10] - a[2] * b[11] - a[3] * b[12] + a[7] * b[16] + a[8] * b[17] + a[9] * b[18] ;
	c[14] += + a[10] * b[4] + a[11] * b[5] + a[12] * b[6] + a[13] * b[7] + a[14] * b[8] + a[15] * b[9] - a[4] * b[10] - a[5] * b[11] - a[6] * b[12] - a[7] * b[13] - a[8] * b[14] - a[9] * b[15] ;
}

void i2gai_pp_02_02_04_m1(const double *a, const double *b, double *c) {
	c[0] += - a[5] * b[0] - a[8] * b[1] - a[9] * b[2] - a[12] * b[5] - a[13] * b[6] - a[14] * b[9] ;
	c[1] += + a[4] * b[0] + a[7] * b[1] - a[9] * b[3] + a[11] * b[5] - a[13] * b[7] - a[14] * b[10] ;
	c[2] += - a[3] * b[0] - a[6] * b[1] - a[9] * b[4] - a[10] * b[5] - a[13] * b[8] - a[14] * b[11] ;
	c[3] += - a[2] * b[0] + a[7] * b[2] + a[8] * b[3] + a[11] * b[6] + a[12] * b[7] - a[14] * b[12] ;
	c[4] += + a[1] * b[0] - a[6] * b[2] + a[8] * b[4] - a[10] * b[6] + a[12] * b[8] - a[14] * b[13] ;
	c[5] += - a[0] * b[0] - a[6] * b[3] - a[7] * b[4] - a[10] * b[7] - a[11] * b[8] - a[14] * b[14] ;
	c[6] += - a[2] * b[1] - a[4] * b[2] - a[5] * b[3] + a[11] * b[9] + a[12] * b[10] + a[13] * b[12] ;
	c[7] += + a[1] * b[1] + a[3] * b[2] - a[5] * b[4] - a[10] * b[9] + a[12] * b[11] + a[13] * b[13] ;
	c[8] += - a[0] * b[1] + a[3] * b[3] + a[4] * b[4] - a[10] * b[10] - a[11] * b[11] + a[13] * b[14] ;
	c[9] += - a[0] * b[2] - a[1] * b[3] - a[2] * b[4] - a[10] * b[12] - a[11] * b[13] - a[12] * b[14] ;
	c[10] += - a[2] * b[5] - a[4] * b[6] - a[5] * b[7] - a[7] * b[9] - a[8] * b[10] - a[9] * b[12] ;
	c[11] += + a[1] * b[5] + a[3] * b[6] - a[5] * b[8] + a[6] * b[9] - a[8] * b[11] - a[9] * b[13] ;
	c[12] += - a[0] * b[5] + a[3] * b[7] + a[4] * b[8] + a[6] * b[10] + a[7] * b[11] - a[9] * b[14] ;
	c[13] += - a[0] * b[6] - a[1] * b[7] - a[2] * b[8] + a[6] * b[12] + a[7] * b[13] + a[8] * b[14] ;
	c[14] += - a[0] * b[9] - a[1] * b[10] - a[2] * b[11] - a[3] * b[12] - a[4] * b[13] - a[5] * b[14] ;
}

void i2gai_pp_02_05_03_m1(const double *a, const double *b, double *c) {
	c[0] += - a[0] * b[9] - a[1] * b[15] - a[2] * b[18] - a[3] * b[19] ;
	c[1] += + a[0] * b[8] + a[1] * b[14] + a[2] * b[17] - a[4] * b[19] ;
	c[2] += - a[0] * b[7] - a[1] * b[13] - a[2] * b[16] - a[5] * b[19] ;
	c[3] += - a[0] * b[6] - a[1] * b[12] + a[3] * b[17] + a[4] * b[18] ;
	c[4] += + a[0] * b[5] + a[1] * b[11] - a[3] * b[16] + a[5] * b[18] ;
	c[5] += - a[0] * b[4] - a[1] * b[10] - a[4] * b[16] - a[5] * b[17] ;
	c[6] += + a[0] * b[3] - a[2] * b[12] - a[3] * b[14] - a[4] * b[15] ;
	c[7] += - a[0] * b[2] + a[2] * b[11] + a[3] * b[13] - a[5] * b[15] ;
	c[8] += + a[0] * b[1] - a[2] * b[10] + a[4] * b[13] + a[5] * b[14] ;
	c[9] += - a[0] * b[0] - a[3] * b[10] - a[4] * b[11] - a[5] * b[12] ;
	c[10] += + a[1] * b[3] + a[2] * b[6] + a[3] * b[8] + a[4] * b[9] ;
	c[11] += - a[1] * b[2] - a[2] * b[5] - a[3] * b[7] + a[5] * b[9] ;
	c[12] += + a[1] * b[1] + a[2] * b[4] - a[4] * b[7] - a[5] * b[8] ;
	c[13] += - a[1] * b[0] + a[3] * b[4] + a[4] * b[5] + a[5] * b[6] ;
	c[14] += - a[2] * b[0] - a[3] * b[1] - a[4] * b[2] - a[5] * b[3] ;
}

void i2gai_pp_02_04_04_m1(const double *a, const double *b, double *c) {
	c[0] += - a[4] * b[3] + a[3] * b[4] - a[8] * b[7] + a[7] * b[8] - a[11] * b[10] + a[10] * b[11] - a[13] * b[12] + a[12] * b[13] ;
	c[1] += + a[4] * b[2] - a[2] * b[4] + a[8] * b[6] - a[6] * b[8] + a[11] * b[9] - a[9] * b[11] - a[14] * b[12] + a[12] * b[14] ;
	c[2] += - a[3] * b[2] + a[2] * b[3] - a[7] * b[6] + a[6] * b[7] - a[10] * b[9] + a[9] * b[10] - a[14] * b[13] + a[13] * b[14] ;
	c[3] += - a[4] * b[1] + a[1] * b[4] - a[8] * b[5] + a[5] * b[8] + a[13] * b[9] + a[14] * b[10] - a[9] * b[13] - a[10] * b[14] ;
	c[4] += + a[3] * b[1] - a[1] * b[3] + a[7] * b[5] - a[5] * b[7] - a[12] * b[9] + a[14] * b[11] + a[9] * b[12] - a[11] * b[14] ;
	c[5] += - a[2] * b[1] + a[1] * b[2] - a[6] * b[5] + a[5] * b[6] - a[12] * b[10] - a[13] * b[11] + a[10] * b[12] + a[11] * b[13] ;
	c[6] += + a[4] * b[0] - a[0] * b[4] - a[11] * b[5] - a[13] * b[6] - a[14] * b[7] + a[5] * b[11] + a[6] * b[13] + a[7] * b[14] ;
	c[7] += - a[3] * b[0] + a[0] * b[3] + a[10] * b[5] + a[12] * b[6] - a[14] * b[8] - a[5] * b[10] - a[6] * b[12] + a[8] * b[14] ;
	c[8] += + a[2] * b[0] - a[0] * b[2] - a[9] * b[5] + a[12] * b[7] + a[13] * b[8] + a[5] * b[9] - a[7] * b[12] - a[8] * b[13] ;
	c[9] += - a[1] * b[0] + a[0] * b[1] - a[9] * b[6] - a[10] * b[7] - a[11] * b[8] + a[6] * b[9] + a[7] * b[10] + a[8] * b[11] ;
	c[10] += + a[8] * b[0] + a[11] * b[1] + a[13] * b[2] + a[14] * b[3] - a[0] * b[8] - a[1] * b[11] - a[2] * b[13] - a[3] * b[14] ;
	c[11] += - a[7] * b[0] - a[10] * b[1] - a[12] * b[2] + a[14] * b[4] + a[0] * b[7] + a[1] * b[10] + a[2] * b[12] - a[4] * b[14] ;
	c[12] += + a[6] * b[0] + a[9] * b[1] - a[12] * b[3] - a[13] * b[4] - a[0] * b[6] - a[1] * b[9] + a[3] * b[12] + a[4] * b[13] ;
	c[13] += - a[5] * b[0] + a[9] * b[2] + a[10] * b[3] + a[11] * b[4] + a[0] * b[5] - a[2] * b[9] - a[3] * b[10] - a[4] * b[11] ;
	c[14] += - a[5] * b[1] - a[6] * b[2] - a[7] * b[3] - a[8] * b[4] + a[1] * b[5] + a[2] * b[6] + a[3] * b[7] + a[4] * b[8] ;
}

void i2gai_pp_02_03_05_m1(const double *a, const double *b, double *c) {
	c[0] += - a[9] * b[0] - a[15] * b[1] - a[18] * b[2] - a[19] * b[3] ;
	c[1] += + a[8] * b[0] + a[14] * b[1] + a[17] * b[2] - a[19] * b[4] ;
	c[2] += - a[7] * b[0] - a[13] * b[1] - a[16] * b[2] - a[19] * b[5] ;
	c[3] += - a[6] * b[0] - a[12] * b[1] + a[17] * b[3] + a[18] * b[4] ;
	c[4] += + a[5] * b[0] + a[11] * b[1] - a[16] * b[3] + a[18] * b[5] ;
	c[5] += - a[4] * b[0] - a[10] * b[1] - a[16] * b[4] - a[17] * b[5] ;
	c[6] += + a[3] * b[0] - a[12] * b[2] - a[14] * b[3] - a[15] * b[4] ;
	c[7] += - a[2] * b[0] + a[11] * b[2] + a[13] * b[3] - a[15] * b[5] ;
	c[8] += + a[1] * b[0] - a[10] * b[2] + a[13] * b[4] + a[14] * b[5] ;
	c[9] += - a[0] * b[0] - a[10] * b[3] - a[11] * b[4] - a[12] * b[5] ;
	c[10] += + a[3] * b[1] + a[6] * b[2] + a[8] * b[3] + a[9] * b[4] ;
	c[11] += - a[2] * b[1] - a[5] * b[2] - a[7] * b[3] + a[9] * b[5] ;
	c[12] += + a[1] * b[1] + a[4] * b[2] - a[7] * b[4] - a[8] * b[5] ;
	c[13] += - a[0] * b[1] + a[4] * b[3] + a[5] * b[4] + a[6] * b[5] ;
	c[14] += - a[0] * b[2] - a[1] * b[3] - a[2] * b[4] - a[3] * b[5] ;
}

void i2gai_pp_02_06_04_m1(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[14] ;
	c[1] += - a[0] * b[13] ;
	c[2] += + a[0] * b[12] ;
	c[3] += + a[0] * b[11] ;
	c[4] += - a[0] * b[10] ;
	c[5] += + a[0] * b[9] ;
	c[6] += - a[0] * b[8] ;
	c[7] += + a[0] * b[7] ;
	c[8] += - a[0] * b[6] ;
	c[9] += + a[0] * b[5] ;
	c[10] += + a[0] * b[4] ;
	c[11] += - a[0] * b[3] ;
	c[12] += + a[0] * b[2] ;
	c[13] += - a[0] * b[1] ;
	c[14] += + a[0] * b[0] ;
}

void i2gai_pp_02_05_05_m1(const double *a, const double *b, double *c) {
	c[0] += - a[5] * b[4] + a[4] * b[5] ;
	c[1] += + a[5] * b[3] - a[3] * b[5] ;
	c[2] += - a[4] * b[3] + a[3] * b[4] ;
	c[3] += - a[5] * b[2] + a[2] * b[5] ;
	c[4] += + a[4] * b[2] - a[2] * b[4] ;
	c[5] += - a[3] * b[2] + a[2] * b[3] ;
	c[6] += + a[5] * b[1] - a[1] * b[5] ;
	c[7] += - a[4] * b[1] + a[1] * b[4] ;
	c[8] += + a[3] * b[1] - a[1] * b[3] ;
	c[9] += - a[2] * b[1] + a[1] * b[2] ;
	c[10] += - a[5] * b[0] + a[0] * b[5] ;
	c[11] += + a[4] * b[0] - a[0] * b[4] ;
	c[12] += - a[3] * b[0] + a[0] * b[3] ;
	c[13] += + a[2] * b[0] - a[0] * b[2] ;
	c[14] += - a[1] * b[0] + a[0] * b[1] ;
}

void i2gai_pp_02_04_06_m1(const double *a, const double *b, double *c) {
	c[0] += + a[14] * b[0] ;
	c[1] += - a[13] * b[0] ;
	c[2] += + a[12] * b[0] ;
	c[3] += + a[11] * b[0] ;
	c[4] += - a[10] * b[0] ;
	c[5] += + a[9] * b[0] ;
	c[6] += - a[8] * b[0] ;
	c[7] += + a[7] * b[0] ;
	c[8] += - a[6] * b[0] ;
	c[9] += + a[5] * b[0] ;
	c[10] += + a[4] * b[0] ;
	c[11] += - a[3] * b[0] ;
	c[12] += + a[2] * b[0] ;
	c[13] += - a[1] * b[0] ;
	c[14] += + a[0] * b[0] ;
}

void i2gai_pp_03_03_00_m1(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[0] ;
	c[1] += + a[1] * b[0] ;
	c[2] += + a[2] * b[0] ;
	c[3] += + a[3] * b[0] ;
	c[4] += + a[4] * b[0] ;
	c[5] += + a[5] * b[0] ;
	c[6] += + a[6] * b[0] ;
	c[7] += + a[7] * b[0] ;
	c[8] += + a[8] * b[0] ;
	c[9] += + a[9] * b[0] ;
	c[10] += + a[10] * b[0] ;
	c[11] += + a[11] * b[0] ;
	c[12] += + a[12] * b[0] ;
	c[13] += + a[13] * b[0] ;
	c[14] += + a[14] * b[0] ;
	c[15] += + a[15] * b[0] ;
	c[16] += + a[16] * b[0] ;
	c[17] += + a[17] * b[0] ;
	c[18] += + a[18] * b[0] ;
	c[19] += + a[19] * b[0] ;
}

void i2gai_pp_03_02_01_m1(const double *a, const double *b, double *c) {
	c[0] += + a[2] * b[0] - a[1] * b[1] + a[0] * b[2] ;
	c[1] += + a[4] * b[0] - a[3] * b[1] + a[0] * b[3] ;
	c[2] += + a[5] * b[0] - a[3] * b[2] + a[1] * b[3] ;
	c[3] += + a[5] * b[1] - a[4] * b[2] + a[2] * b[3] ;
	c[4] += + a[7] * b[0] - a[6] * b[1] + a[0] * b[4] ;
	c[5] += + a[8] * b[0] - a[6] * b[2] + a[1] * b[4] ;
	c[6] += + a[8] * b[1] - a[7] * b[2] + a[2] * b[4] ;
	c[7] += + a[9] * b[0] - a[6] * b[3] + a[3] * b[4] ;
	c[8] += + a[9] * b[1] - a[7] * b[3] + a[4] * b[4] ;
	c[9] += + a[9] * b[2] - a[8] * b[3] + a[5] * b[4] ;
	c[10] += + a[11] * b[0] - a[10] * b[1] + a[0] * b[5] ;
	c[11] += + a[12] * b[0] - a[10] * b[2] + a[1] * b[5] ;
	c[12] += + a[12] * b[1] - a[11] * b[2] + a[2] * b[5] ;
	c[13] += + a[13] * b[0] - a[10] * b[3] + a[3] * b[5] ;
	c[14] += + a[13] * b[1] - a[11] * b[3] + a[4] * b[5] ;
	c[15] += + a[13] * b[2] - a[12] * b[3] + a[5] * b[5] ;
	c[16] += + a[14] * b[0] - a[10] * b[4] + a[6] * b[5] ;
	c[17] += + a[14] * b[1] - a[11] * b[4] + a[7] * b[5] ;
	c[18] += + a[14] * b[2] - a[12] * b[4] + a[8] * b[5] ;
	c[19] += + a[14] * b[3] - a[13] * b[4] + a[9] * b[5] ;
}

void i2gai_pp_03_01_02_m1(const double *a, const double *b, double *c) {
	c[0] += + a[2] * b[0] - a[1] * b[1] + a[0] * b[2] ;
	c[1] += + a[3] * b[0] - a[1] * b[3] + a[0] * b[4] ;
	c[2] += + a[3] * b[1] - a[2] * b[3] + a[0] * b[5] ;
	c[3] += + a[3] * b[2] - a[2] * b[4] + a[1] * b[5] ;
	c[4] += + a[4] * b[0] - a[1] * b[6] + a[0] * b[7] ;
	c[5] += + a[4] * b[1] - a[2] * b[6] + a[0] * b[8] ;
	c[6] += + a[4] * b[2] - a[2] * b[7] + a[1] * b[8] ;
	c[7] += + a[4] * b[3] - a[3] * b[6] + a[0] * b[9] ;
	c[8] += + a[4] * b[4] - a[3] * b[7] + a[1] * b[9] ;
	c[9] += + a[4] * b[5] - a[3] * b[8] + a[2] * b[9] ;
	c[10] += + a[5] * b[0] - a[1] * b[10] + a[0] * b[11] ;
	c[11] += + a[5] * b[1] - a[2] * b[10] + a[0] * b[12] ;
	c[12] += + a[5] * b[2] - a[2] * b[11] + a[1] * b[12] ;
	c[13] += + a[5] * b[3] - a[3] * b[10] + a[0] * b[13] ;
	c[14] += + a[5] * b[4] - a[3] * b[11] + a[1] * b[13] ;
	c[15] += + a[5] * b[5] - a[3] * b[12] + a[2] * b[13] ;
	c[16] += + a[5] * b[6] - a[4] * b[10] + a[0] * b[14] ;
	c[17] += + a[5] * b[7] - a[4] * b[11] + a[1] * b[14] ;
	c[18] += + a[5] * b[8] - a[4] * b[12] + a[2] * b[14] ;
	c[19] += + a[5] * b[9] - a[4] * b[13] + a[3] * b[14] ;
}

void i2gai_pp_03_00_03_m1(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[0] ;
	c[1] += + a[0] * b[1] ;
	c[2] += + a[0] * b[2] ;
	c[3] += + a[0] * b[3] ;
	c[4] += + a[0] * b[4] ;
	c[5] += + a[0] * b[5] ;
	c[6] += + a[0] * b[6] ;
	c[7] += + a[0] * b[7] ;
	c[8] += + a[0] * b[8] ;
	c[9] += + a[0] * b[9] ;
	c[10] += + a[0] * b[10] ;
	c[11] += + a[0] * b[11] ;
	c[12] += + a[0] * b[12] ;
	c[13] += + a[0] * b[13] ;
	c[14] += + a[0] * b[14] ;
	c[15] += + a[0] * b[15] ;
	c[16] += + a[0] * b[16] ;
	c[17] += + a[0] * b[17] ;
	c[18] += + a[0] * b[18] ;
	c[19] += + a[0] * b[19] ;
}

void i2gai_pp_03_04_01_m1(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[3] + a[1] * b[4] + a[5] * b[5] ;
	c[1] += - a[0] * b[2] + a[2] * b[4] + a[6] * b[5] ;
	c[2] += + a[0] * b[1] + a[3] * b[4] + a[7] * b[5] ;
	c[3] += - a[0] * b[0] + a[4] * b[4] + a[8] * b[5] ;
	c[4] += - a[1] * b[2] - a[2] * b[3] + a[9] * b[5] ;
	c[5] += + a[1] * b[1] - a[3] * b[3] + a[10] * b[5] ;
	c[6] += - a[1] * b[0] - a[4] * b[3] + a[11] * b[5] ;
	c[7] += + a[2] * b[1] + a[3] * b[2] + a[12] * b[5] ;
	c[8] += - a[2] * b[0] + a[4] * b[2] + a[13] * b[5] ;
	c[9] += - a[3] * b[0] - a[4] * b[1] + a[14] * b[5] ;
	c[10] += - a[5] * b[2] - a[6] * b[3] - a[9] * b[4] ;
	c[11] += + a[5] * b[1] - a[7] * b[3] - a[10] * b[4] ;
	c[12] += - a[5] * b[0] - a[8] * b[3] - a[11] * b[4] ;
	c[13] += + a[6] * b[1] + a[7] * b[2] - a[12] * b[4] ;
	c[14] += - a[6] * b[0] + a[8] * b[2] - a[13] * b[4] ;
	c[15] += - a[7] * b[0] - a[8] * b[1] - a[14] * b[4] ;
	c[16] += + a[9] * b[1] + a[10] * b[2] + a[12] * b[3] ;
	c[17] += - a[9] * b[0] + a[11] * b[2] + a[13] * b[3] ;
	c[18] += - a[10] * b[0] - a[11] * b[1] + a[14] * b[3] ;
	c[19] += - a[12] * b[0] - a[13] * b[1] - a[14] * b[2] ;
}

void i2gai_pp_03_03_02_m1(const double *a, const double *b, double *c) {
	c[0] += - a[3] * b[3] + a[2] * b[4] - a[1] * b[5] - a[6] * b[6] + a[5] * b[7] - a[4] * b[8] - a[12] * b[10] + a[11] * b[11] - a[10] * b[12] ;
	c[1] += + a[3] * b[1] - a[2] * b[2] + a[0] * b[5] - a[8] * b[6] + a[7] * b[7] - a[4] * b[9] - a[14] * b[10] + a[13] * b[11] - a[10] * b[13] ;
	c[2] += - a[3] * b[0] + a[1] * b[2] - a[0] * b[4] - a[9] * b[6] + a[7] * b[8] - a[5] * b[9] - a[15] * b[10] + a[13] * b[12] - a[11] * b[13] ;
	c[3] += + a[2] * b[0] - a[1] * b[1] + a[0] * b[3] - a[9] * b[7] + a[8] * b[8] - a[6] * b[9] - a[15] * b[11] + a[14] * b[12] - a[12] * b[13] ;
	c[4] += + a[6] * b[1] - a[5] * b[2] + a[8] * b[3] - a[7] * b[4] + a[0] * b[8] + a[1] * b[9] - a[17] * b[10] + a[16] * b[11] - a[10] * b[14] ;
	c[5] += - a[6] * b[0] + a[4] * b[2] + a[9] * b[3] - a[7] * b[5] - a[0] * b[7] + a[2] * b[9] - a[18] * b[10] + a[16] * b[12] - a[11] * b[14] ;
	c[6] += + a[5] * b[0] - a[4] * b[1] + a[9] * b[4] - a[8] * b[5] + a[0] * b[6] + a[3] * b[9] - a[18] * b[11] + a[17] * b[12] - a[12] * b[14] ;
	c[7] += - a[8] * b[0] - a[9] * b[1] + a[4] * b[4] + a[5] * b[5] - a[1] * b[7] - a[2] * b[8] - a[19] * b[10] + a[16] * b[13] - a[13] * b[14] ;
	c[8] += + a[7] * b[0] - a[9] * b[2] - a[4] * b[3] + a[6] * b[5] + a[1] * b[6] - a[3] * b[8] - a[19] * b[11] + a[17] * b[13] - a[14] * b[14] ;
	c[9] += + a[7] * b[1] + a[8] * b[2] - a[5] * b[3] - a[6] * b[4] + a[2] * b[6] + a[3] * b[7] - a[19] * b[12] + a[18] * b[13] - a[15] * b[14] ;
	c[10] += + a[12] * b[1] - a[11] * b[2] + a[14] * b[3] - a[13] * b[4] + a[17] * b[6] - a[16] * b[7] + a[0] * b[12] + a[1] * b[13] + a[4] * b[14] ;
	c[11] += - a[12] * b[0] + a[10] * b[2] + a[15] * b[3] - a[13] * b[5] + a[18] * b[6] - a[16] * b[8] - a[0] * b[11] + a[2] * b[13] + a[5] * b[14] ;
	c[12] += + a[11] * b[0] - a[10] * b[1] + a[15] * b[4] - a[14] * b[5] + a[18] * b[7] - a[17] * b[8] + a[0] * b[10] + a[3] * b[13] + a[6] * b[14] ;
	c[13] += - a[14] * b[0] - a[15] * b[1] + a[10] * b[4] + a[11] * b[5] + a[19] * b[6] - a[16] * b[9] - a[1] * b[11] - a[2] * b[12] + a[7] * b[14] ;
	c[14] += + a[13] * b[0] - a[15] * b[2] - a[10] * b[3] + a[12] * b[5] + a[19] * b[7] - a[17] * b[9] + a[1] * b[10] - a[3] * b[12] + a[8] * b[14] ;
	c[15] += + a[13] * b[1] + a[14] * b[2] - a[11] * b[3] - a[12] * b[4] + a[19] * b[8] - a[18] * b[9] + a[2] * b[10] + a[3] * b[11] + a[9] * b[14] ;
	c[16] += - a[17] * b[0] - a[18] * b[1] - a[19] * b[3] + a[10] * b[7] + a[11] * b[8] + a[13] * b[9] - a[4] * b[11] - a[5] * b[12] - a[7] * b[13] ;
	c[17] += + a[16] * b[0] - a[18] * b[2] - a[19] * b[4] - a[10] * b[6] + a[12] * b[8] + a[14] * b[9] + a[4] * b[10] - a[6] * b[12] - a[8] * b[13] ;
	c[18] += + a[16] * b[1] + a[17] * b[2] - a[19] * b[5] - a[11] * b[6] - a[12] * b[7] + a[15] * b[9] + a[5] * b[10] + a[6] * b[11] - a[9] * b[13] ;
	c[19] += + a[16] * b[3] + a[17] * b[4] + a[18] * b[5] - a[13] * b[6] - a[14] * b[7] - a[15] * b[8] + a[7] * b[10] + a[8] * b[11] + a[9] * b[12] ;
}

void i2gai_pp_03_02_03_m1(const double *a, const double *b, double *c) {
	c[0] += + a[5] * b[1] - a[4] * b[2] + a[3] * b[3] + a[8] * b[4] - a[7] * b[5] + a[6] * b[6] + a[12] * b[10] - a[11] * b[11] + a[10] * b[12] ;
	c[1] += - a[5] * b[0] + a[2] * b[2] - a[1] * b[3] + a[9] * b[4] - a[7] * b[7] + a[6] * b[8] + a[13] * b[10] - a[11] * b[13] + a[10] * b[14] ;
	c[2] += + a[4] * b[0] - a[2] * b[1] + a[0] * b[3] + a[9] * b[5] - a[8] * b[7] + a[6] * b[9] + a[13] * b[11] - a[12] * b[13] + a[10] * b[15] ;
	c[3] += - a[3] * b[0] + a[1] * b[1] - a[0] * b[2] + a[9] * b[6] - a[8] * b[8] + a[7] * b[9] + a[13] * b[12] - a[12] * b[14] + a[11] * b[15] ;
	c[4] += - a[8] * b[0] - a[9] * b[1] + a[2] * b[5] - a[1] * b[6] + a[4] * b[7] - a[3] * b[8] + a[14] * b[10] - a[11] * b[16] + a[10] * b[17] ;
	c[5] += + a[7] * b[0] - a[9] * b[2] - a[2] * b[4] + a[0] * b[6] + a[5] * b[7] - a[3] * b[9] + a[14] * b[11] - a[12] * b[16] + a[10] * b[18] ;
	c[6] += - a[6] * b[0] - a[9] * b[3] + a[1] * b[4] - a[0] * b[5] + a[5] * b[8] - a[4] * b[9] + a[14] * b[12] - a[12] * b[17] + a[11] * b[18] ;
	c[7] += + a[7] * b[1] + a[8] * b[2] - a[4] * b[4] - a[5] * b[5] + a[0] * b[8] + a[1] * b[9] + a[14] * b[13] - a[13] * b[16] + a[10] * b[19] ;
	c[8] += - a[6] * b[1] + a[8] * b[3] + a[3] * b[4] - a[5] * b[6] - a[0] * b[7] + a[2] * b[9] + a[14] * b[14] - a[13] * b[17] + a[11] * b[19] ;
	c[9] += - a[6] * b[2] - a[7] * b[3] + a[3] * b[5] + a[4] * b[6] - a[1] * b[7] - a[2] * b[8] + a[14] * b[15] - a[13] * b[18] + a[12] * b[19] ;
	c[10] += - a[12] * b[0] - a[13] * b[1] - a[14] * b[4] + a[2] * b[11] - a[1] * b[12] + a[4] * b[13] - a[3] * b[14] + a[7] * b[16] - a[6] * b[17] ;
	c[11] += + a[11] * b[0] - a[13] * b[2] - a[14] * b[5] - a[2] * b[10] + a[0] * b[12] + a[5] * b[13] - a[3] * b[15] + a[8] * b[16] - a[6] * b[18] ;
	c[12] += - a[10] * b[0] - a[13] * b[3] - a[14] * b[6] + a[1] * b[10] - a[0] * b[11] + a[5] * b[14] - a[4] * b[15] + a[8] * b[17] - a[7] * b[18] ;
	c[13] += + a[11] * b[1] + a[12] * b[2] - a[14] * b[7] - a[4] * b[10] - a[5] * b[11] + a[0] * b[14] + a[1] * b[15] + a[9] * b[16] - a[6] * b[19] ;
	c[14] += - a[10] * b[1] + a[12] * b[3] - a[14] * b[8] + a[3] * b[10] - a[5] * b[12] - a[0] * b[13] + a[2] * b[15] + a[9] * b[17] - a[7] * b[19] ;
	c[15] += - a[10] * b[2] - a[11] * b[3] - a[14] * b[9] + a[3] * b[11] + a[4] * b[12] - a[1] * b[13] - a[2] * b[14] + a[9] * b[18] - a[8] * b[19] ;
	c[16] += + a[11] * b[4] + a[12] * b[5] + a[13] * b[7] - a[7] * b[10] - a[8] * b[11] - a[9] * b[13] + a[0] * b[17] + a[1] * b[18] + a[3] * b[19] ;
	c[17] += - a[10] * b[4] + a[12] * b[6] + a[13] * b[8] + a[6] * b[10] - a[8] * b[12] - a[9] * b[14] - a[0] * b[16] + a[2] * b[18] + a[4] * b[19] ;
	c[18] += - a[10] * b[5] - a[11] * b[6] + a[13] * b[9] + a[6] * b[11] + a[7] * b[12] - a[9] * b[15] - a[1] * b[16] - a[2] * b[17] + a[5] * b[19] ;
	c[19] += - a[10] * b[7] - a[11] * b[8] - a[12] * b[9] + a[6] * b[13] + a[7] * b[14] + a[8] * b[15] - a[3] * b[16] - a[4] * b[17] - a[5] * b[18] ;
}

void i2gai_pp_03_01_04_m1(const double *a, const double *b, double *c) {
	c[0] += - a[3] * b[0] - a[4] * b[1] - a[5] * b[5] ;
	c[1] += + a[2] * b[0] - a[4] * b[2] - a[5] * b[6] ;
	c[2] += - a[1] * b[0] - a[4] * b[3] - a[5] * b[7] ;
	c[3] += + a[0] * b[0] - a[4] * b[4] - a[5] * b[8] ;
	c[4] += + a[2] * b[1] + a[3] * b[2] - a[5] * b[9] ;
	c[5] += - a[1] * b[1] + a[3] * b[3] - a[5] * b[10] ;
	c[6] += + a[0] * b[1] + a[3] * b[4] - a[5] * b[11] ;
	c[7] += - a[1] * b[2] - a[2] * b[3] - a[5] * b[12] ;
	c[8] += + a[0] * b[2] - a[2] * b[4] - a[5] * b[13] ;
	c[9] += + a[0] * b[3] + a[1] * b[4] - a[5] * b[14] ;
	c[10] += + a[2] * b[5] + a[3] * b[6] + a[4] * b[9] ;
	c[11] += - a[1] * b[5] + a[3] * b[7] + a[4] * b[10] ;
	c[12] += + a[0] * b[5] + a[3] * b[8] + a[4] * b[11] ;
	c[13] += - a[1] * b[6] - a[2] * b[7] + a[4] * b[12] ;
	c[14] += + a[0] * b[6] - a[2] * b[8] + a[4] * b[13] ;
	c[15] += + a[0] * b[7] + a[1] * b[8] + a[4] * b[14] ;
	c[16] += - a[1] * b[9] - a[2] * b[10] - a[3] * b[12] ;
	c[17] += + a[0] * b[9] - a[2] * b[11] - a[3] * b[13] ;
	c[18] += + a[0] * b[10] + a[1] * b[11] - a[3] * b[14] ;
	c[19] += + a[0] * b[12] + a[1] * b[13] + a[2] * b[14] ;
}

void i2gai_pp_03_05_02_m1(const double *a, const double *b, double *c) {
	c[0] += - a[0] * b[9] - a[1] * b[13] - a[2] * b[14] ;
	c[1] += + a[0] * b[8] + a[1] * b[12] - a[3] * b[14] ;
	c[2] += - a[0] * b[7] - a[1] * b[11] - a[4] * b[14] ;
	c[3] += + a[0] * b[6] + a[1] * b[10] - a[5] * b[14] ;
	c[4] += - a[0] * b[5] + a[2] * b[12] + a[3] * b[13] ;
	c[5] += + a[0] * b[4] - a[2] * b[11] + a[4] * b[13] ;
	c[6] += - a[0] * b[3] + a[2] * b[10] + a[5] * b[13] ;
	c[7] += - a[0] * b[2] - a[3] * b[11] - a[4] * b[12] ;
	c[8] += + a[0] * b[1] + a[3] * b[10] - a[5] * b[12] ;
	c[9] += - a[0] * b[0] + a[4] * b[10] + a[5] * b[11] ;
	c[10] += - a[1] * b[5] - a[2] * b[8] - a[3] * b[9] ;
	c[11] += + a[1] * b[4] + a[2] * b[7] - a[4] * b[9] ;
	c[12] += - a[1] * b[3] - a[2] * b[6] - a[5] * b[9] ;
	c[13] += - a[1] * b[2] + a[3] * b[7] + a[4] * b[8] ;
	c[14] += + a[1] * b[1] - a[3] * b[6] + a[5] * b[8] ;
	c[15] += - a[1] * b[0] - a[4] * b[6] - a[5] * b[7] ;
	c[16] += - a[2] * b[2] - a[3] * b[4] - a[4] * b[5] ;
	c[17] += + a[2] * b[1] + a[3] * b[3] - a[5] * b[5] ;
	c[18] += - a[2] * b[0] + a[4] * b[3] + a[5] * b[4] ;
	c[19] += - a[3] * b[0] - a[4] * b[1] - a[5] * b[2] ;
}

void i2gai_pp_03_04_03_m1(const double *a, const double *b, double *c) {
	c[0] += - a[4] * b[7] + a[3] * b[8] - a[2] * b[9] - a[8] * b[13] + a[7] * b[14] - a[6] * b[15] - a[11] * b[16] + a[10] * b[17] - a[9] * b[18] ;
	c[1] += + a[4] * b[5] - a[3] * b[6] + a[1] * b[9] + a[8] * b[11] - a[7] * b[12] + a[5] * b[15] - a[13] * b[16] + a[12] * b[17] - a[9] * b[19] ;
	c[2] += - a[4] * b[4] + a[2] * b[6] - a[1] * b[8] - a[8] * b[10] + a[6] * b[12] - a[5] * b[14] - a[14] * b[16] + a[12] * b[18] - a[10] * b[19] ;
	c[3] += + a[3] * b[4] - a[2] * b[5] + a[1] * b[7] + a[7] * b[10] - a[6] * b[11] + a[5] * b[13] - a[14] * b[17] + a[13] * b[18] - a[11] * b[19] ;
	c[4] += - a[4] * b[2] + a[3] * b[3] - a[0] * b[9] + a[11] * b[11] - a[10] * b[12] + a[13] * b[13] - a[12] * b[14] + a[5] * b[18] + a[6] * b[19] ;
	c[5] += + a[4] * b[1] - a[2] * b[3] + a[0] * b[8] - a[11] * b[10] + a[9] * b[12] + a[14] * b[13] - a[12] * b[15] - a[5] * b[17] + a[7] * b[19] ;
	c[6] += - a[3] * b[1] + a[2] * b[2] - a[0] * b[7] + a[10] * b[10] - a[9] * b[11] + a[14] * b[14] - a[13] * b[15] + a[5] * b[16] + a[8] * b[19] ;
	c[7] += - a[4] * b[0] + a[1] * b[3] - a[0] * b[6] - a[13] * b[10] - a[14] * b[11] + a[9] * b[14] + a[10] * b[15] - a[6] * b[17] - a[7] * b[18] ;
	c[8] += + a[3] * b[0] - a[1] * b[2] + a[0] * b[5] + a[12] * b[10] - a[14] * b[12] - a[9] * b[13] + a[11] * b[15] + a[6] * b[16] - a[8] * b[18] ;
	c[9] += - a[2] * b[0] + a[1] * b[1] - a[0] * b[4] + a[12] * b[11] + a[13] * b[12] - a[10] * b[13] - a[11] * b[14] + a[7] * b[16] + a[8] * b[17] ;
	c[10] += - a[8] * b[2] + a[7] * b[3] - a[11] * b[5] + a[10] * b[6] - a[13] * b[7] + a[12] * b[8] - a[0] * b[15] - a[1] * b[18] - a[2] * b[19] ;
	c[11] += + a[8] * b[1] - a[6] * b[3] + a[11] * b[4] - a[9] * b[6] - a[14] * b[7] + a[12] * b[9] + a[0] * b[14] + a[1] * b[17] - a[3] * b[19] ;
	c[12] += - a[7] * b[1] + a[6] * b[2] - a[10] * b[4] + a[9] * b[5] - a[14] * b[8] + a[13] * b[9] - a[0] * b[13] - a[1] * b[16] - a[4] * b[19] ;
	c[13] += - a[8] * b[0] + a[5] * b[3] + a[13] * b[4] + a[14] * b[5] - a[9] * b[8] - a[10] * b[9] - a[0] * b[12] + a[2] * b[17] + a[3] * b[18] ;
	c[14] += + a[7] * b[0] - a[5] * b[2] - a[12] * b[4] + a[14] * b[6] + a[9] * b[7] - a[11] * b[9] + a[0] * b[11] - a[2] * b[16] + a[4] * b[18] ;
	c[15] += - a[6] * b[0] + a[5] * b[1] - a[12] * b[5] - a[13] * b[6] + a[10] * b[7] + a[11] * b[8] - a[0] * b[10] - a[3] * b[16] - a[4] * b[17] ;
	c[16] += - a[11] * b[0] - a[13] * b[1] - a[14] * b[2] + a[5] * b[6] + a[6] * b[8] + a[7] * b[9] - a[1] * b[12] - a[2] * b[14] - a[3] * b[15] ;
	c[17] += + a[10] * b[0] + a[12] * b[1] - a[14] * b[3] - a[5] * b[5] - a[6] * b[7] + a[8] * b[9] + a[1] * b[11] + a[2] * b[13] - a[4] * b[15] ;
	c[18] += - a[9] * b[0] + a[12] * b[2] + a[13] * b[3] + a[5] * b[4] - a[7] * b[7] - a[8] * b[8] - a[1] * b[10] + a[3] * b[13] + a[4] * b[14] ;
	c[19] += - a[9] * b[1] - a[10] * b[2] - a[11] * b[3] + a[6] * b[4] + a[7] * b[5] + a[8] * b[6] - a[2] * b[10] - a[3] * b[11] - a[4] * b[12] ;
}

void i2gai_pp_03_03_04_m1(const double *a, const double *b, double *c) {
	c[0] += - a[9] * b[2] + a[8] * b[3] - a[7] * b[4] - a[15] * b[6] + a[14] * b[7] - a[13] * b[8] - a[18] * b[9] + a[17] * b[10] - a[16] * b[11] ;
	c[1] += + a[9] * b[1] - a[6] * b[3] + a[5] * b[4] + a[15] * b[5] - a[12] * b[7] + a[11] * b[8] - a[19] * b[9] + a[17] * b[12] - a[16] * b[13] ;
	c[2] += - a[8] * b[1] + a[6] * b[2] - a[4] * b[4] - a[14] * b[5] + a[12] * b[6] - a[10] * b[8] - a[19] * b[10] + a[18] * b[12] - a[16] * b[14] ;
	c[3] += + a[7] * b[1] - a[5] * b[2] + a[4] * b[3] + a[13] * b[5] - a[11] * b[6] + a[10] * b[7] - a[19] * b[11] + a[18] * b[13] - a[17] * b[14] ;
	c[4] += - a[9] * b[0] + a[3] * b[3] - a[2] * b[4] + a[18] * b[5] + a[19] * b[6] - a[12] * b[10] + a[11] * b[11] - a[14] * b[12] + a[13] * b[13] ;
	c[5] += + a[8] * b[0] - a[3] * b[2] + a[1] * b[4] - a[17] * b[5] + a[19] * b[7] + a[12] * b[9] - a[10] * b[11] - a[15] * b[12] + a[13] * b[14] ;
	c[6] += - a[7] * b[0] + a[2] * b[2] - a[1] * b[3] + a[16] * b[5] + a[19] * b[8] - a[11] * b[9] + a[10] * b[10] - a[15] * b[13] + a[14] * b[14] ;
	c[7] += - a[6] * b[0] + a[3] * b[1] - a[0] * b[4] - a[17] * b[6] - a[18] * b[7] + a[14] * b[9] + a[15] * b[10] - a[10] * b[13] - a[11] * b[14] ;
	c[8] += + a[5] * b[0] - a[2] * b[1] + a[0] * b[3] + a[16] * b[6] - a[18] * b[8] - a[13] * b[9] + a[15] * b[11] + a[10] * b[12] - a[12] * b[14] ;
	c[9] += - a[4] * b[0] + a[1] * b[1] - a[0] * b[2] + a[16] * b[7] + a[17] * b[8] - a[13] * b[10] - a[14] * b[11] + a[11] * b[12] + a[12] * b[13] ;
	c[10] += - a[15] * b[0] - a[18] * b[1] - a[19] * b[2] + a[3] * b[7] - a[2] * b[8] + a[6] * b[10] - a[5] * b[11] + a[8] * b[12] - a[7] * b[13] ;
	c[11] += + a[14] * b[0] + a[17] * b[1] - a[19] * b[3] - a[3] * b[6] + a[1] * b[8] - a[6] * b[9] + a[4] * b[11] + a[9] * b[12] - a[7] * b[14] ;
	c[12] += - a[13] * b[0] - a[16] * b[1] - a[19] * b[4] + a[2] * b[6] - a[1] * b[7] + a[5] * b[9] - a[4] * b[10] + a[9] * b[13] - a[8] * b[14] ;
	c[13] += - a[12] * b[0] + a[17] * b[2] + a[18] * b[3] + a[3] * b[5] - a[0] * b[8] - a[8] * b[9] - a[9] * b[10] + a[4] * b[13] + a[5] * b[14] ;
	c[14] += + a[11] * b[0] - a[16] * b[2] + a[18] * b[4] - a[2] * b[5] + a[0] * b[7] + a[7] * b[9] - a[9] * b[11] - a[4] * b[12] + a[6] * b[14] ;
	c[15] += - a[10] * b[0] - a[16] * b[3] - a[17] * b[4] + a[1] * b[5] - a[0] * b[6] + a[7] * b[10] + a[8] * b[11] - a[5] * b[12] - a[6] * b[13] ;
	c[16] += - a[12] * b[1] - a[14] * b[2] - a[15] * b[3] + a[6] * b[5] + a[8] * b[6] + a[9] * b[7] - a[0] * b[11] - a[1] * b[13] - a[2] * b[14] ;
	c[17] += + a[11] * b[1] + a[13] * b[2] - a[15] * b[4] - a[5] * b[5] - a[7] * b[6] + a[9] * b[8] + a[0] * b[10] + a[1] * b[12] - a[3] * b[14] ;
	c[18] += - a[10] * b[1] + a[13] * b[3] + a[14] * b[4] + a[4] * b[5] - a[7] * b[7] - a[8] * b[8] - a[0] * b[9] + a[2] * b[12] + a[3] * b[13] ;
	c[19] += - a[10] * b[2] - a[11] * b[3] - a[12] * b[4] + a[4] * b[6] + a[5] * b[7] + a[6] * b[8] - a[1] * b[9] - a[2] * b[10] - a[3] * b[11] ;
}

void i2gai_pp_03_02_05_m1(const double *a, const double *b, double *c) {
	c[0] += - a[9] * b[0] - a[13] * b[1] - a[14] * b[2] ;
	c[1] += + a[8] * b[0] + a[12] * b[1] - a[14] * b[3] ;
	c[2] += - a[7] * b[0] - a[11] * b[1] - a[14] * b[4] ;
	c[3] += + a[6] * b[0] + a[10] * b[1] - a[14] * b[5] ;
	c[4] += - a[5] * b[0] + a[12] * b[2] + a[13] * b[3] ;
	c[5] += + a[4] * b[0] - a[11] * b[2] + a[13] * b[4] ;
	c[6] += - a[3] * b[0] + a[10] * b[2] + a[13] * b[5] ;
	c[7] += - a[2] * b[0] - a[11] * b[3] - a[12] * b[4] ;
	c[8] += + a[1] * b[0] + a[10] * b[3] - a[12] * b[5] ;
	c[9] += - a[0] * b[0] + a[10] * b[4] + a[11] * b[5] ;
	c[10] += - a[5] * b[1] - a[8] * b[2] - a[9] * b[3] ;
	c[11] += + a[4] * b[1] + a[7] * b[2] - a[9] * b[4] ;
	c[12] += - a[3] * b[1] - a[6] * b[2] - a[9] * b[5] ;
	c[13] += - a[2] * b[1] + a[7] * b[3] + a[8] * b[4] ;
	c[14] += + a[1] * b[1] - a[6] * b[3] + a[8] * b[5] ;
	c[15] += - a[0] * b[1] - a[6] * b[4] - a[7] * b[5] ;
	c[16] += - a[2] * b[2] - a[4] * b[3] - a[5] * b[4] ;
	c[17] += + a[1] * b[2] + a[3] * b[3] - a[5] * b[5] ;
	c[18] += - a[0] * b[2] + a[3] * b[4] + a[4] * b[5] ;
	c[19] += - a[0] * b[3] - a[1] * b[4] - a[2] * b[5] ;
}

void i2gai_pp_03_06_03_m1(const double *a, const double *b, double *c) {
	c[0] += - a[0] * b[19] ;
	c[1] += + a[0] * b[18] ;
	c[2] += - a[0] * b[17] ;
	c[3] += + a[0] * b[16] ;
	c[4] += - a[0] * b[15] ;
	c[5] += + a[0] * b[14] ;
	c[6] += - a[0] * b[13] ;
	c[7] += - a[0] * b[12] ;
	c[8] += + a[0] * b[11] ;
	c[9] += - a[0] * b[10] ;
	c[10] += + a[0] * b[9] ;
	c[11] += - a[0] * b[8] ;
	c[12] += + a[0] * b[7] ;
	c[13] += + a[0] * b[6] ;
	c[14] += - a[0] * b[5] ;
	c[15] += + a[0] * b[4] ;
	c[16] += - a[0] * b[3] ;
	c[17] += + a[0] * b[2] ;
	c[18] += - a[0] * b[1] ;
	c[19] += + a[0] * b[0] ;
}

void i2gai_pp_03_05_04_m1(const double *a, const double *b, double *c) {
	c[0] += + a[5] * b[12] - a[4] * b[13] + a[3] * b[14] ;
	c[1] += - a[5] * b[10] + a[4] * b[11] - a[2] * b[14] ;
	c[2] += + a[5] * b[9] - a[3] * b[11] + a[2] * b[13] ;
	c[3] += - a[4] * b[9] + a[3] * b[10] - a[2] * b[12] ;
	c[4] += + a[5] * b[7] - a[4] * b[8] + a[1] * b[14] ;
	c[5] += - a[5] * b[6] + a[3] * b[8] - a[1] * b[13] ;
	c[6] += + a[4] * b[6] - a[3] * b[7] + a[1] * b[12] ;
	c[7] += + a[5] * b[5] - a[2] * b[8] + a[1] * b[11] ;
	c[8] += - a[4] * b[5] + a[2] * b[7] - a[1] * b[10] ;
	c[9] += + a[3] * b[5] - a[2] * b[6] + a[1] * b[9] ;
	c[10] += - a[5] * b[3] + a[4] * b[4] - a[0] * b[14] ;
	c[11] += + a[5] * b[2] - a[3] * b[4] + a[0] * b[13] ;
	c[12] += - a[4] * b[2] + a[3] * b[3] - a[0] * b[12] ;
	c[13] += - a[5] * b[1] + a[2] * b[4] - a[0] * b[11] ;
	c[14] += + a[4] * b[1] - a[2] * b[3] + a[0] * b[10] ;
	c[15] += - a[3] * b[1] + a[2] * b[2] - a[0] * b[9] ;
	c[16] += + a[5] * b[0] - a[1] * b[4] + a[0] * b[8] ;
	c[17] += - a[4] * b[0] + a[1] * b[3] - a[0] * b[7] ;
	c[18] += + a[3] * b[0] - a[1] * b[2] + a[0] * b[6] ;
	c[19] += - a[2] * b[0] + a[1] * b[1] - a[0] * b[5] ;
}

void i2gai_pp_03_04_05_m1(const double *a, const double *b, double *c) {
	c[0] += - a[14] * b[3] + a[13] * b[4] - a[12] * b[5] ;
	c[1] += + a[14] * b[2] - a[11] * b[4] + a[10] * b[5] ;
	c[2] += - a[13] * b[2] + a[11] * b[3] - a[9] * b[5] ;
	c[3] += + a[12] * b[2] - a[10] * b[3] + a[9] * b[4] ;
	c[4] += - a[14] * b[1] + a[8] * b[4] - a[7] * b[5] ;
	c[5] += + a[13] * b[1] - a[8] * b[3] + a[6] * b[5] ;
	c[6] += - a[12] * b[1] + a[7] * b[3] - a[6] * b[4] ;
	c[7] += - a[11] * b[1] + a[8] * b[2] - a[5] * b[5] ;
	c[8] += + a[10] * b[1] - a[7] * b[2] + a[5] * b[4] ;
	c[9] += - a[9] * b[1] + a[6] * b[2] - a[5] * b[3] ;
	c[10] += + a[14] * b[0] - a[4] * b[4] + a[3] * b[5] ;
	c[11] += - a[13] * b[0] + a[4] * b[3] - a[2] * b[5] ;
	c[12] += + a[12] * b[0] - a[3] * b[3] + a[2] * b[4] ;
	c[13] += + a[11] * b[0] - a[4] * b[2] + a[1] * b[5] ;
	c[14] += - a[10] * b[0] + a[3] * b[2] - a[1] * b[4] ;
	c[15] += + a[9] * b[0] - a[2] * b[2] + a[1] * b[3] ;
	c[16] += - a[8] * b[0] + a[4] * b[1] - a[0] * b[5] ;
	c[17] += + a[7] * b[0] - a[3] * b[1] + a[0] * b[4] ;
	c[18] += - a[6] * b[0] + a[2] * b[1] - a[0] * b[3] ;
	c[19] += + a[5] * b[0] - a[1] * b[1] + a[0] * b[2] ;
}

void i2gai_pp_03_03_06_m1(const double *a, const double *b, double *c) {
	c[0] += + a[19] * b[0] ;
	c[1] += - a[18] * b[0] ;
	c[2] += + a[17] * b[0] ;
	c[3] += - a[16] * b[0] ;
	c[4] += + a[15] * b[0] ;
	c[5] += - a[14] * b[0] ;
	c[6] += + a[13] * b[0] ;
	c[7] += + a[12] * b[0] ;
	c[8] += - a[11] * b[0] ;
	c[9] += + a[10] * b[0] ;
	c[10] += - a[9] * b[0] ;
	c[11] += + a[8] * b[0] ;
	c[12] += - a[7] * b[0] ;
	c[13] += - a[6] * b[0] ;
	c[14] += + a[5] * b[0] ;
	c[15] += - a[4] * b[0] ;
	c[16] += + a[3] * b[0] ;
	c[17] += - a[2] * b[0] ;
	c[18] += + a[1] * b[0] ;
	c[19] += - a[0] * b[0] ;
}

void i2gai_pp_04_04_00_m1(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[0] ;
	c[1] += + a[1] * b[0] ;
	c[2] += + a[2] * b[0] ;
	c[3] += + a[3] * b[0] ;
	c[4] += + a[4] * b[0] ;
	c[5] += + a[5] * b[0] ;
	c[6] += + a[6] * b[0] ;
	c[7] += + a[7] * b[0] ;
	c[8] += + a[8] * b[0] ;
	c[9] += + a[9] * b[0] ;
	c[10] += + a[10] * b[0] ;
	c[11] += + a[11] * b[0] ;
	c[12] += + a[12] * b[0] ;
	c[13] += + a[13] * b[0] ;
	c[14] += + a[14] * b[0] ;
}

void i2gai_pp_04_03_01_m1(const double *a, const double *b, double *c) {
	c[0] += - a[3] * b[0] + a[2] * b[1] - a[1] * b[2] + a[0] * b[3] ;
	c[1] += - a[6] * b[0] + a[5] * b[1] - a[4] * b[2] + a[0] * b[4] ;
	c[2] += - a[8] * b[0] + a[7] * b[1] - a[4] * b[3] + a[1] * b[4] ;
	c[3] += - a[9] * b[0] + a[7] * b[2] - a[5] * b[3] + a[2] * b[4] ;
	c[4] += - a[9] * b[1] + a[8] * b[2] - a[6] * b[3] + a[3] * b[4] ;
	c[5] += - a[12] * b[0] + a[11] * b[1] - a[10] * b[2] + a[0] * b[5] ;
	c[6] += - a[14] * b[0] + a[13] * b[1] - a[10] * b[3] + a[1] * b[5] ;
	c[7] += - a[15] * b[0] + a[13] * b[2] - a[11] * b[3] + a[2] * b[5] ;
	c[8] += - a[15] * b[1] + a[14] * b[2] - a[12] * b[3] + a[3] * b[5] ;
	c[9] += - a[17] * b[0] + a[16] * b[1] - a[10] * b[4] + a[4] * b[5] ;
	c[10] += - a[18] * b[0] + a[16] * b[2] - a[11] * b[4] + a[5] * b[5] ;
	c[11] += - a[18] * b[1] + a[17] * b[2] - a[12] * b[4] + a[6] * b[5] ;
	c[12] += - a[19] * b[0] + a[16] * b[3] - a[13] * b[4] + a[7] * b[5] ;
	c[13] += - a[19] * b[1] + a[17] * b[3] - a[14] * b[4] + a[8] * b[5] ;
	c[14] += - a[19] * b[2] + a[18] * b[3] - a[15] * b[4] + a[9] * b[5] ;
}

void i2gai_pp_04_02_02_m1(const double *a, const double *b, double *c) {
	c[0] += + a[5] * b[0] - a[4] * b[1] + a[3] * b[2] + a[2] * b[3] - a[1] * b[4] + a[0] * b[5] ;
	c[1] += + a[8] * b[0] - a[7] * b[1] + a[6] * b[2] + a[2] * b[6] - a[1] * b[7] + a[0] * b[8] ;
	c[2] += + a[9] * b[0] - a[7] * b[3] + a[6] * b[4] + a[4] * b[6] - a[3] * b[7] + a[0] * b[9] ;
	c[3] += + a[9] * b[1] - a[8] * b[3] + a[6] * b[5] + a[5] * b[6] - a[3] * b[8] + a[1] * b[9] ;
	c[4] += + a[9] * b[2] - a[8] * b[4] + a[7] * b[5] + a[5] * b[7] - a[4] * b[8] + a[2] * b[9] ;
	c[5] += + a[12] * b[0] - a[11] * b[1] + a[10] * b[2] + a[2] * b[10] - a[1] * b[11] + a[0] * b[12] ;
	c[6] += + a[13] * b[0] - a[11] * b[3] + a[10] * b[4] + a[4] * b[10] - a[3] * b[11] + a[0] * b[13] ;
	c[7] += + a[13] * b[1] - a[12] * b[3] + a[10] * b[5] + a[5] * b[10] - a[3] * b[12] + a[1] * b[13] ;
	c[8] += + a[13] * b[2] - a[12] * b[4] + a[11] * b[5] + a[5] * b[11] - a[4] * b[12] + a[2] * b[13] ;
	c[9] += + a[14] * b[0] - a[11] * b[6] + a[10] * b[7] + a[7] * b[10] - a[6] * b[11] + a[0] * b[14] ;
	c[10] += + a[14] * b[1] - a[12] * b[6] + a[10] * b[8] + a[8] * b[10] - a[6] * b[12] + a[1] * b[14] ;
	c[11] += + a[14] * b[2] - a[12] * b[7] + a[11] * b[8] + a[8] * b[11] - a[7] * b[12] + a[2] * b[14] ;
	c[12] += + a[14] * b[3] - a[13] * b[6] + a[10] * b[9] + a[9] * b[10] - a[6] * b[13] + a[3] * b[14] ;
	c[13] += + a[14] * b[4] - a[13] * b[7] + a[11] * b[9] + a[9] * b[11] - a[7] * b[13] + a[4] * b[14] ;
	c[14] += + a[14] * b[5] - a[13] * b[8] + a[12] * b[9] + a[9] * b[12] - a[8] * b[13] + a[5] * b[14] ;
}

void i2gai_pp_04_01_03_m1(const double *a, const double *b, double *c) {
	c[0] += - a[3] * b[0] + a[2] * b[1] - a[1] * b[2] + a[0] * b[3] ;
	c[1] += - a[4] * b[0] + a[2] * b[4] - a[1] * b[5] + a[0] * b[6] ;
	c[2] += - a[4] * b[1] + a[3] * b[4] - a[1] * b[7] + a[0] * b[8] ;
	c[3] += - a[4] * b[2] + a[3] * b[5] - a[2] * b[7] + a[0] * b[9] ;
	c[4] += - a[4] * b[3] + a[3] * b[6] - a[2] * b[8] + a[1] * b[9] ;
	c[5] += - a[5] * b[0] + a[2] * b[10] - a[1] * b[11] + a[0] * b[12] ;
	c[6] += - a[5] * b[1] + a[3] * b[10] - a[1] * b[13] + a[0] * b[14] ;
	c[7] += - a[5] * b[2] + a[3] * b[11] - a[2] * b[13] + a[0] * b[15] ;
	c[8] += - a[5] * b[3] + a[3] * b[12] - a[2] * b[14] + a[1] * b[15] ;
	c[9] += - a[5] * b[4] + a[4] * b[10] - a[1] * b[16] + a[0] * b[17] ;
	c[10] += - a[5] * b[5] + a[4] * b[11] - a[2] * b[16] + a[0] * b[18] ;
	c[11] += - a[5] * b[6] + a[4] * b[12] - a[2] * b[17] + a[1] * b[18] ;
	c[12] += - a[5] * b[7] + a[4] * b[13] - a[3] * b[16] + a[0] * b[19] ;
	c[13] += - a[5] * b[8] + a[4] * b[14] - a[3] * b[17] + a[1] * b[19] ;
	c[14] += - a[5] * b[9] + a[4] * b[15] - a[3] * b[18] + a[2] * b[19] ;
}

void i2gai_pp_04_00_04_m1(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[0] ;
	c[1] += + a[0] * b[1] ;
	c[2] += + a[0] * b[2] ;
	c[3] += + a[0] * b[3] ;
	c[4] += + a[0] * b[4] ;
	c[5] += + a[0] * b[5] ;
	c[6] += + a[0] * b[6] ;
	c[7] += + a[0] * b[7] ;
	c[8] += + a[0] * b[8] ;
	c[9] += + a[0] * b[9] ;
	c[10] += + a[0] * b[10] ;
	c[11] += + a[0] * b[11] ;
	c[12] += + a[0] * b[12] ;
	c[13] += + a[0] * b[13] ;
	c[14] += + a[0] * b[14] ;
}

void i2gai_pp_04_05_01_m1(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[4] + a[1] * b[5] ;
	c[1] += - a[0] * b[3] + a[2] * b[5] ;
	c[2] += + a[0] * b[2] + a[3] * b[5] ;
	c[3] += - a[0] * b[1] + a[4] * b[5] ;
	c[4] += + a[0] * b[0] + a[5] * b[5] ;
	c[5] += - a[1] * b[3] - a[2] * b[4] ;
	c[6] += + a[1] * b[2] - a[3] * b[4] ;
	c[7] += - a[1] * b[1] - a[4] * b[4] ;
	c[8] += + a[1] * b[0] - a[5] * b[4] ;
	c[9] += + a[2] * b[2] + a[3] * b[3] ;
	c[10] += - a[2] * b[1] + a[4] * b[3] ;
	c[11] += + a[2] * b[0] + a[5] * b[3] ;
	c[12] += - a[3] * b[1] - a[4] * b[2] ;
	c[13] += + a[3] * b[0] - a[5] * b[2] ;
	c[14] += + a[4] * b[0] + a[5] * b[1] ;
}

void i2gai_pp_04_04_02_m1(const double *a, const double *b, double *c) {
	c[0] += + a[4] * b[6] - a[3] * b[7] + a[2] * b[8] - a[1] * b[9] + a[8] * b[10] - a[7] * b[11] + a[6] * b[12] - a[5] * b[13] ;
	c[1] += - a[4] * b[3] + a[3] * b[4] - a[2] * b[5] + a[0] * b[9] + a[11] * b[10] - a[10] * b[11] + a[9] * b[12] - a[5] * b[14] ;
	c[2] += + a[4] * b[1] - a[3] * b[2] + a[1] * b[5] - a[0] * b[8] + a[13] * b[10] - a[12] * b[11] + a[9] * b[13] - a[6] * b[14] ;
	c[3] += - a[4] * b[0] + a[2] * b[2] - a[1] * b[4] + a[0] * b[7] + a[14] * b[10] - a[12] * b[12] + a[10] * b[13] - a[7] * b[14] ;
	c[4] += + a[3] * b[0] - a[2] * b[1] + a[1] * b[3] - a[0] * b[6] + a[14] * b[11] - a[13] * b[12] + a[11] * b[13] - a[8] * b[14] ;
	c[5] += - a[8] * b[3] + a[7] * b[4] - a[6] * b[5] - a[11] * b[6] + a[10] * b[7] - a[9] * b[8] + a[0] * b[13] + a[1] * b[14] ;
	c[6] += + a[8] * b[1] - a[7] * b[2] + a[5] * b[5] - a[13] * b[6] + a[12] * b[7] - a[9] * b[9] - a[0] * b[12] + a[2] * b[14] ;
	c[7] += - a[8] * b[0] + a[6] * b[2] - a[5] * b[4] - a[14] * b[6] + a[12] * b[8] - a[10] * b[9] + a[0] * b[11] + a[3] * b[14] ;
	c[8] += + a[7] * b[0] - a[6] * b[1] + a[5] * b[3] - a[14] * b[7] + a[13] * b[8] - a[11] * b[9] - a[0] * b[10] + a[4] * b[14] ;
	c[9] += + a[11] * b[1] - a[10] * b[2] + a[13] * b[3] - a[12] * b[4] + a[5] * b[8] + a[6] * b[9] - a[1] * b[12] - a[2] * b[13] ;
	c[10] += - a[11] * b[0] + a[9] * b[2] + a[14] * b[3] - a[12] * b[5] - a[5] * b[7] + a[7] * b[9] + a[1] * b[11] - a[3] * b[13] ;
	c[11] += + a[10] * b[0] - a[9] * b[1] + a[14] * b[4] - a[13] * b[5] + a[5] * b[6] + a[8] * b[9] - a[1] * b[10] - a[4] * b[13] ;
	c[12] += - a[13] * b[0] - a[14] * b[1] + a[9] * b[4] + a[10] * b[5] - a[6] * b[7] - a[7] * b[8] + a[2] * b[11] + a[3] * b[12] ;
	c[13] += + a[12] * b[0] - a[14] * b[2] - a[9] * b[3] + a[11] * b[5] + a[6] * b[6] - a[8] * b[8] - a[2] * b[10] + a[4] * b[12] ;
	c[14] += + a[12] * b[1] + a[13] * b[2] - a[10] * b[3] - a[11] * b[4] + a[7] * b[6] + a[8] * b[7] - a[3] * b[10] - a[4] * b[11] ;
}

void i2gai_pp_04_03_03_m1(const double *a, const double *b, double *c) {
	c[0] += + a[9] * b[4] - a[8] * b[5] + a[7] * b[6] + a[6] * b[7] - a[5] * b[8] + a[4] * b[9] + a[15] * b[10] - a[14] * b[11] + a[13] * b[12] + a[12] * b[13] - a[11] * b[14] + a[10] * b[15] ;
	c[1] += - a[9] * b[1] + a[8] * b[2] - a[7] * b[3] - a[3] * b[7] + a[2] * b[8] - a[1] * b[9] + a[18] * b[10] - a[17] * b[11] + a[16] * b[12] + a[12] * b[16] - a[11] * b[17] + a[10] * b[18] ;
	c[2] += + a[9] * b[0] - a[6] * b[2] + a[5] * b[3] + a[3] * b[5] - a[2] * b[6] + a[0] * b[9] + a[19] * b[10] - a[17] * b[13] + a[16] * b[14] + a[14] * b[16] - a[13] * b[17] + a[10] * b[19] ;
	c[3] += - a[8] * b[0] + a[6] * b[1] - a[4] * b[3] - a[3] * b[4] + a[1] * b[6] - a[0] * b[8] + a[19] * b[11] - a[18] * b[13] + a[16] * b[15] + a[15] * b[16] - a[13] * b[18] + a[11] * b[19] ;
	c[4] += + a[7] * b[0] - a[5] * b[1] + a[4] * b[2] + a[2] * b[4] - a[1] * b[5] + a[0] * b[7] + a[19] * b[12] - a[18] * b[14] + a[17] * b[15] + a[15] * b[17] - a[14] * b[18] + a[12] * b[19] ;
	c[5] += - a[15] * b[1] + a[14] * b[2] - a[13] * b[3] - a[18] * b[4] + a[17] * b[5] - a[16] * b[6] - a[3] * b[13] + a[2] * b[14] - a[1] * b[15] - a[6] * b[16] + a[5] * b[17] - a[4] * b[18] ;
	c[6] += + a[15] * b[0] - a[12] * b[2] + a[11] * b[3] - a[19] * b[4] + a[17] * b[7] - a[16] * b[8] + a[3] * b[11] - a[2] * b[12] + a[0] * b[15] - a[8] * b[16] + a[7] * b[17] - a[4] * b[19] ;
	c[7] += - a[14] * b[0] + a[12] * b[1] - a[10] * b[3] - a[19] * b[5] + a[18] * b[7] - a[16] * b[9] - a[3] * b[10] + a[1] * b[12] - a[0] * b[14] - a[9] * b[16] + a[7] * b[18] - a[5] * b[19] ;
	c[8] += + a[13] * b[0] - a[11] * b[1] + a[10] * b[2] - a[19] * b[6] + a[18] * b[8] - a[17] * b[9] + a[2] * b[10] - a[1] * b[11] + a[0] * b[13] - a[9] * b[17] + a[8] * b[18] - a[6] * b[19] ;
	c[9] += + a[18] * b[0] + a[19] * b[1] - a[12] * b[5] + a[11] * b[6] - a[14] * b[7] + a[13] * b[8] + a[6] * b[11] - a[5] * b[12] + a[8] * b[13] - a[7] * b[14] + a[0] * b[18] + a[1] * b[19] ;
	c[10] += - a[17] * b[0] + a[19] * b[2] + a[12] * b[4] - a[10] * b[6] - a[15] * b[7] + a[13] * b[9] - a[6] * b[10] + a[4] * b[12] + a[9] * b[13] - a[7] * b[15] - a[0] * b[17] + a[2] * b[19] ;
	c[11] += + a[16] * b[0] + a[19] * b[3] - a[11] * b[4] + a[10] * b[5] - a[15] * b[8] + a[14] * b[9] + a[5] * b[10] - a[4] * b[11] + a[9] * b[14] - a[8] * b[15] + a[0] * b[16] + a[3] * b[19] ;
	c[12] += - a[17] * b[1] - a[18] * b[2] + a[14] * b[4] + a[15] * b[5] - a[10] * b[8] - a[11] * b[9] - a[8] * b[10] - a[9] * b[11] + a[4] * b[14] + a[5] * b[15] - a[1] * b[17] - a[2] * b[18] ;
	c[13] += + a[16] * b[1] - a[18] * b[3] - a[13] * b[4] + a[15] * b[6] + a[10] * b[7] - a[12] * b[9] + a[7] * b[10] - a[9] * b[12] - a[4] * b[13] + a[6] * b[15] + a[1] * b[16] - a[3] * b[18] ;
	c[14] += + a[16] * b[2] + a[17] * b[3] - a[13] * b[5] - a[14] * b[6] + a[11] * b[7] + a[12] * b[8] + a[7] * b[11] + a[8] * b[12] - a[5] * b[13] - a[6] * b[14] + a[2] * b[16] + a[3] * b[17] ;
}

void i2gai_pp_04_02_04_m1(const double *a, const double *b, double *c) {
	c[0] += + a[9] * b[1] - a[8] * b[2] + a[7] * b[3] - a[6] * b[4] + a[13] * b[5] - a[12] * b[6] + a[11] * b[7] - a[10] * b[8] ;
	c[1] += - a[9] * b[0] + a[5] * b[2] - a[4] * b[3] + a[3] * b[4] + a[14] * b[5] - a[12] * b[9] + a[11] * b[10] - a[10] * b[11] ;
	c[2] += + a[8] * b[0] - a[5] * b[1] + a[2] * b[3] - a[1] * b[4] + a[14] * b[6] - a[13] * b[9] + a[11] * b[12] - a[10] * b[13] ;
	c[3] += - a[7] * b[0] + a[4] * b[1] - a[2] * b[2] + a[0] * b[4] + a[14] * b[7] - a[13] * b[10] + a[12] * b[12] - a[10] * b[14] ;
	c[4] += + a[6] * b[0] - a[3] * b[1] + a[1] * b[2] - a[0] * b[3] + a[14] * b[8] - a[13] * b[11] + a[12] * b[13] - a[11] * b[14] ;
	c[5] += - a[13] * b[0] - a[14] * b[1] + a[5] * b[6] - a[4] * b[7] + a[3] * b[8] + a[8] * b[9] - a[7] * b[10] + a[6] * b[11] ;
	c[6] += + a[12] * b[0] - a[14] * b[2] - a[5] * b[5] + a[2] * b[7] - a[1] * b[8] + a[9] * b[9] - a[7] * b[12] + a[6] * b[13] ;
	c[7] += - a[11] * b[0] - a[14] * b[3] + a[4] * b[5] - a[2] * b[6] + a[0] * b[8] + a[9] * b[10] - a[8] * b[12] + a[6] * b[14] ;
	c[8] += + a[10] * b[0] - a[14] * b[4] - a[3] * b[5] + a[1] * b[6] - a[0] * b[7] + a[9] * b[11] - a[8] * b[13] + a[7] * b[14] ;
	c[9] += + a[12] * b[1] + a[13] * b[2] - a[8] * b[5] - a[9] * b[6] + a[2] * b[10] - a[1] * b[11] + a[4] * b[12] - a[3] * b[13] ;
	c[10] += - a[11] * b[1] + a[13] * b[3] + a[7] * b[5] - a[9] * b[7] - a[2] * b[9] + a[0] * b[11] + a[5] * b[12] - a[3] * b[14] ;
	c[11] += + a[10] * b[1] + a[13] * b[4] - a[6] * b[5] - a[9] * b[8] + a[1] * b[9] - a[0] * b[10] + a[5] * b[13] - a[4] * b[14] ;
	c[12] += - a[11] * b[2] - a[12] * b[3] + a[7] * b[6] + a[8] * b[7] - a[4] * b[9] - a[5] * b[10] + a[0] * b[13] + a[1] * b[14] ;
	c[13] += + a[10] * b[2] - a[12] * b[4] - a[6] * b[6] + a[8] * b[8] + a[3] * b[9] - a[5] * b[11] - a[0] * b[12] + a[2] * b[14] ;
	c[14] += + a[10] * b[3] + a[11] * b[4] - a[6] * b[7] - a[7] * b[8] + a[3] * b[10] + a[4] * b[11] - a[1] * b[12] - a[2] * b[13] ;
}

void i2gai_pp_04_01_05_m1(const double *a, const double *b, double *c) {
	c[0] += + a[4] * b[0] + a[5] * b[1] ;
	c[1] += - a[3] * b[0] + a[5] * b[2] ;
	c[2] += + a[2] * b[0] + a[5] * b[3] ;
	c[3] += - a[1] * b[0] + a[5] * b[4] ;
	c[4] += + a[0] * b[0] + a[5] * b[5] ;
	c[5] += - a[3] * b[1] - a[4] * b[2] ;
	c[6] += + a[2] * b[1] - a[4] * b[3] ;
	c[7] += - a[1] * b[1] - a[4] * b[4] ;
	c[8] += + a[0] * b[1] - a[4] * b[5] ;
	c[9] += + a[2] * b[2] + a[3] * b[3] ;
	c[10] += - a[1] * b[2] + a[3] * b[4] ;
	c[11] += + a[0] * b[2] + a[3] * b[5] ;
	c[12] += - a[1] * b[3] - a[2] * b[4] ;
	c[13] += + a[0] * b[3] - a[2] * b[5] ;
	c[14] += + a[0] * b[4] + a[1] * b[5] ;
}

void i2gai_pp_04_06_02_m1(const double *a, const double *b, double *c) {
	c[0] += - a[0] * b[14] ;
	c[1] += + a[0] * b[13] ;
	c[2] += - a[0] * b[12] ;
	c[3] += + a[0] * b[11] ;
	c[4] += - a[0] * b[10] ;
	c[5] += - a[0] * b[9] ;
	c[6] += + a[0] * b[8] ;
	c[7] += - a[0] * b[7] ;
	c[8] += + a[0] * b[6] ;
	c[9] += - a[0] * b[5] ;
	c[10] += + a[0] * b[4] ;
	c[11] += - a[0] * b[3] ;
	c[12] += - a[0] * b[2] ;
	c[13] += + a[0] * b[1] ;
	c[14] += - a[0] * b[0] ;
}

void i2gai_pp_04_05_03_m1(const double *a, const double *b, double *c) {
	c[0] += + a[5] * b[16] - a[4] * b[17] + a[3] * b[18] - a[2] * b[19] ;
	c[1] += - a[5] * b[13] + a[4] * b[14] - a[3] * b[15] + a[1] * b[19] ;
	c[2] += + a[5] * b[11] - a[4] * b[12] + a[2] * b[15] - a[1] * b[18] ;
	c[3] += - a[5] * b[10] + a[3] * b[12] - a[2] * b[14] + a[1] * b[17] ;
	c[4] += + a[4] * b[10] - a[3] * b[11] + a[2] * b[13] - a[1] * b[16] ;
	c[5] += + a[5] * b[7] - a[4] * b[8] + a[3] * b[9] - a[0] * b[19] ;
	c[6] += - a[5] * b[5] + a[4] * b[6] - a[2] * b[9] + a[0] * b[18] ;
	c[7] += + a[5] * b[4] - a[3] * b[6] + a[2] * b[8] - a[0] * b[17] ;
	c[8] += - a[4] * b[4] + a[3] * b[5] - a[2] * b[7] + a[0] * b[16] ;
	c[9] += + a[5] * b[2] - a[4] * b[3] + a[1] * b[9] - a[0] * b[15] ;
	c[10] += - a[5] * b[1] + a[3] * b[3] - a[1] * b[8] + a[0] * b[14] ;
	c[11] += + a[4] * b[1] - a[3] * b[2] + a[1] * b[7] - a[0] * b[13] ;
	c[12] += + a[5] * b[0] - a[2] * b[3] + a[1] * b[6] - a[0] * b[12] ;
	c[13] += - a[4] * b[0] + a[2] * b[2] - a[1] * b[5] + a[0] * b[11] ;
	c[14] += + a[3] * b[0] - a[2] * b[1] + a[1] * b[4] - a[0] * b[10] ;
}

void i2gai_pp_04_04_04_m1(const double *a, const double *b, double *c) {
	c[0] += - a[14] * b[9] + a[13] * b[10] - a[12] * b[11] - a[11] * b[12] + a[10] * b[13] - a[9] * b[14] ;
	c[1] += + a[14] * b[6] - a[13] * b[7] + a[12] * b[8] + a[8] * b[12] - a[7] * b[13] + a[6] * b[14] ;
	c[2] += - a[14] * b[5] + a[11] * b[7] - a[10] * b[8] - a[8] * b[10] + a[7] * b[11] - a[5] * b[14] ;
	c[3] += + a[13] * b[5] - a[11] * b[6] + a[9] * b[8] + a[8] * b[9] - a[6] * b[11] + a[5] * b[13] ;
	c[4] += - a[12] * b[5] + a[10] * b[6] - a[9] * b[7] - a[7] * b[9] + a[6] * b[10] - a[5] * b[12] ;
	c[5] += - a[14] * b[2] + a[13] * b[3] - a[12] * b[4] - a[4] * b[12] + a[3] * b[13] - a[2] * b[14] ;
	c[6] += + a[14] * b[1] - a[11] * b[3] + a[10] * b[4] + a[4] * b[10] - a[3] * b[11] + a[1] * b[14] ;
	c[7] += - a[13] * b[1] + a[11] * b[2] - a[9] * b[4] - a[4] * b[9] + a[2] * b[11] - a[1] * b[13] ;
	c[8] += + a[12] * b[1] - a[10] * b[2] + a[9] * b[3] + a[3] * b[9] - a[2] * b[10] + a[1] * b[12] ;
	c[9] += - a[14] * b[0] + a[8] * b[3] - a[7] * b[4] - a[4] * b[7] + a[3] * b[8] - a[0] * b[14] ;
	c[10] += + a[13] * b[0] - a[8] * b[2] + a[6] * b[4] + a[4] * b[6] - a[2] * b[8] + a[0] * b[13] ;
	c[11] += - a[12] * b[0] + a[7] * b[2] - a[6] * b[3] - a[3] * b[6] + a[2] * b[7] - a[0] * b[12] ;
	c[12] += - a[11] * b[0] + a[8] * b[1] - a[5] * b[4] - a[4] * b[5] + a[1] * b[8] - a[0] * b[11] ;
	c[13] += + a[10] * b[0] - a[7] * b[1] + a[5] * b[3] + a[3] * b[5] - a[1] * b[7] + a[0] * b[10] ;
	c[14] += - a[9] * b[0] + a[6] * b[1] - a[5] * b[2] - a[2] * b[5] + a[1] * b[6] - a[0] * b[9] ;
}

void i2gai_pp_04_03_05_m1(const double *a, const double *b, double *c) {
	c[0] += + a[19] * b[2] - a[18] * b[3] + a[17] * b[4] - a[16] * b[5] ;
	c[1] += - a[19] * b[1] + a[15] * b[3] - a[14] * b[4] + a[13] * b[5] ;
	c[2] += + a[18] * b[1] - a[15] * b[2] + a[12] * b[4] - a[11] * b[5] ;
	c[3] += - a[17] * b[1] + a[14] * b[2] - a[12] * b[3] + a[10] * b[5] ;
	c[4] += + a[16] * b[1] - a[13] * b[2] + a[11] * b[3] - a[10] * b[4] ;
	c[5] += + a[19] * b[0] - a[9] * b[3] + a[8] * b[4] - a[7] * b[5] ;
	c[6] += - a[18] * b[0] + a[9] * b[2] - a[6] * b[4] + a[5] * b[5] ;
	c[7] += + a[17] * b[0] - a[8] * b[2] + a[6] * b[3] - a[4] * b[5] ;
	c[8] += - a[16] * b[0] + a[7] * b[2] - a[5] * b[3] + a[4] * b[4] ;
	c[9] += + a[15] * b[0] - a[9] * b[1] + a[3] * b[4] - a[2] * b[5] ;
	c[10] += - a[14] * b[0] + a[8] * b[1] - a[3] * b[3] + a[1] * b[5] ;
	c[11] += + a[13] * b[0] - a[7] * b[1] + a[2] * b[3] - a[1] * b[4] ;
	c[12] += + a[12] * b[0] - a[6] * b[1] + a[3] * b[2] - a[0] * b[5] ;
	c[13] += - a[11] * b[0] + a[5] * b[1] - a[2] * b[2] + a[0] * b[4] ;
	c[14] += + a[10] * b[0] - a[4] * b[1] + a[1] * b[2] - a[0] * b[3] ;
}

void i2gai_pp_04_02_06_m1(const double *a, const double *b, double *c) {
	c[0] += - a[14] * b[0] ;
	c[1] += + a[13] * b[0] ;
	c[2] += - a[12] * b[0] ;
	c[3] += + a[11] * b[0] ;
	c[4] += - a[10] * b[0] ;
	c[5] += - a[9] * b[0] ;
	c[6] += + a[8] * b[0] ;
	c[7] += - a[7] * b[0] ;
	c[8] += + a[6] * b[0] ;
	c[9] += - a[5] * b[0] ;
	c[10] += + a[4] * b[0] ;
	c[11] += - a[3] * b[0] ;
	c[12] += - a[2] * b[0] ;
	c[13] += + a[1] * b[0] ;
	c[14] += - a[0] * b[0] ;
}

void i2gai_pp_05_05_00_m1(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[0] ;
	c[1] += + a[1] * b[0] ;
	c[2] += + a[2] * b[0] ;
	c[3] += + a[3] * b[0] ;
	c[4] += + a[4] * b[0] ;
	c[5] += + a[5] * b[0] ;
}

void i2gai_pp_05_04_01_m1(const double *a, const double *b, double *c) {
	c[0] += + a[4] * b[0] - a[3] * b[1] + a[2] * b[2] - a[1] * b[3] + a[0] * b[4] ;
	c[1] += + a[8] * b[0] - a[7] * b[1] + a[6] * b[2] - a[5] * b[3] + a[0] * b[5] ;
	c[2] += + a[11] * b[0] - a[10] * b[1] + a[9] * b[2] - a[5] * b[4] + a[1] * b[5] ;
	c[3] += + a[13] * b[0] - a[12] * b[1] + a[9] * b[3] - a[6] * b[4] + a[2] * b[5] ;
	c[4] += + a[14] * b[0] - a[12] * b[2] + a[10] * b[3] - a[7] * b[4] + a[3] * b[5] ;
	c[5] += + a[14] * b[1] - a[13] * b[2] + a[11] * b[3] - a[8] * b[4] + a[4] * b[5] ;
}

void i2gai_pp_05_03_02_m1(const double *a, const double *b, double *c) {
	c[0] += + a[9] * b[0] - a[8] * b[1] + a[7] * b[2] + a[6] * b[3] - a[5] * b[4] + a[4] * b[5] - a[3] * b[6] + a[2] * b[7] - a[1] * b[8] + a[0] * b[9] ;
	c[1] += + a[15] * b[0] - a[14] * b[1] + a[13] * b[2] + a[12] * b[3] - a[11] * b[4] + a[10] * b[5] - a[3] * b[10] + a[2] * b[11] - a[1] * b[12] + a[0] * b[13] ;
	c[2] += + a[18] * b[0] - a[17] * b[1] + a[16] * b[2] + a[12] * b[6] - a[11] * b[7] + a[10] * b[8] - a[6] * b[10] + a[5] * b[11] - a[4] * b[12] + a[0] * b[14] ;
	c[3] += + a[19] * b[0] - a[17] * b[3] + a[16] * b[4] + a[14] * b[6] - a[13] * b[7] + a[10] * b[9] - a[8] * b[10] + a[7] * b[11] - a[4] * b[13] + a[1] * b[14] ;
	c[4] += + a[19] * b[1] - a[18] * b[3] + a[16] * b[5] + a[15] * b[6] - a[13] * b[8] + a[11] * b[9] - a[9] * b[10] + a[7] * b[12] - a[5] * b[13] + a[2] * b[14] ;
	c[5] += + a[19] * b[2] - a[18] * b[4] + a[17] * b[5] + a[15] * b[7] - a[14] * b[8] + a[12] * b[9] - a[9] * b[11] + a[8] * b[12] - a[6] * b[13] + a[3] * b[14] ;
}

void i2gai_pp_05_02_03_m1(const double *a, const double *b, double *c) {
	c[0] += + a[9] * b[0] - a[8] * b[1] + a[7] * b[2] - a[6] * b[3] + a[5] * b[4] - a[4] * b[5] + a[3] * b[6] + a[2] * b[7] - a[1] * b[8] + a[0] * b[9] ;
	c[1] += + a[13] * b[0] - a[12] * b[1] + a[11] * b[2] - a[10] * b[3] + a[5] * b[10] - a[4] * b[11] + a[3] * b[12] + a[2] * b[13] - a[1] * b[14] + a[0] * b[15] ;
	c[2] += + a[14] * b[0] - a[12] * b[4] + a[11] * b[5] - a[10] * b[6] + a[8] * b[10] - a[7] * b[11] + a[6] * b[12] + a[2] * b[16] - a[1] * b[17] + a[0] * b[18] ;
	c[3] += + a[14] * b[1] - a[13] * b[4] + a[11] * b[7] - a[10] * b[8] + a[9] * b[10] - a[7] * b[13] + a[6] * b[14] + a[4] * b[16] - a[3] * b[17] + a[0] * b[19] ;
	c[4] += + a[14] * b[2] - a[13] * b[5] + a[12] * b[7] - a[10] * b[9] + a[9] * b[11] - a[8] * b[13] + a[6] * b[15] + a[5] * b[16] - a[3] * b[18] + a[1] * b[19] ;
	c[5] += + a[14] * b[3] - a[13] * b[6] + a[12] * b[8] - a[11] * b[9] + a[9] * b[12] - a[8] * b[14] + a[7] * b[15] + a[5] * b[17] - a[4] * b[18] + a[2] * b[19] ;
}

void i2gai_pp_05_01_04_m1(const double *a, const double *b, double *c) {
	c[0] += + a[4] * b[0] - a[3] * b[1] + a[2] * b[2] - a[1] * b[3] + a[0] * b[4] ;
	c[1] += + a[5] * b[0] - a[3] * b[5] + a[2] * b[6] - a[1] * b[7] + a[0] * b[8] ;
	c[2] += + a[5] * b[1] - a[4] * b[5] + a[2] * b[9] - a[1] * b[10] + a[0] * b[11] ;
	c[3] += + a[5] * b[2] - a[4] * b[6] + a[3] * b[9] - a[1] * b[12] + a[0] * b[13] ;
	c[4] += + a[5] * b[3] - a[4] * b[7] + a[3] * b[10] - a[2] * b[12] + a[0] * b[14] ;
	c[5] += + a[5] * b[4] - a[4] * b[8] + a[3] * b[11] - a[2] * b[13] + a[1] * b[14] ;
}

void i2gai_pp_05_00_05_m1(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[0] ;
	c[1] += + a[0] * b[1] ;
	c[2] += + a[0] * b[2] ;
	c[3] += + a[0] * b[3] ;
	c[4] += + a[0] * b[4] ;
	c[5] += + a[0] * b[5] ;
}

void i2gai_pp_05_06_01_m1(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[5] ;
	c[1] += - a[0] * b[4] ;
	c[2] += + a[0] * b[3] ;
	c[3] += - a[0] * b[2] ;
	c[4] += + a[0] * b[1] ;
	c[5] += - a[0] * b[0] ;
}

void i2gai_pp_05_05_02_m1(const double *a, const double *b, double *c) {
	c[0] += - a[5] * b[10] + a[4] * b[11] - a[3] * b[12] + a[2] * b[13] - a[1] * b[14] ;
	c[1] += + a[5] * b[6] - a[4] * b[7] + a[3] * b[8] - a[2] * b[9] + a[0] * b[14] ;
	c[2] += - a[5] * b[3] + a[4] * b[4] - a[3] * b[5] + a[1] * b[9] - a[0] * b[13] ;
	c[3] += + a[5] * b[1] - a[4] * b[2] + a[2] * b[5] - a[1] * b[8] + a[0] * b[12] ;
	c[4] += - a[5] * b[0] + a[3] * b[2] - a[2] * b[4] + a[1] * b[7] - a[0] * b[11] ;
	c[5] += + a[4] * b[0] - a[3] * b[1] + a[2] * b[3] - a[1] * b[6] + a[0] * b[10] ;
}

void i2gai_pp_05_04_03_m1(const double *a, const double *b, double *c) {
	c[0] += + a[14] * b[10] - a[13] * b[11] + a[12] * b[12] + a[11] * b[13] - a[10] * b[14] + a[9] * b[15] - a[8] * b[16] + a[7] * b[17] - a[6] * b[18] + a[5] * b[19] ;
	c[1] += - a[14] * b[4] + a[13] * b[5] - a[12] * b[6] - a[11] * b[7] + a[10] * b[8] - a[9] * b[9] + a[4] * b[16] - a[3] * b[17] + a[2] * b[18] - a[1] * b[19] ;
	c[2] += + a[14] * b[1] - a[13] * b[2] + a[12] * b[3] + a[8] * b[7] - a[7] * b[8] + a[6] * b[9] - a[4] * b[13] + a[3] * b[14] - a[2] * b[15] + a[0] * b[19] ;
	c[3] += - a[14] * b[0] + a[11] * b[2] - a[10] * b[3] - a[8] * b[5] + a[7] * b[6] - a[5] * b[9] + a[4] * b[11] - a[3] * b[12] + a[1] * b[15] - a[0] * b[18] ;
	c[4] += + a[13] * b[0] - a[11] * b[1] + a[9] * b[3] + a[8] * b[4] - a[6] * b[6] + a[5] * b[8] - a[4] * b[10] + a[2] * b[12] - a[1] * b[14] + a[0] * b[17] ;
	c[5] += - a[12] * b[0] + a[10] * b[1] - a[9] * b[2] - a[7] * b[4] + a[6] * b[5] - a[5] * b[7] + a[3] * b[10] - a[2] * b[11] + a[1] * b[13] - a[0] * b[16] ;
}

void i2gai_pp_05_03_04_m1(const double *a, const double *b, double *c) {
	c[0] += - a[19] * b[5] + a[18] * b[6] - a[17] * b[7] + a[16] * b[8] - a[15] * b[9] + a[14] * b[10] - a[13] * b[11] - a[12] * b[12] + a[11] * b[13] - a[10] * b[14] ;
	c[1] += + a[19] * b[1] - a[18] * b[2] + a[17] * b[3] - a[16] * b[4] + a[9] * b[9] - a[8] * b[10] + a[7] * b[11] + a[6] * b[12] - a[5] * b[13] + a[4] * b[14] ;
	c[2] += - a[19] * b[0] + a[15] * b[2] - a[14] * b[3] + a[13] * b[4] - a[9] * b[6] + a[8] * b[7] - a[7] * b[8] - a[3] * b[12] + a[2] * b[13] - a[1] * b[14] ;
	c[3] += + a[18] * b[0] - a[15] * b[1] + a[12] * b[3] - a[11] * b[4] + a[9] * b[5] - a[6] * b[7] + a[5] * b[8] + a[3] * b[10] - a[2] * b[11] + a[0] * b[14] ;
	c[4] += - a[17] * b[0] + a[14] * b[1] - a[12] * b[2] + a[10] * b[4] - a[8] * b[5] + a[6] * b[6] - a[4] * b[8] - a[3] * b[9] + a[1] * b[11] - a[0] * b[13] ;
	c[5] += + a[16] * b[0] - a[13] * b[1] + a[11] * b[2] - a[10] * b[3] + a[7] * b[5] - a[5] * b[6] + a[4] * b[7] + a[2] * b[9] - a[1] * b[10] + a[0] * b[12] ;
}

void i2gai_pp_05_02_05_m1(const double *a, const double *b, double *c) {
	c[0] += + a[14] * b[1] - a[13] * b[2] + a[12] * b[3] - a[11] * b[4] + a[10] * b[5] ;
	c[1] += - a[14] * b[0] + a[9] * b[2] - a[8] * b[3] + a[7] * b[4] - a[6] * b[5] ;
	c[2] += + a[13] * b[0] - a[9] * b[1] + a[5] * b[3] - a[4] * b[4] + a[3] * b[5] ;
	c[3] += - a[12] * b[0] + a[8] * b[1] - a[5] * b[2] + a[2] * b[4] - a[1] * b[5] ;
	c[4] += + a[11] * b[0] - a[7] * b[1] + a[4] * b[2] - a[2] * b[3] + a[0] * b[5] ;
	c[5] += - a[10] * b[0] + a[6] * b[1] - a[3] * b[2] + a[1] * b[3] - a[0] * b[4] ;
}

void i2gai_pp_05_01_06_m1(const double *a, const double *b, double *c) {
	c[0] += - a[5] * b[0] ;
	c[1] += + a[4] * b[0] ;
	c[2] += - a[3] * b[0] ;
	c[3] += + a[2] * b[0] ;
	c[4] += - a[1] * b[0] ;
	c[5] += + a[0] * b[0] ;
}

void i2gai_pp_06_06_00_m1(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[0] ;
}

void i2gai_pp_06_05_01_m1(const double *a, const double *b, double *c) {
	c[0] += - a[5] * b[0] + a[4] * b[1] - a[3] * b[2] + a[2] * b[3] - a[1] * b[4] + a[0] * b[5] ;
}

void i2gai_pp_06_04_02_m1(const double *a, const double *b, double *c) {
	c[0] += + a[14] * b[0] - a[13] * b[1] + a[12] * b[2] + a[11] * b[3] - a[10] * b[4] + a[9] * b[5] - a[8] * b[6] + a[7] * b[7] - a[6] * b[8] + a[5] * b[9] + a[4] * b[10] - a[3] * b[11] + a[2] * b[12] - a[1] * b[13] + a[0] * b[14] ;
}

void i2gai_pp_06_03_03_m1(const double *a, const double *b, double *c) {
	c[0] += - a[19] * b[0] + a[18] * b[1] - a[17] * b[2] + a[16] * b[3] - a[15] * b[4] + a[14] * b[5] - a[13] * b[6] - a[12] * b[7] + a[11] * b[8] - a[10] * b[9] + a[9] * b[10] - a[8] * b[11] + a[7] * b[12] + a[6] * b[13] - a[5] * b[14] + a[4] * b[15] - a[3] * b[16] + a[2] * b[17] - a[1] * b[18] + a[0] * b[19] ;
}

void i2gai_pp_06_02_04_m1(const double *a, const double *b, double *c) {
	c[0] += + a[14] * b[0] - a[13] * b[1] + a[12] * b[2] - a[11] * b[3] + a[10] * b[4] + a[9] * b[5] - a[8] * b[6] + a[7] * b[7] - a[6] * b[8] + a[5] * b[9] - a[4] * b[10] + a[3] * b[11] + a[2] * b[12] - a[1] * b[13] + a[0] * b[14] ;
}

void i2gai_pp_06_01_05_m1(const double *a, const double *b, double *c) {
	c[0] += - a[5] * b[0] + a[4] * b[1] - a[3] * b[2] + a[2] * b[3] - a[1] * b[4] + a[0] * b[5] ;
}

void i2gai_pp_06_00_06_m1(const double *a, const double *b, double *c) {
	c[0] += + a[0] * b[0] ;
}

void i2gai_general_gp(const double *a[], const double *b[], double *c) {
	const double *an, *bn;
	i2gai_null(c, 64);
	if (an = a[0]) {
		if (bn = b[0]) {
			i2gai_pp_00_00_00_m0(an, bn, c + 0);
		}
		if (bn = b[1]) {
			i2gai_pp_01_00_01_m0(an, bn, c + 1);
		}
		if (bn = b[2]) {
			i2gai_pp_02_00_02_m0(an, bn, c + 7);
		}
		if (bn = b[3]) {
			i2gai_pp_03_00_03_m0(an, bn, c + 22);
		}
		if (bn = b[4]) {
			i2gai_pp_04_00_04_m0(an, bn, c + 42);
		}
		if (bn = b[5]) {
			i2gai_pp_05_00_05_m0(an, bn, c + 57);
		}
		if (bn = b[6]) {
			i2gai_pp_06_00_06_m0(an, bn, c + 63);
		}
	}
	if (an = a[1]) {
		if (bn = b[0]) {
			i2gai_pp_01_01_00_m0(an, bn, c + 1);
		}
		if (bn = b[1]) {
			i2gai_pp_00_01_01_m0(an, bn, c + 0);
			i2gai_pp_02_01_01_m0(an, bn, c + 7);
		}
		if (bn = b[2]) {
			i2gai_pp_01_01_02_m0(an, bn, c + 1);
			i2gai_pp_03_01_02_m0(an, bn, c + 22);
		}
		if (bn = b[3]) {
			i2gai_pp_02_01_03_m0(an, bn, c + 7);
			i2gai_pp_04_01_03_m0(an, bn, c + 42);
		}
		if (bn = b[4]) {
			i2gai_pp_03_01_04_m0(an, bn, c + 22);
			i2gai_pp_05_01_04_m0(an, bn, c + 57);
		}
		if (bn = b[5]) {
			i2gai_pp_04_01_05_m0(an, bn, c + 42);
			i2gai_pp_06_01_05_m0(an, bn, c + 63);
		}
		if (bn = b[6]) {
			i2gai_pp_05_01_06_m0(an, bn, c + 57);
		}
	}
	if (an = a[2]) {
		if (bn = b[0]) {
			i2gai_pp_02_02_00_m0(an, bn, c + 7);
		}
		if (bn = b[1]) {
			i2gai_pp_01_02_01_m0(an, bn, c + 1);
			i2gai_pp_03_02_01_m0(an, bn, c + 22);
		}
		if (bn = b[2]) {
			i2gai_pp_00_02_02_m0(an, bn, c + 0);
			i2gai_pp_02_02_02_m0(an, bn, c + 7);
			i2gai_pp_04_02_02_m0(an, bn, c + 42);
		}
		if (bn = b[3]) {
			i2gai_pp_01_02_03_m0(an, bn, c + 1);
			i2gai_pp_03_02_03_m0(an, bn, c + 22);
			i2gai_pp_05_02_03_m0(an, bn, c + 57);
		}
		if (bn = b[4]) {
			i2gai_pp_02_02_04_m0(an, bn, c + 7);
			i2gai_pp_04_02_04_m0(an, bn, c + 42);
			i2gai_pp_06_02_04_m0(an, bn, c + 63);
		}
		if (bn = b[5]) {
			i2gai_pp_03_02_05_m0(an, bn, c + 22);
			i2gai_pp_05_02_05_m0(an, bn, c + 57);
		}
		if (bn = b[6]) {
			i2gai_pp_04_02_06_m0(an, bn, c + 42);
		}
	}
	if (an = a[3]) {
		if (bn = b[0]) {
			i2gai_pp_03_03_00_m0(an, bn, c + 22);
		}
		if (bn = b[1]) {
			i2gai_pp_02_03_01_m0(an, bn, c + 7);
			i2gai_pp_04_03_01_m0(an, bn, c + 42);
		}
		if (bn = b[2]) {
			i2gai_pp_01_03_02_m0(an, bn, c + 1);
			i2gai_pp_03_03_02_m0(an, bn, c + 22);
			i2gai_pp_05_03_02_m0(an, bn, c + 57);
		}
		if (bn = b[3]) {
			i2gai_pp_00_03_03_m0(an, bn, c + 0);
			i2gai_pp_02_03_03_m0(an, bn, c + 7);
			i2gai_pp_04_03_03_m0(an, bn, c + 42);
			i2gai_pp_06_03_03_m0(an, bn, c + 63);
		}
		if (bn = b[4]) {
			i2gai_pp_01_03_04_m0(an, bn, c + 1);
			i2gai_pp_03_03_04_m0(an, bn, c + 22);
			i2gai_pp_05_03_04_m0(an, bn, c + 57);
		}
		if (bn = b[5]) {
			i2gai_pp_02_03_05_m0(an, bn, c + 7);
			i2gai_pp_04_03_05_m0(an, bn, c + 42);
		}
		if (bn = b[6]) {
			i2gai_pp_03_03_06_m0(an, bn, c + 22);
		}
	}
	if (an = a[4]) {
		if (bn = b[0]) {
			i2gai_pp_04_04_00_m0(an, bn, c + 42);
		}
		if (bn = b[1]) {
			i2gai_pp_03_04_01_m0(an, bn, c + 22);
			i2gai_pp_05_04_01_m0(an, bn, c + 57);
		}
		if (bn = b[2]) {
			i2gai_pp_02_04_02_m0(an, bn, c + 7);
			i2gai_pp_04_04_02_m0(an, bn, c + 42);
			i2gai_pp_06_04_02_m0(an, bn, c + 63);
		}
		if (bn = b[3]) {
			i2gai_pp_01_04_03_m0(an, bn, c + 1);
			i2gai_pp_03_04_03_m0(an, bn, c + 22);
			i2gai_pp_05_04_03_m0(an, bn, c + 57);
		}
		if (bn = b[4]) {
			i2gai_pp_00_04_04_m0(an, bn, c + 0);
			i2gai_pp_02_04_04_m0(an, bn, c + 7);
			i2gai_pp_04_04_04_m0(an, bn, c + 42);
		}
		if (bn = b[5]) {
			i2gai_pp_01_04_05_m0(an, bn, c + 1);
			i2gai_pp_03_04_05_m0(an, bn, c + 22);
		}
		if (bn = b[6]) {
			i2gai_pp_02_04_06_m0(an, bn, c + 7);
		}
	}
	if (an = a[5]) {
		if (bn = b[0]) {
			i2gai_pp_05_05_00_m0(an, bn, c + 57);
		}
		if (bn = b[1]) {
			i2gai_pp_04_05_01_m0(an, bn, c + 42);
			i2gai_pp_06_05_01_m0(an, bn, c + 63);
		}
		if (bn = b[2]) {
			i2gai_pp_03_05_02_m0(an, bn, c + 22);
			i2gai_pp_05_05_02_m0(an, bn, c + 57);
		}
		if (bn = b[3]) {
			i2gai_pp_02_05_03_m0(an, bn, c + 7);
			i2gai_pp_04_05_03_m0(an, bn, c + 42);
		}
		if (bn = b[4]) {
			i2gai_pp_01_05_04_m0(an, bn, c + 1);
			i2gai_pp_03_05_04_m0(an, bn, c + 22);
		}
		if (bn = b[5]) {
			i2gai_pp_00_05_05_m0(an, bn, c + 0);
			i2gai_pp_02_05_05_m0(an, bn, c + 7);
		}
		if (bn = b[6]) {
			i2gai_pp_01_05_06_m0(an, bn, c + 1);
		}
	}
	if (an = a[6]) {
		if (bn = b[0]) {
			i2gai_pp_06_06_00_m0(an, bn, c + 63);
		}
		if (bn = b[1]) {
			i2gai_pp_05_06_01_m0(an, bn, c + 57);
		}
		if (bn = b[2]) {
			i2gai_pp_04_06_02_m0(an, bn, c + 42);
		}
		if (bn = b[3]) {
			i2gai_pp_03_06_03_m0(an, bn, c + 22);
		}
		if (bn = b[4]) {
			i2gai_pp_02_06_04_m0(an, bn, c + 7);
		}
		if (bn = b[5]) {
			i2gai_pp_01_06_05_m0(an, bn, c + 1);
		}
		if (bn = b[6]) {
			i2gai_pp_00_06_06_m0(an, bn, c + 0);
		}
	}
}

void i2gai_general_hip(const double *a[], const double *b[], double *c) {
	const double *an, *bn;
	i2gai_null(c, 64);
	if (an = a[0]) {
	}
	if (an = a[1]) {
		if (bn = b[1]) {
			i2gai_pp_00_01_01_m0(an, bn, c + 0);
		}
		if (bn = b[2]) {
			i2gai_pp_01_01_02_m0(an, bn, c + 1);
		}
		if (bn = b[3]) {
			i2gai_pp_02_01_03_m0(an, bn, c + 7);
		}
		if (bn = b[4]) {
			i2gai_pp_03_01_04_m0(an, bn, c + 22);
		}
		if (bn = b[5]) {
			i2gai_pp_04_01_05_m0(an, bn, c + 42);
		}
		if (bn = b[6]) {
			i2gai_pp_05_01_06_m0(an, bn, c + 57);
		}
	}
	if (an = a[2]) {
		if (bn = b[1]) {
			i2gai_pp_01_02_01_m0(an, bn, c + 1);
		}
		if (bn = b[2]) {
			i2gai_pp_00_02_02_m0(an, bn, c + 0);
		}
		if (bn = b[3]) {
			i2gai_pp_01_02_03_m0(an, bn, c + 1);
		}
		if (bn = b[4]) {
			i2gai_pp_02_02_04_m0(an, bn, c + 7);
		}
		if (bn = b[5]) {
			i2gai_pp_03_02_05_m0(an, bn, c + 22);
		}
		if (bn = b[6]) {
			i2gai_pp_04_02_06_m0(an, bn, c + 42);
		}
	}
	if (an = a[3]) {
		if (bn = b[1]) {
			i2gai_pp_02_03_01_m0(an, bn, c + 7);
		}
		if (bn = b[2]) {
			i2gai_pp_01_03_02_m0(an, bn, c + 1);
		}
		if (bn = b[3]) {
			i2gai_pp_00_03_03_m0(an, bn, c + 0);
		}
		if (bn = b[4]) {
			i2gai_pp_01_03_04_m0(an, bn, c + 1);
		}
		if (bn = b[5]) {
			i2gai_pp_02_03_05_m0(an, bn, c + 7);
		}
		if (bn = b[6]) {
			i2gai_pp_03_03_06_m0(an, bn, c + 22);
		}
	}
	if (an = a[4]) {
		if (bn = b[1]) {
			i2gai_pp_03_04_01_m0(an, bn, c + 22);
		}
		if (bn = b[2]) {
			i2gai_pp_02_04_02_m0(an, bn, c + 7);
		}
		if (bn = b[3]) {
			i2gai_pp_01_04_03_m0(an, bn, c + 1);
		}
		if (bn = b[4]) {
			i2gai_pp_00_04_04_m0(an, bn, c + 0);
		}
		if (bn = b[5]) {
			i2gai_pp_01_04_05_m0(an, bn, c + 1);
		}
		if (bn = b[6]) {
			i2gai_pp_02_04_06_m0(an, bn, c + 7);
		}
	}
	if (an = a[5]) {
		if (bn = b[1]) {
			i2gai_pp_04_05_01_m0(an, bn, c + 42);
		}
		if (bn = b[2]) {
			i2gai_pp_03_05_02_m0(an, bn, c + 22);
		}
		if (bn = b[3]) {
			i2gai_pp_02_05_03_m0(an, bn, c + 7);
		}
		if (bn = b[4]) {
			i2gai_pp_01_05_04_m0(an, bn, c + 1);
		}
		if (bn = b[5]) {
			i2gai_pp_00_05_05_m0(an, bn, c + 0);
		}
		if (bn = b[6]) {
			i2gai_pp_01_05_06_m0(an, bn, c + 1);
		}
	}
	if (an = a[6]) {
		if (bn = b[1]) {
			i2gai_pp_05_06_01_m0(an, bn, c + 57);
		}
		if (bn = b[2]) {
			i2gai_pp_04_06_02_m0(an, bn, c + 42);
		}
		if (bn = b[3]) {
			i2gai_pp_03_06_03_m0(an, bn, c + 22);
		}
		if (bn = b[4]) {
			i2gai_pp_02_06_04_m0(an, bn, c + 7);
		}
		if (bn = b[5]) {
			i2gai_pp_01_06_05_m0(an, bn, c + 1);
		}
		if (bn = b[6]) {
			i2gai_pp_00_06_06_m0(an, bn, c + 0);
		}
	}
}

void i2gai_general_mhip(const double *a[], const double *b[], double *c) {
	const double *an, *bn;
	i2gai_null(c, 64);
	if (an = a[0]) {
		if (bn = b[0]) {
			i2gai_pp_00_00_00_m0(an, bn, c + 0);
		}
		if (bn = b[1]) {
			i2gai_pp_01_00_01_m0(an, bn, c + 1);
		}
		if (bn = b[2]) {
			i2gai_pp_02_00_02_m0(an, bn, c + 7);
		}
		if (bn = b[3]) {
			i2gai_pp_03_00_03_m0(an, bn, c + 22);
		}
		if (bn = b[4]) {
			i2gai_pp_04_00_04_m0(an, bn, c + 42);
		}
		if (bn = b[5]) {
			i2gai_pp_05_00_05_m0(an, bn, c + 57);
		}
		if (bn = b[6]) {
			i2gai_pp_06_00_06_m0(an, bn, c + 63);
		}
	}
	if (an = a[1]) {
		if (bn = b[0]) {
			i2gai_pp_01_01_00_m0(an, bn, c + 1);
		}
		if (bn = b[1]) {
			i2gai_pp_00_01_01_m0(an, bn, c + 0);
		}
		if (bn = b[2]) {
			i2gai_pp_01_01_02_m0(an, bn, c + 1);
		}
		if (bn = b[3]) {
			i2gai_pp_02_01_03_m0(an, bn, c + 7);
		}
		if (bn = b[4]) {
			i2gai_pp_03_01_04_m0(an, bn, c + 22);
		}
		if (bn = b[5]) {
			i2gai_pp_04_01_05_m0(an, bn, c + 42);
		}
		if (bn = b[6]) {
			i2gai_pp_05_01_06_m0(an, bn, c + 57);
		}
	}
	if (an = a[2]) {
		if (bn = b[0]) {
			i2gai_pp_02_02_00_m0(an, bn, c + 7);
		}
		if (bn = b[1]) {
			i2gai_pp_01_02_01_m0(an, bn, c + 1);
		}
		if (bn = b[2]) {
			i2gai_pp_00_02_02_m0(an, bn, c + 0);
		}
		if (bn = b[3]) {
			i2gai_pp_01_02_03_m0(an, bn, c + 1);
		}
		if (bn = b[4]) {
			i2gai_pp_02_02_04_m0(an, bn, c + 7);
		}
		if (bn = b[5]) {
			i2gai_pp_03_02_05_m0(an, bn, c + 22);
		}
		if (bn = b[6]) {
			i2gai_pp_04_02_06_m0(an, bn, c + 42);
		}
	}
	if (an = a[3]) {
		if (bn = b[0]) {
			i2gai_pp_03_03_00_m0(an, bn, c + 22);
		}
		if (bn = b[1]) {
			i2gai_pp_02_03_01_m0(an, bn, c + 7);
		}
		if (bn = b[2]) {
			i2gai_pp_01_03_02_m0(an, bn, c + 1);
		}
		if (bn = b[3]) {
			i2gai_pp_00_03_03_m0(an, bn, c + 0);
		}
		if (bn = b[4]) {
			i2gai_pp_01_03_04_m0(an, bn, c + 1);
		}
		if (bn = b[5]) {
			i2gai_pp_02_03_05_m0(an, bn, c + 7);
		}
		if (bn = b[6]) {
			i2gai_pp_03_03_06_m0(an, bn, c + 22);
		}
	}
	if (an = a[4]) {
		if (bn = b[0]) {
			i2gai_pp_04_04_00_m0(an, bn, c + 42);
		}
		if (bn = b[1]) {
			i2gai_pp_03_04_01_m0(an, bn, c + 22);
		}
		if (bn = b[2]) {
			i2gai_pp_02_04_02_m0(an, bn, c + 7);
		}
		if (bn = b[3]) {
			i2gai_pp_01_04_03_m0(an, bn, c + 1);
		}
		if (bn = b[4]) {
			i2gai_pp_00_04_04_m0(an, bn, c + 0);
		}
		if (bn = b[5]) {
			i2gai_pp_01_04_05_m0(an, bn, c + 1);
		}
		if (bn = b[6]) {
			i2gai_pp_02_04_06_m0(an, bn, c + 7);
		}
	}
	if (an = a[5]) {
		if (bn = b[0]) {
			i2gai_pp_05_05_00_m0(an, bn, c + 57);
		}
		if (bn = b[1]) {
			i2gai_pp_04_05_01_m0(an, bn, c + 42);
		}
		if (bn = b[2]) {
			i2gai_pp_03_05_02_m0(an, bn, c + 22);
		}
		if (bn = b[3]) {
			i2gai_pp_02_05_03_m0(an, bn, c + 7);
		}
		if (bn = b[4]) {
			i2gai_pp_01_05_04_m0(an, bn, c + 1);
		}
		if (bn = b[5]) {
			i2gai_pp_00_05_05_m0(an, bn, c + 0);
		}
		if (bn = b[6]) {
			i2gai_pp_01_05_06_m0(an, bn, c + 1);
		}
	}
	if (an = a[6]) {
		if (bn = b[0]) {
			i2gai_pp_06_06_00_m0(an, bn, c + 63);
		}
		if (bn = b[1]) {
			i2gai_pp_05_06_01_m0(an, bn, c + 57);
		}
		if (bn = b[2]) {
			i2gai_pp_04_06_02_m0(an, bn, c + 42);
		}
		if (bn = b[3]) {
			i2gai_pp_03_06_03_m0(an, bn, c + 22);
		}
		if (bn = b[4]) {
			i2gai_pp_02_06_04_m0(an, bn, c + 7);
		}
		if (bn = b[5]) {
			i2gai_pp_01_06_05_m0(an, bn, c + 1);
		}
		if (bn = b[6]) {
			i2gai_pp_00_06_06_m0(an, bn, c + 0);
		}
	}
}

void i2gai_general_lcont(const double *a[], const double *b[], double *c) {
	const double *an, *bn;
	i2gai_null(c, 64);
	if (an = a[0]) {
		if (bn = b[0]) {
			i2gai_pp_00_00_00_m0(an, bn, c + 0);
		}
		if (bn = b[1]) {
			i2gai_pp_01_00_01_m0(an, bn, c + 1);
		}
		if (bn = b[2]) {
			i2gai_pp_02_00_02_m0(an, bn, c + 7);
		}
		if (bn = b[3]) {
			i2gai_pp_03_00_03_m0(an, bn, c + 22);
		}
		if (bn = b[4]) {
			i2gai_pp_04_00_04_m0(an, bn, c + 42);
		}
		if (bn = b[5]) {
			i2gai_pp_05_00_05_m0(an, bn, c + 57);
		}
		if (bn = b[6]) {
			i2gai_pp_06_00_06_m0(an, bn, c + 63);
		}
	}
	if (an = a[1]) {
		if (bn = b[1]) {
			i2gai_pp_00_01_01_m0(an, bn, c + 0);
		}
		if (bn = b[2]) {
			i2gai_pp_01_01_02_m0(an, bn, c + 1);
		}
		if (bn = b[3]) {
			i2gai_pp_02_01_03_m0(an, bn, c + 7);
		}
		if (bn = b[4]) {
			i2gai_pp_03_01_04_m0(an, bn, c + 22);
		}
		if (bn = b[5]) {
			i2gai_pp_04_01_05_m0(an, bn, c + 42);
		}
		if (bn = b[6]) {
			i2gai_pp_05_01_06_m0(an, bn, c + 57);
		}
	}
	if (an = a[2]) {
		if (bn = b[2]) {
			i2gai_pp_00_02_02_m0(an, bn, c + 0);
		}
		if (bn = b[3]) {
			i2gai_pp_01_02_03_m0(an, bn, c + 1);
		}
		if (bn = b[4]) {
			i2gai_pp_02_02_04_m0(an, bn, c + 7);
		}
		if (bn = b[5]) {
			i2gai_pp_03_02_05_m0(an, bn, c + 22);
		}
		if (bn = b[6]) {
			i2gai_pp_04_02_06_m0(an, bn, c + 42);
		}
	}
	if (an = a[3]) {
		if (bn = b[3]) {
			i2gai_pp_00_03_03_m0(an, bn, c + 0);
		}
		if (bn = b[4]) {
			i2gai_pp_01_03_04_m0(an, bn, c + 1);
		}
		if (bn = b[5]) {
			i2gai_pp_02_03_05_m0(an, bn, c + 7);
		}
		if (bn = b[6]) {
			i2gai_pp_03_03_06_m0(an, bn, c + 22);
		}
	}
	if (an = a[4]) {
		if (bn = b[4]) {
			i2gai_pp_00_04_04_m0(an, bn, c + 0);
		}
		if (bn = b[5]) {
			i2gai_pp_01_04_05_m0(an, bn, c + 1);
		}
		if (bn = b[6]) {
			i2gai_pp_02_04_06_m0(an, bn, c + 7);
		}
	}
	if (an = a[5]) {
		if (bn = b[5]) {
			i2gai_pp_00_05_05_m0(an, bn, c + 0);
		}
		if (bn = b[6]) {
			i2gai_pp_01_05_06_m0(an, bn, c + 1);
		}
	}
	if (an = a[6]) {
		if (bn = b[6]) {
			i2gai_pp_00_06_06_m0(an, bn, c + 0);
		}
	}
}

void i2gai_general_rcont(const double *a[], const double *b[], double *c) {
	const double *an, *bn;
	i2gai_null(c, 64);
	if (an = a[0]) {
		if (bn = b[0]) {
			i2gai_pp_00_00_00_m0(an, bn, c + 0);
		}
	}
	if (an = a[1]) {
		if (bn = b[0]) {
			i2gai_pp_01_01_00_m0(an, bn, c + 1);
		}
		if (bn = b[1]) {
			i2gai_pp_00_01_01_m0(an, bn, c + 0);
		}
	}
	if (an = a[2]) {
		if (bn = b[0]) {
			i2gai_pp_02_02_00_m0(an, bn, c + 7);
		}
		if (bn = b[1]) {
			i2gai_pp_01_02_01_m0(an, bn, c + 1);
		}
		if (bn = b[2]) {
			i2gai_pp_00_02_02_m0(an, bn, c + 0);
		}
	}
	if (an = a[3]) {
		if (bn = b[0]) {
			i2gai_pp_03_03_00_m0(an, bn, c + 22);
		}
		if (bn = b[1]) {
			i2gai_pp_02_03_01_m0(an, bn, c + 7);
		}
		if (bn = b[2]) {
			i2gai_pp_01_03_02_m0(an, bn, c + 1);
		}
		if (bn = b[3]) {
			i2gai_pp_00_03_03_m0(an, bn, c + 0);
		}
	}
	if (an = a[4]) {
		if (bn = b[0]) {
			i2gai_pp_04_04_00_m0(an, bn, c + 42);
		}
		if (bn = b[1]) {
			i2gai_pp_03_04_01_m0(an, bn, c + 22);
		}
		if (bn = b[2]) {
			i2gai_pp_02_04_02_m0(an, bn, c + 7);
		}
		if (bn = b[3]) {
			i2gai_pp_01_04_03_m0(an, bn, c + 1);
		}
		if (bn = b[4]) {
			i2gai_pp_00_04_04_m0(an, bn, c + 0);
		}
	}
	if (an = a[5]) {
		if (bn = b[0]) {
			i2gai_pp_05_05_00_m0(an, bn, c + 57);
		}
		if (bn = b[1]) {
			i2gai_pp_04_05_01_m0(an, bn, c + 42);
		}
		if (bn = b[2]) {
			i2gai_pp_03_05_02_m0(an, bn, c + 22);
		}
		if (bn = b[3]) {
			i2gai_pp_02_05_03_m0(an, bn, c + 7);
		}
		if (bn = b[4]) {
			i2gai_pp_01_05_04_m0(an, bn, c + 1);
		}
		if (bn = b[5]) {
			i2gai_pp_00_05_05_m0(an, bn, c + 0);
		}
	}
	if (an = a[6]) {
		if (bn = b[0]) {
			i2gai_pp_06_06_00_m0(an, bn, c + 63);
		}
		if (bn = b[1]) {
			i2gai_pp_05_06_01_m0(an, bn, c + 57);
		}
		if (bn = b[2]) {
			i2gai_pp_04_06_02_m0(an, bn, c + 42);
		}
		if (bn = b[3]) {
			i2gai_pp_03_06_03_m0(an, bn, c + 22);
		}
		if (bn = b[4]) {
			i2gai_pp_02_06_04_m0(an, bn, c + 7);
		}
		if (bn = b[5]) {
			i2gai_pp_01_06_05_m0(an, bn, c + 1);
		}
		if (bn = b[6]) {
			i2gai_pp_00_06_06_m0(an, bn, c + 0);
		}
	}
}

void i2gai_general_op(const double *a[], const double *b[], double *c) {
	const double *an, *bn;
	i2gai_null(c, 64);
	if (an = a[0]) {
		if (bn = b[0]) {
			i2gai_pp_00_00_00_m0(an, bn, c + 0);
		}
		if (bn = b[1]) {
			i2gai_pp_01_00_01_m0(an, bn, c + 1);
		}
		if (bn = b[2]) {
			i2gai_pp_02_00_02_m0(an, bn, c + 7);
		}
		if (bn = b[3]) {
			i2gai_pp_03_00_03_m0(an, bn, c + 22);
		}
		if (bn = b[4]) {
			i2gai_pp_04_00_04_m0(an, bn, c + 42);
		}
		if (bn = b[5]) {
			i2gai_pp_05_00_05_m0(an, bn, c + 57);
		}
		if (bn = b[6]) {
			i2gai_pp_06_00_06_m0(an, bn, c + 63);
		}
	}
	if (an = a[1]) {
		if (bn = b[0]) {
			i2gai_pp_01_01_00_m0(an, bn, c + 1);
		}
		if (bn = b[1]) {
			i2gai_pp_02_01_01_m0(an, bn, c + 7);
		}
		if (bn = b[2]) {
			i2gai_pp_03_01_02_m0(an, bn, c + 22);
		}
		if (bn = b[3]) {
			i2gai_pp_04_01_03_m0(an, bn, c + 42);
		}
		if (bn = b[4]) {
			i2gai_pp_05_01_04_m0(an, bn, c + 57);
		}
		if (bn = b[5]) {
			i2gai_pp_06_01_05_m0(an, bn, c + 63);
		}
	}
	if (an = a[2]) {
		if (bn = b[0]) {
			i2gai_pp_02_02_00_m0(an, bn, c + 7);
		}
		if (bn = b[1]) {
			i2gai_pp_03_02_01_m0(an, bn, c + 22);
		}
		if (bn = b[2]) {
			i2gai_pp_04_02_02_m0(an, bn, c + 42);
		}
		if (bn = b[3]) {
			i2gai_pp_05_02_03_m0(an, bn, c + 57);
		}
		if (bn = b[4]) {
			i2gai_pp_06_02_04_m0(an, bn, c + 63);
		}
	}
	if (an = a[3]) {
		if (bn = b[0]) {
			i2gai_pp_03_03_00_m0(an, bn, c + 22);
		}
		if (bn = b[1]) {
			i2gai_pp_04_03_01_m0(an, bn, c + 42);
		}
		if (bn = b[2]) {
			i2gai_pp_05_03_02_m0(an, bn, c + 57);
		}
		if (bn = b[3]) {
			i2gai_pp_06_03_03_m0(an, bn, c + 63);
		}
	}
	if (an = a[4]) {
		if (bn = b[0]) {
			i2gai_pp_04_04_00_m0(an, bn, c + 42);
		}
		if (bn = b[1]) {
			i2gai_pp_05_04_01_m0(an, bn, c + 57);
		}
		if (bn = b[2]) {
			i2gai_pp_06_04_02_m0(an, bn, c + 63);
		}
	}
	if (an = a[5]) {
		if (bn = b[0]) {
			i2gai_pp_05_05_00_m0(an, bn, c + 57);
		}
		if (bn = b[1]) {
			i2gai_pp_06_05_01_m0(an, bn, c + 63);
		}
	}
	if (an = a[6]) {
		if (bn = b[0]) {
			i2gai_pp_06_06_00_m0(an, bn, c + 63);
		}
	}
}

void i2gai_general_scp(const double *a[], const double *b[], double *c) {
	const double *an, *bn;
	i2gai_null(c, 64);
	if (an = a[0]) {
		if (bn = b[0]) {
			i2gai_pp_00_00_00_m0(an, bn, c + 0);
		}
	}
	if (an = a[1]) {
		if (bn = b[1]) {
			i2gai_pp_00_01_01_m0(an, bn, c + 0);
		}
	}
	if (an = a[2]) {
		if (bn = b[2]) {
			i2gai_pp_00_02_02_m0(an, bn, c + 0);
		}
	}
	if (an = a[3]) {
		if (bn = b[3]) {
			i2gai_pp_00_03_03_m0(an, bn, c + 0);
		}
	}
	if (an = a[4]) {
		if (bn = b[4]) {
			i2gai_pp_00_04_04_m0(an, bn, c + 0);
		}
	}
	if (an = a[5]) {
		if (bn = b[5]) {
			i2gai_pp_00_05_05_m0(an, bn, c + 0);
		}
	}
	if (an = a[6]) {
		if (bn = b[6]) {
			i2gai_pp_00_06_06_m0(an, bn, c + 0);
		}
	}
}

void i2gai_general_gpem(const double *a[], const double *b[], double *c) {
	const double *an, *bn;
	i2gai_null(c, 64);
	if (an = a[0]) {
		if (bn = b[0]) {
			i2gai_pp_00_00_00_m1(an, bn, c + 0);
		}
		if (bn = b[1]) {
			i2gai_pp_01_00_01_m1(an, bn, c + 1);
		}
		if (bn = b[2]) {
			i2gai_pp_02_00_02_m1(an, bn, c + 7);
		}
		if (bn = b[3]) {
			i2gai_pp_03_00_03_m1(an, bn, c + 22);
		}
		if (bn = b[4]) {
			i2gai_pp_04_00_04_m1(an, bn, c + 42);
		}
		if (bn = b[5]) {
			i2gai_pp_05_00_05_m1(an, bn, c + 57);
		}
		if (bn = b[6]) {
			i2gai_pp_06_00_06_m1(an, bn, c + 63);
		}
	}
	if (an = a[1]) {
		if (bn = b[0]) {
			i2gai_pp_01_01_00_m1(an, bn, c + 1);
		}
		if (bn = b[1]) {
			i2gai_pp_00_01_01_m1(an, bn, c + 0);
			i2gai_pp_02_01_01_m1(an, bn, c + 7);
		}
		if (bn = b[2]) {
			i2gai_pp_01_01_02_m1(an, bn, c + 1);
			i2gai_pp_03_01_02_m1(an, bn, c + 22);
		}
		if (bn = b[3]) {
			i2gai_pp_02_01_03_m1(an, bn, c + 7);
			i2gai_pp_04_01_03_m1(an, bn, c + 42);
		}
		if (bn = b[4]) {
			i2gai_pp_03_01_04_m1(an, bn, c + 22);
			i2gai_pp_05_01_04_m1(an, bn, c + 57);
		}
		if (bn = b[5]) {
			i2gai_pp_04_01_05_m1(an, bn, c + 42);
			i2gai_pp_06_01_05_m1(an, bn, c + 63);
		}
		if (bn = b[6]) {
			i2gai_pp_05_01_06_m1(an, bn, c + 57);
		}
	}
	if (an = a[2]) {
		if (bn = b[0]) {
			i2gai_pp_02_02_00_m1(an, bn, c + 7);
		}
		if (bn = b[1]) {
			i2gai_pp_01_02_01_m1(an, bn, c + 1);
			i2gai_pp_03_02_01_m1(an, bn, c + 22);
		}
		if (bn = b[2]) {
			i2gai_pp_00_02_02_m1(an, bn, c + 0);
			i2gai_pp_02_02_02_m1(an, bn, c + 7);
			i2gai_pp_04_02_02_m1(an, bn, c + 42);
		}
		if (bn = b[3]) {
			i2gai_pp_01_02_03_m1(an, bn, c + 1);
			i2gai_pp_03_02_03_m1(an, bn, c + 22);
			i2gai_pp_05_02_03_m1(an, bn, c + 57);
		}
		if (bn = b[4]) {
			i2gai_pp_02_02_04_m1(an, bn, c + 7);
			i2gai_pp_04_02_04_m1(an, bn, c + 42);
			i2gai_pp_06_02_04_m1(an, bn, c + 63);
		}
		if (bn = b[5]) {
			i2gai_pp_03_02_05_m1(an, bn, c + 22);
			i2gai_pp_05_02_05_m1(an, bn, c + 57);
		}
		if (bn = b[6]) {
			i2gai_pp_04_02_06_m1(an, bn, c + 42);
		}
	}
	if (an = a[3]) {
		if (bn = b[0]) {
			i2gai_pp_03_03_00_m1(an, bn, c + 22);
		}
		if (bn = b[1]) {
			i2gai_pp_02_03_01_m1(an, bn, c + 7);
			i2gai_pp_04_03_01_m1(an, bn, c + 42);
		}
		if (bn = b[2]) {
			i2gai_pp_01_03_02_m1(an, bn, c + 1);
			i2gai_pp_03_03_02_m1(an, bn, c + 22);
			i2gai_pp_05_03_02_m1(an, bn, c + 57);
		}
		if (bn = b[3]) {
			i2gai_pp_00_03_03_m1(an, bn, c + 0);
			i2gai_pp_02_03_03_m1(an, bn, c + 7);
			i2gai_pp_04_03_03_m1(an, bn, c + 42);
			i2gai_pp_06_03_03_m1(an, bn, c + 63);
		}
		if (bn = b[4]) {
			i2gai_pp_01_03_04_m1(an, bn, c + 1);
			i2gai_pp_03_03_04_m1(an, bn, c + 22);
			i2gai_pp_05_03_04_m1(an, bn, c + 57);
		}
		if (bn = b[5]) {
			i2gai_pp_02_03_05_m1(an, bn, c + 7);
			i2gai_pp_04_03_05_m1(an, bn, c + 42);
		}
		if (bn = b[6]) {
			i2gai_pp_03_03_06_m1(an, bn, c + 22);
		}
	}
	if (an = a[4]) {
		if (bn = b[0]) {
			i2gai_pp_04_04_00_m1(an, bn, c + 42);
		}
		if (bn = b[1]) {
			i2gai_pp_03_04_01_m1(an, bn, c + 22);
			i2gai_pp_05_04_01_m1(an, bn, c + 57);
		}
		if (bn = b[2]) {
			i2gai_pp_02_04_02_m1(an, bn, c + 7);
			i2gai_pp_04_04_02_m1(an, bn, c + 42);
			i2gai_pp_06_04_02_m1(an, bn, c + 63);
		}
		if (bn = b[3]) {
			i2gai_pp_01_04_03_m1(an, bn, c + 1);
			i2gai_pp_03_04_03_m1(an, bn, c + 22);
			i2gai_pp_05_04_03_m1(an, bn, c + 57);
		}
		if (bn = b[4]) {
			i2gai_pp_00_04_04_m1(an, bn, c + 0);
			i2gai_pp_02_04_04_m1(an, bn, c + 7);
			i2gai_pp_04_04_04_m1(an, bn, c + 42);
		}
		if (bn = b[5]) {
			i2gai_pp_01_04_05_m1(an, bn, c + 1);
			i2gai_pp_03_04_05_m1(an, bn, c + 22);
		}
		if (bn = b[6]) {
			i2gai_pp_02_04_06_m1(an, bn, c + 7);
		}
	}
	if (an = a[5]) {
		if (bn = b[0]) {
			i2gai_pp_05_05_00_m1(an, bn, c + 57);
		}
		if (bn = b[1]) {
			i2gai_pp_04_05_01_m1(an, bn, c + 42);
			i2gai_pp_06_05_01_m1(an, bn, c + 63);
		}
		if (bn = b[2]) {
			i2gai_pp_03_05_02_m1(an, bn, c + 22);
			i2gai_pp_05_05_02_m1(an, bn, c + 57);
		}
		if (bn = b[3]) {
			i2gai_pp_02_05_03_m1(an, bn, c + 7);
			i2gai_pp_04_05_03_m1(an, bn, c + 42);
		}
		if (bn = b[4]) {
			i2gai_pp_01_05_04_m1(an, bn, c + 1);
			i2gai_pp_03_05_04_m1(an, bn, c + 22);
		}
		if (bn = b[5]) {
			i2gai_pp_00_05_05_m1(an, bn, c + 0);
			i2gai_pp_02_05_05_m1(an, bn, c + 7);
		}
		if (bn = b[6]) {
			i2gai_pp_01_05_06_m1(an, bn, c + 1);
		}
	}
	if (an = a[6]) {
		if (bn = b[0]) {
			i2gai_pp_06_06_00_m1(an, bn, c + 63);
		}
		if (bn = b[1]) {
			i2gai_pp_05_06_01_m1(an, bn, c + 57);
		}
		if (bn = b[2]) {
			i2gai_pp_04_06_02_m1(an, bn, c + 42);
		}
		if (bn = b[3]) {
			i2gai_pp_03_06_03_m1(an, bn, c + 22);
		}
		if (bn = b[4]) {
			i2gai_pp_02_06_04_m1(an, bn, c + 7);
		}
		if (bn = b[5]) {
			i2gai_pp_01_06_05_m1(an, bn, c + 1);
		}
		if (bn = b[6]) {
			i2gai_pp_00_06_06_m1(an, bn, c + 0);
		}
	}
}

void i2gai_general_lcem(const double *a[], const double *b[], double *c) {
	const double *an, *bn;
	i2gai_null(c, 64);
	if (an = a[0]) {
		if (bn = b[0]) {
			i2gai_pp_00_00_00_m1(an, bn, c + 0);
		}
		if (bn = b[1]) {
			i2gai_pp_01_00_01_m1(an, bn, c + 1);
		}
		if (bn = b[2]) {
			i2gai_pp_02_00_02_m1(an, bn, c + 7);
		}
		if (bn = b[3]) {
			i2gai_pp_03_00_03_m1(an, bn, c + 22);
		}
		if (bn = b[4]) {
			i2gai_pp_04_00_04_m1(an, bn, c + 42);
		}
		if (bn = b[5]) {
			i2gai_pp_05_00_05_m1(an, bn, c + 57);
		}
		if (bn = b[6]) {
			i2gai_pp_06_00_06_m1(an, bn, c + 63);
		}
	}
	if (an = a[1]) {
		if (bn = b[1]) {
			i2gai_pp_00_01_01_m1(an, bn, c + 0);
		}
		if (bn = b[2]) {
			i2gai_pp_01_01_02_m1(an, bn, c + 1);
		}
		if (bn = b[3]) {
			i2gai_pp_02_01_03_m1(an, bn, c + 7);
		}
		if (bn = b[4]) {
			i2gai_pp_03_01_04_m1(an, bn, c + 22);
		}
		if (bn = b[5]) {
			i2gai_pp_04_01_05_m1(an, bn, c + 42);
		}
		if (bn = b[6]) {
			i2gai_pp_05_01_06_m1(an, bn, c + 57);
		}
	}
	if (an = a[2]) {
		if (bn = b[2]) {
			i2gai_pp_00_02_02_m1(an, bn, c + 0);
		}
		if (bn = b[3]) {
			i2gai_pp_01_02_03_m1(an, bn, c + 1);
		}
		if (bn = b[4]) {
			i2gai_pp_02_02_04_m1(an, bn, c + 7);
		}
		if (bn = b[5]) {
			i2gai_pp_03_02_05_m1(an, bn, c + 22);
		}
		if (bn = b[6]) {
			i2gai_pp_04_02_06_m1(an, bn, c + 42);
		}
	}
	if (an = a[3]) {
		if (bn = b[3]) {
			i2gai_pp_00_03_03_m1(an, bn, c + 0);
		}
		if (bn = b[4]) {
			i2gai_pp_01_03_04_m1(an, bn, c + 1);
		}
		if (bn = b[5]) {
			i2gai_pp_02_03_05_m1(an, bn, c + 7);
		}
		if (bn = b[6]) {
			i2gai_pp_03_03_06_m1(an, bn, c + 22);
		}
	}
	if (an = a[4]) {
		if (bn = b[4]) {
			i2gai_pp_00_04_04_m1(an, bn, c + 0);
		}
		if (bn = b[5]) {
			i2gai_pp_01_04_05_m1(an, bn, c + 1);
		}
		if (bn = b[6]) {
			i2gai_pp_02_04_06_m1(an, bn, c + 7);
		}
	}
	if (an = a[5]) {
		if (bn = b[5]) {
			i2gai_pp_00_05_05_m1(an, bn, c + 0);
		}
		if (bn = b[6]) {
			i2gai_pp_01_05_06_m1(an, bn, c + 1);
		}
	}
	if (an = a[6]) {
		if (bn = b[6]) {
			i2gai_pp_00_06_06_m1(an, bn, c + 0);
		}
	}
}

void i2gai_general_scpem(const double *a[], const double *b[], double *c) {
	const double *an, *bn;
	i2gai_null(c, 64);
	if (an = a[0]) {
		if (bn = b[0]) {
			i2gai_pp_00_00_00_m1(an, bn, c + 0);
		}
	}
	if (an = a[1]) {
		if (bn = b[1]) {
			i2gai_pp_00_01_01_m1(an, bn, c + 0);
		}
	}
	if (an = a[2]) {
		if (bn = b[2]) {
			i2gai_pp_00_02_02_m1(an, bn, c + 0);
		}
	}
	if (an = a[3]) {
		if (bn = b[3]) {
			i2gai_pp_00_03_03_m1(an, bn, c + 0);
		}
	}
	if (an = a[4]) {
		if (bn = b[4]) {
			i2gai_pp_00_04_04_m1(an, bn, c + 0);
		}
	}
	if (an = a[5]) {
		if (bn = b[5]) {
			i2gai_pp_00_05_05_m1(an, bn, c + 0);
		}
	}
	if (an = a[6]) {
		if (bn = b[6]) {
			i2gai_pp_00_06_06_m1(an, bn, c + 0);
		}
	}
}

void i2gai_opt_om_01x01(const double *a, const double *b, double *c) {
	c[0] = + a[0] * b[0] ;
}

void i2gai_opt_om_06x06(const double *a, const double *b, double *c) {
	c[0] = + a[0] * b[0] + a[1] * b[1] + a[2] * b[2] + a[3] * b[3] + a[4] * b[4] + a[5] * b[5] ;
	c[1] = + a[6] * b[0] + a[7] * b[1] + a[8] * b[2] + a[9] * b[3] + a[10] * b[4] + a[11] * b[5] ;
	c[2] = + a[12] * b[0] + a[13] * b[1] + a[14] * b[2] + a[15] * b[3] + a[16] * b[4] + a[17] * b[5] ;
	c[3] = + a[18] * b[0] + a[19] * b[1] + a[20] * b[2] + a[21] * b[3] + a[22] * b[4] + a[23] * b[5] ;
	c[4] = + a[24] * b[0] + a[25] * b[1] + a[26] * b[2] + a[27] * b[3] + a[28] * b[4] + a[29] * b[5] ;
	c[5] = + a[30] * b[0] + a[31] * b[1] + a[32] * b[2] + a[33] * b[3] + a[34] * b[4] + a[35] * b[5] ;
}

void i2gai_opt_om_0Fx0F(const double *a, const double *b, double *c) {
	c[0] = + a[0] * b[0] + a[1] * b[1] + a[2] * b[2] + a[3] * b[3] + a[4] * b[4] + a[5] * b[5] + a[6] * b[6] + a[7] * b[7] + a[8] * b[8] + a[9] * b[9] + a[10] * b[10] + a[11] * b[11] + a[12] * b[12] + a[13] * b[13] + a[14] * b[14] ;
	c[1] = + a[15] * b[0] + a[16] * b[1] + a[17] * b[2] + a[18] * b[3] + a[19] * b[4] + a[20] * b[5] + a[21] * b[6] + a[22] * b[7] + a[23] * b[8] + a[24] * b[9] + a[25] * b[10] + a[26] * b[11] + a[27] * b[12] + a[28] * b[13] + a[29] * b[14] ;
	c[2] = + a[30] * b[0] + a[31] * b[1] + a[32] * b[2] + a[33] * b[3] + a[34] * b[4] + a[35] * b[5] + a[36] * b[6] + a[37] * b[7] + a[38] * b[8] + a[39] * b[9] + a[40] * b[10] + a[41] * b[11] + a[42] * b[12] + a[43] * b[13] + a[44] * b[14] ;
	c[3] = + a[45] * b[0] + a[46] * b[1] + a[47] * b[2] + a[48] * b[3] + a[49] * b[4] + a[50] * b[5] + a[51] * b[6] + a[52] * b[7] + a[53] * b[8] + a[54] * b[9] + a[55] * b[10] + a[56] * b[11] + a[57] * b[12] + a[58] * b[13] + a[59] * b[14] ;
	c[4] = + a[60] * b[0] + a[61] * b[1] + a[62] * b[2] + a[63] * b[3] + a[64] * b[4] + a[65] * b[5] + a[66] * b[6] + a[67] * b[7] + a[68] * b[8] + a[69] * b[9] + a[70] * b[10] + a[71] * b[11] + a[72] * b[12] + a[73] * b[13] + a[74] * b[14] ;
	c[5] = + a[75] * b[0] + a[76] * b[1] + a[77] * b[2] + a[78] * b[3] + a[79] * b[4] + a[80] * b[5] + a[81] * b[6] + a[82] * b[7] + a[83] * b[8] + a[84] * b[9] + a[85] * b[10] + a[86] * b[11] + a[87] * b[12] + a[88] * b[13] + a[89] * b[14] ;
	c[6] = + a[90] * b[0] + a[91] * b[1] + a[92] * b[2] + a[93] * b[3] + a[94] * b[4] + a[95] * b[5] + a[96] * b[6] + a[97] * b[7] + a[98] * b[8] + a[99] * b[9] + a[100] * b[10] + a[101] * b[11] + a[102] * b[12] + a[103] * b[13] + a[104] * b[14] ;
	c[7] = + a[105] * b[0] + a[106] * b[1] + a[107] * b[2] + a[108] * b[3] + a[109] * b[4] + a[110] * b[5] + a[111] * b[6] + a[112] * b[7] + a[113] * b[8] + a[114] * b[9] + a[115] * b[10] + a[116] * b[11] + a[117] * b[12] + a[118] * b[13] + a[119] * b[14] ;
	c[8] = + a[120] * b[0] + a[121] * b[1] + a[122] * b[2] + a[123] * b[3] + a[124] * b[4] + a[125] * b[5] + a[126] * b[6] + a[127] * b[7] + a[128] * b[8] + a[129] * b[9] + a[130] * b[10] + a[131] * b[11] + a[132] * b[12] + a[133] * b[13] + a[134] * b[14] ;
	c[9] = + a[135] * b[0] + a[136] * b[1] + a[137] * b[2] + a[138] * b[3] + a[139] * b[4] + a[140] * b[5] + a[141] * b[6] + a[142] * b[7] + a[143] * b[8] + a[144] * b[9] + a[145] * b[10] + a[146] * b[11] + a[147] * b[12] + a[148] * b[13] + a[149] * b[14] ;
	c[10] = + a[150] * b[0] + a[151] * b[1] + a[152] * b[2] + a[153] * b[3] + a[154] * b[4] + a[155] * b[5] + a[156] * b[6] + a[157] * b[7] + a[158] * b[8] + a[159] * b[9] + a[160] * b[10] + a[161] * b[11] + a[162] * b[12] + a[163] * b[13] + a[164] * b[14] ;
	c[11] = + a[165] * b[0] + a[166] * b[1] + a[167] * b[2] + a[168] * b[3] + a[169] * b[4] + a[170] * b[5] + a[171] * b[6] + a[172] * b[7] + a[173] * b[8] + a[174] * b[9] + a[175] * b[10] + a[176] * b[11] + a[177] * b[12] + a[178] * b[13] + a[179] * b[14] ;
	c[12] = + a[180] * b[0] + a[181] * b[1] + a[182] * b[2] + a[183] * b[3] + a[184] * b[4] + a[185] * b[5] + a[186] * b[6] + a[187] * b[7] + a[188] * b[8] + a[189] * b[9] + a[190] * b[10] + a[191] * b[11] + a[192] * b[12] + a[193] * b[13] + a[194] * b[14] ;
	c[13] = + a[195] * b[0] + a[196] * b[1] + a[197] * b[2] + a[198] * b[3] + a[199] * b[4] + a[200] * b[5] + a[201] * b[6] + a[202] * b[7] + a[203] * b[8] + a[204] * b[9] + a[205] * b[10] + a[206] * b[11] + a[207] * b[12] + a[208] * b[13] + a[209] * b[14] ;
	c[14] = + a[210] * b[0] + a[211] * b[1] + a[212] * b[2] + a[213] * b[3] + a[214] * b[4] + a[215] * b[5] + a[216] * b[6] + a[217] * b[7] + a[218] * b[8] + a[219] * b[9] + a[220] * b[10] + a[221] * b[11] + a[222] * b[12] + a[223] * b[13] + a[224] * b[14] ;
}

void i2gai_opt_om_14x14(const double *a, const double *b, double *c) {
	c[0] = + a[0] * b[0] + a[1] * b[1] + a[2] * b[2] + a[3] * b[3] + a[4] * b[4] + a[5] * b[5] + a[6] * b[6] + a[7] * b[7] + a[8] * b[8] + a[9] * b[9] + a[10] * b[10] + a[11] * b[11] + a[12] * b[12] + a[13] * b[13] + a[14] * b[14] + a[15] * b[15] + a[16] * b[16] + a[17] * b[17] + a[18] * b[18] + a[19] * b[19] ;
	c[1] = + a[20] * b[0] + a[21] * b[1] + a[22] * b[2] + a[23] * b[3] + a[24] * b[4] + a[25] * b[5] + a[26] * b[6] + a[27] * b[7] + a[28] * b[8] + a[29] * b[9] + a[30] * b[10] + a[31] * b[11] + a[32] * b[12] + a[33] * b[13] + a[34] * b[14] + a[35] * b[15] + a[36] * b[16] + a[37] * b[17] + a[38] * b[18] + a[39] * b[19] ;
	c[2] = + a[40] * b[0] + a[41] * b[1] + a[42] * b[2] + a[43] * b[3] + a[44] * b[4] + a[45] * b[5] + a[46] * b[6] + a[47] * b[7] + a[48] * b[8] + a[49] * b[9] + a[50] * b[10] + a[51] * b[11] + a[52] * b[12] + a[53] * b[13] + a[54] * b[14] + a[55] * b[15] + a[56] * b[16] + a[57] * b[17] + a[58] * b[18] + a[59] * b[19] ;
	c[3] = + a[60] * b[0] + a[61] * b[1] + a[62] * b[2] + a[63] * b[3] + a[64] * b[4] + a[65] * b[5] + a[66] * b[6] + a[67] * b[7] + a[68] * b[8] + a[69] * b[9] + a[70] * b[10] + a[71] * b[11] + a[72] * b[12] + a[73] * b[13] + a[74] * b[14] + a[75] * b[15] + a[76] * b[16] + a[77] * b[17] + a[78] * b[18] + a[79] * b[19] ;
	c[4] = + a[80] * b[0] + a[81] * b[1] + a[82] * b[2] + a[83] * b[3] + a[84] * b[4] + a[85] * b[5] + a[86] * b[6] + a[87] * b[7] + a[88] * b[8] + a[89] * b[9] + a[90] * b[10] + a[91] * b[11] + a[92] * b[12] + a[93] * b[13] + a[94] * b[14] + a[95] * b[15] + a[96] * b[16] + a[97] * b[17] + a[98] * b[18] + a[99] * b[19] ;
	c[5] = + a[100] * b[0] + a[101] * b[1] + a[102] * b[2] + a[103] * b[3] + a[104] * b[4] + a[105] * b[5] + a[106] * b[6] + a[107] * b[7] + a[108] * b[8] + a[109] * b[9] + a[110] * b[10] + a[111] * b[11] + a[112] * b[12] + a[113] * b[13] + a[114] * b[14] + a[115] * b[15] + a[116] * b[16] + a[117] * b[17] + a[118] * b[18] + a[119] * b[19] ;
	c[6] = + a[120] * b[0] + a[121] * b[1] + a[122] * b[2] + a[123] * b[3] + a[124] * b[4] + a[125] * b[5] + a[126] * b[6] + a[127] * b[7] + a[128] * b[8] + a[129] * b[9] + a[130] * b[10] + a[131] * b[11] + a[132] * b[12] + a[133] * b[13] + a[134] * b[14] + a[135] * b[15] + a[136] * b[16] + a[137] * b[17] + a[138] * b[18] + a[139] * b[19] ;
	c[7] = + a[140] * b[0] + a[141] * b[1] + a[142] * b[2] + a[143] * b[3] + a[144] * b[4] + a[145] * b[5] + a[146] * b[6] + a[147] * b[7] + a[148] * b[8] + a[149] * b[9] + a[150] * b[10] + a[151] * b[11] + a[152] * b[12] + a[153] * b[13] + a[154] * b[14] + a[155] * b[15] + a[156] * b[16] + a[157] * b[17] + a[158] * b[18] + a[159] * b[19] ;
	c[8] = + a[160] * b[0] + a[161] * b[1] + a[162] * b[2] + a[163] * b[3] + a[164] * b[4] + a[165] * b[5] + a[166] * b[6] + a[167] * b[7] + a[168] * b[8] + a[169] * b[9] + a[170] * b[10] + a[171] * b[11] + a[172] * b[12] + a[173] * b[13] + a[174] * b[14] + a[175] * b[15] + a[176] * b[16] + a[177] * b[17] + a[178] * b[18] + a[179] * b[19] ;
	c[9] = + a[180] * b[0] + a[181] * b[1] + a[182] * b[2] + a[183] * b[3] + a[184] * b[4] + a[185] * b[5] + a[186] * b[6] + a[187] * b[7] + a[188] * b[8] + a[189] * b[9] + a[190] * b[10] + a[191] * b[11] + a[192] * b[12] + a[193] * b[13] + a[194] * b[14] + a[195] * b[15] + a[196] * b[16] + a[197] * b[17] + a[198] * b[18] + a[199] * b[19] ;
	c[10] = + a[200] * b[0] + a[201] * b[1] + a[202] * b[2] + a[203] * b[3] + a[204] * b[4] + a[205] * b[5] + a[206] * b[6] + a[207] * b[7] + a[208] * b[8] + a[209] * b[9] + a[210] * b[10] + a[211] * b[11] + a[212] * b[12] + a[213] * b[13] + a[214] * b[14] + a[215] * b[15] + a[216] * b[16] + a[217] * b[17] + a[218] * b[18] + a[219] * b[19] ;
	c[11] = + a[220] * b[0] + a[221] * b[1] + a[222] * b[2] + a[223] * b[3] + a[224] * b[4] + a[225] * b[5] + a[226] * b[6] + a[227] * b[7] + a[228] * b[8] + a[229] * b[9] + a[230] * b[10] + a[231] * b[11] + a[232] * b[12] + a[233] * b[13] + a[234] * b[14] + a[235] * b[15] + a[236] * b[16] + a[237] * b[17] + a[238] * b[18] + a[239] * b[19] ;
	c[12] = + a[240] * b[0] + a[241] * b[1] + a[242] * b[2] + a[243] * b[3] + a[244] * b[4] + a[245] * b[5] + a[246] * b[6] + a[247] * b[7] + a[248] * b[8] + a[249] * b[9] + a[250] * b[10] + a[251] * b[11] + a[252] * b[12] + a[253] * b[13] + a[254] * b[14] + a[255] * b[15] + a[256] * b[16] + a[257] * b[17] + a[258] * b[18] + a[259] * b[19] ;
	c[13] = + a[260] * b[0] + a[261] * b[1] + a[262] * b[2] + a[263] * b[3] + a[264] * b[4] + a[265] * b[5] + a[266] * b[6] + a[267] * b[7] + a[268] * b[8] + a[269] * b[9] + a[270] * b[10] + a[271] * b[11] + a[272] * b[12] + a[273] * b[13] + a[274] * b[14] + a[275] * b[15] + a[276] * b[16] + a[277] * b[17] + a[278] * b[18] + a[279] * b[19] ;
	c[14] = + a[280] * b[0] + a[281] * b[1] + a[282] * b[2] + a[283] * b[3] + a[284] * b[4] + a[285] * b[5] + a[286] * b[6] + a[287] * b[7] + a[288] * b[8] + a[289] * b[9] + a[290] * b[10] + a[291] * b[11] + a[292] * b[12] + a[293] * b[13] + a[294] * b[14] + a[295] * b[15] + a[296] * b[16] + a[297] * b[17] + a[298] * b[18] + a[299] * b[19] ;
	c[15] = + a[300] * b[0] + a[301] * b[1] + a[302] * b[2] + a[303] * b[3] + a[304] * b[4] + a[305] * b[5] + a[306] * b[6] + a[307] * b[7] + a[308] * b[8] + a[309] * b[9] + a[310] * b[10] + a[311] * b[11] + a[312] * b[12] + a[313] * b[13] + a[314] * b[14] + a[315] * b[15] + a[316] * b[16] + a[317] * b[17] + a[318] * b[18] + a[319] * b[19] ;
	c[16] = + a[320] * b[0] + a[321] * b[1] + a[322] * b[2] + a[323] * b[3] + a[324] * b[4] + a[325] * b[5] + a[326] * b[6] + a[327] * b[7] + a[328] * b[8] + a[329] * b[9] + a[330] * b[10] + a[331] * b[11] + a[332] * b[12] + a[333] * b[13] + a[334] * b[14] + a[335] * b[15] + a[336] * b[16] + a[337] * b[17] + a[338] * b[18] + a[339] * b[19] ;
	c[17] = + a[340] * b[0] + a[341] * b[1] + a[342] * b[2] + a[343] * b[3] + a[344] * b[4] + a[345] * b[5] + a[346] * b[6] + a[347] * b[7] + a[348] * b[8] + a[349] * b[9] + a[350] * b[10] + a[351] * b[11] + a[352] * b[12] + a[353] * b[13] + a[354] * b[14] + a[355] * b[15] + a[356] * b[16] + a[357] * b[17] + a[358] * b[18] + a[359] * b[19] ;
	c[18] = + a[360] * b[0] + a[361] * b[1] + a[362] * b[2] + a[363] * b[3] + a[364] * b[4] + a[365] * b[5] + a[366] * b[6] + a[367] * b[7] + a[368] * b[8] + a[369] * b[9] + a[370] * b[10] + a[371] * b[11] + a[372] * b[12] + a[373] * b[13] + a[374] * b[14] + a[375] * b[15] + a[376] * b[16] + a[377] * b[17] + a[378] * b[18] + a[379] * b[19] ;
	c[19] = + a[380] * b[0] + a[381] * b[1] + a[382] * b[2] + a[383] * b[3] + a[384] * b[4] + a[385] * b[5] + a[386] * b[6] + a[387] * b[7] + a[388] * b[8] + a[389] * b[9] + a[390] * b[10] + a[391] * b[11] + a[392] * b[12] + a[393] * b[13] + a[394] * b[14] + a[395] * b[15] + a[396] * b[16] + a[397] * b[17] + a[398] * b[18] + a[399] * b[19] ;
}

void i2gai_copy(double *dest, const double *src, int length) {
	memcpy(dest, src, length * sizeof(double));
}

void i2gai_reverse(double *a[]) {
	double *an;
	if (an = a[2]) {
		an[0] = -an[0];
		an[1] = -an[1];
		an[2] = -an[2];
		an[3] = -an[3];
		an[4] = -an[4];
		an[5] = -an[5];
		an[6] = -an[6];
		an[7] = -an[7];
		an[8] = -an[8];
		an[9] = -an[9];
		an[10] = -an[10];
		an[11] = -an[11];
		an[12] = -an[12];
		an[13] = -an[13];
		an[14] = -an[14];
	}
	if (an = a[3]) {
		an[0] = -an[0];
		an[1] = -an[1];
		an[2] = -an[2];
		an[3] = -an[3];
		an[4] = -an[4];
		an[5] = -an[5];
		an[6] = -an[6];
		an[7] = -an[7];
		an[8] = -an[8];
		an[9] = -an[9];
		an[10] = -an[10];
		an[11] = -an[11];
		an[12] = -an[12];
		an[13] = -an[13];
		an[14] = -an[14];
		an[15] = -an[15];
		an[16] = -an[16];
		an[17] = -an[17];
		an[18] = -an[18];
		an[19] = -an[19];
	}
	if (an = a[6]) {
		an[0] = -an[0];
	}
}

void i2gai_cliffordConjugate(double *a[]) {
	double *an;
	if (an = a[1]) {
		an[0] = -an[0];
		an[1] = -an[1];
		an[2] = -an[2];
		an[3] = -an[3];
		an[4] = -an[4];
		an[5] = -an[5];
	}
	if (an = a[2]) {
		an[0] = -an[0];
		an[1] = -an[1];
		an[2] = -an[2];
		an[3] = -an[3];
		an[4] = -an[4];
		an[5] = -an[5];
		an[6] = -an[6];
		an[7] = -an[7];
		an[8] = -an[8];
		an[9] = -an[9];
		an[10] = -an[10];
		an[11] = -an[11];
		an[12] = -an[12];
		an[13] = -an[13];
		an[14] = -an[14];
	}
	if (an = a[5]) {
		an[0] = -an[0];
		an[1] = -an[1];
		an[2] = -an[2];
		an[3] = -an[3];
		an[4] = -an[4];
		an[5] = -an[5];
	}
	if (an = a[6]) {
		an[0] = -an[0];
	}
}

void i2gai_involution(double *a[]) {
	double *an;
	if (an = a[1]) {
		an[0] = -an[0];
		an[1] = -an[1];
		an[2] = -an[2];
		an[3] = -an[3];
		an[4] = -an[4];
		an[5] = -an[5];
	}
	if (an = a[3]) {
		an[0] = -an[0];
		an[1] = -an[1];
		an[2] = -an[2];
		an[3] = -an[3];
		an[4] = -an[4];
		an[5] = -an[5];
		an[6] = -an[6];
		an[7] = -an[7];
		an[8] = -an[8];
		an[9] = -an[9];
		an[10] = -an[10];
		an[11] = -an[11];
		an[12] = -an[12];
		an[13] = -an[13];
		an[14] = -an[14];
		an[15] = -an[15];
		an[16] = -an[16];
		an[17] = -an[17];
		an[18] = -an[18];
		an[19] = -an[19];
	}
	if (an = a[5]) {
		an[0] = -an[0];
		an[1] = -an[1];
		an[2] = -an[2];
		an[3] = -an[3];
		an[4] = -an[4];
		an[5] = -an[5];
	}
}

void i2gai_negate(double *dest, const double *src, int length) {
	int i;
	for (i = 0; i < length; i++)
		dest[i] = -src[i];
}

double i2gai_norm_a(const double a[], int nb) {
	int i;
	double norm = 0.0;
	for (i = 0; i < nb; i++)
		norm += a[i] * a[i];
	return norm;
}

void i2gai_addSameGradeUsage(double *c, const double *a, const double *b, int length) {
	int i;
	for (i = 0; i < length; i++)
		c[i] = a[i] + b[i];
}

void i2gai_add(const double *a[7], const double *b[7], double *c[7]) {
	double const *an, *bn;
	double *cn;

	if (cn = c[0]) {
		bn = b[0];
		if ((an = a[0]) && bn) {
			cn[0] = an[0] + bn[0];
		}
		else if (an) {
			cn[0] = an[0];
		}
		else {
			cn[0] = bn[0];
		}
	}
	if (cn = c[1]) {
		bn = b[1];
		if ((an = a[1]) && bn) {
			cn[0] = an[0] + bn[0];
			cn[1] = an[1] + bn[1];
			cn[2] = an[2] + bn[2];
			cn[3] = an[3] + bn[3];
			cn[4] = an[4] + bn[4];
			cn[5] = an[5] + bn[5];
		}
		else if (an) {
			cn[0] = an[0];
			cn[1] = an[1];
			cn[2] = an[2];
			cn[3] = an[3];
			cn[4] = an[4];
			cn[5] = an[5];
		}
		else {
			cn[0] = bn[0];
			cn[1] = bn[1];
			cn[2] = bn[2];
			cn[3] = bn[3];
			cn[4] = bn[4];
			cn[5] = bn[5];
		}
	}
	if (cn = c[2]) {
		bn = b[2];
		if ((an = a[2]) && bn) {
			cn[0] = an[0] + bn[0];
			cn[1] = an[1] + bn[1];
			cn[2] = an[2] + bn[2];
			cn[3] = an[3] + bn[3];
			cn[4] = an[4] + bn[4];
			cn[5] = an[5] + bn[5];
			cn[6] = an[6] + bn[6];
			cn[7] = an[7] + bn[7];
			cn[8] = an[8] + bn[8];
			cn[9] = an[9] + bn[9];
			cn[10] = an[10] + bn[10];
			cn[11] = an[11] + bn[11];
			cn[12] = an[12] + bn[12];
			cn[13] = an[13] + bn[13];
			cn[14] = an[14] + bn[14];
		}
		else if (an) {
			cn[0] = an[0];
			cn[1] = an[1];
			cn[2] = an[2];
			cn[3] = an[3];
			cn[4] = an[4];
			cn[5] = an[5];
			cn[6] = an[6];
			cn[7] = an[7];
			cn[8] = an[8];
			cn[9] = an[9];
			cn[10] = an[10];
			cn[11] = an[11];
			cn[12] = an[12];
			cn[13] = an[13];
			cn[14] = an[14];
		}
		else {
			cn[0] = bn[0];
			cn[1] = bn[1];
			cn[2] = bn[2];
			cn[3] = bn[3];
			cn[4] = bn[4];
			cn[5] = bn[5];
			cn[6] = bn[6];
			cn[7] = bn[7];
			cn[8] = bn[8];
			cn[9] = bn[9];
			cn[10] = bn[10];
			cn[11] = bn[11];
			cn[12] = bn[12];
			cn[13] = bn[13];
			cn[14] = bn[14];
		}
	}
	if (cn = c[3]) {
		bn = b[3];
		if ((an = a[3]) && bn) {
			cn[0] = an[0] + bn[0];
			cn[1] = an[1] + bn[1];
			cn[2] = an[2] + bn[2];
			cn[3] = an[3] + bn[3];
			cn[4] = an[4] + bn[4];
			cn[5] = an[5] + bn[5];
			cn[6] = an[6] + bn[6];
			cn[7] = an[7] + bn[7];
			cn[8] = an[8] + bn[8];
			cn[9] = an[9] + bn[9];
			cn[10] = an[10] + bn[10];
			cn[11] = an[11] + bn[11];
			cn[12] = an[12] + bn[12];
			cn[13] = an[13] + bn[13];
			cn[14] = an[14] + bn[14];
			cn[15] = an[15] + bn[15];
			cn[16] = an[16] + bn[16];
			cn[17] = an[17] + bn[17];
			cn[18] = an[18] + bn[18];
			cn[19] = an[19] + bn[19];
		}
		else if (an) {
			cn[0] = an[0];
			cn[1] = an[1];
			cn[2] = an[2];
			cn[3] = an[3];
			cn[4] = an[4];
			cn[5] = an[5];
			cn[6] = an[6];
			cn[7] = an[7];
			cn[8] = an[8];
			cn[9] = an[9];
			cn[10] = an[10];
			cn[11] = an[11];
			cn[12] = an[12];
			cn[13] = an[13];
			cn[14] = an[14];
			cn[15] = an[15];
			cn[16] = an[16];
			cn[17] = an[17];
			cn[18] = an[18];
			cn[19] = an[19];
		}
		else {
			cn[0] = bn[0];
			cn[1] = bn[1];
			cn[2] = bn[2];
			cn[3] = bn[3];
			cn[4] = bn[4];
			cn[5] = bn[5];
			cn[6] = bn[6];
			cn[7] = bn[7];
			cn[8] = bn[8];
			cn[9] = bn[9];
			cn[10] = bn[10];
			cn[11] = bn[11];
			cn[12] = bn[12];
			cn[13] = bn[13];
			cn[14] = bn[14];
			cn[15] = bn[15];
			cn[16] = bn[16];
			cn[17] = bn[17];
			cn[18] = bn[18];
			cn[19] = bn[19];
		}
	}
	if (cn = c[4]) {
		bn = b[4];
		if ((an = a[4]) && bn) {
			cn[0] = an[0] + bn[0];
			cn[1] = an[1] + bn[1];
			cn[2] = an[2] + bn[2];
			cn[3] = an[3] + bn[3];
			cn[4] = an[4] + bn[4];
			cn[5] = an[5] + bn[5];
			cn[6] = an[6] + bn[6];
			cn[7] = an[7] + bn[7];
			cn[8] = an[8] + bn[8];
			cn[9] = an[9] + bn[9];
			cn[10] = an[10] + bn[10];
			cn[11] = an[11] + bn[11];
			cn[12] = an[12] + bn[12];
			cn[13] = an[13] + bn[13];
			cn[14] = an[14] + bn[14];
		}
		else if (an) {
			cn[0] = an[0];
			cn[1] = an[1];
			cn[2] = an[2];
			cn[3] = an[3];
			cn[4] = an[4];
			cn[5] = an[5];
			cn[6] = an[6];
			cn[7] = an[7];
			cn[8] = an[8];
			cn[9] = an[9];
			cn[10] = an[10];
			cn[11] = an[11];
			cn[12] = an[12];
			cn[13] = an[13];
			cn[14] = an[14];
		}
		else {
			cn[0] = bn[0];
			cn[1] = bn[1];
			cn[2] = bn[2];
			cn[3] = bn[3];
			cn[4] = bn[4];
			cn[5] = bn[5];
			cn[6] = bn[6];
			cn[7] = bn[7];
			cn[8] = bn[8];
			cn[9] = bn[9];
			cn[10] = bn[10];
			cn[11] = bn[11];
			cn[12] = bn[12];
			cn[13] = bn[13];
			cn[14] = bn[14];
		}
	}
	if (cn = c[5]) {
		bn = b[5];
		if ((an = a[5]) && bn) {
			cn[0] = an[0] + bn[0];
			cn[1] = an[1] + bn[1];
			cn[2] = an[2] + bn[2];
			cn[3] = an[3] + bn[3];
			cn[4] = an[4] + bn[4];
			cn[5] = an[5] + bn[5];
		}
		else if (an) {
			cn[0] = an[0];
			cn[1] = an[1];
			cn[2] = an[2];
			cn[3] = an[3];
			cn[4] = an[4];
			cn[5] = an[5];
		}
		else {
			cn[0] = bn[0];
			cn[1] = bn[1];
			cn[2] = bn[2];
			cn[3] = bn[3];
			cn[4] = bn[4];
			cn[5] = bn[5];
		}
	}
	if (cn = c[6]) {
		bn = b[6];
		if ((an = a[6]) && bn) {
			cn[0] = an[0] + bn[0];
		}
		else if (an) {
			cn[0] = an[0];
		}
		else {
			cn[0] = bn[0];
		}
	}
}

void i2gai_subSameGradeUsage(double *c, const double *a, const double *b, int length) {
	int i;
	for (i = 0; i < length; i++)
		c[i] = a[i] - b[i];
}

void i2gai_sub(const double *a[7], const double *b[7], double *c[7]) {
	double const *an, *bn;
	double *cn;

	if (cn = c[0]) {
		bn = b[0];
		if ((an = a[0]) && bn) {
			cn[0] = an[0] - bn[0];
		}
		else if (an) {
			cn[0] = an[0];
		}
		else {
			cn[0] = -bn[0];
		}
	}
	if (cn = c[1]) {
		bn = b[1];
		if ((an = a[1]) && bn) {
			cn[0] = an[0] - bn[0];
			cn[1] = an[1] - bn[1];
			cn[2] = an[2] - bn[2];
			cn[3] = an[3] - bn[3];
			cn[4] = an[4] - bn[4];
			cn[5] = an[5] - bn[5];
		}
		else if (an) {
			cn[0] = an[0];
			cn[1] = an[1];
			cn[2] = an[2];
			cn[3] = an[3];
			cn[4] = an[4];
			cn[5] = an[5];
		}
		else {
			cn[0] = -bn[0];
			cn[1] = -bn[1];
			cn[2] = -bn[2];
			cn[3] = -bn[3];
			cn[4] = -bn[4];
			cn[5] = -bn[5];
		}
	}
	if (cn = c[2]) {
		bn = b[2];
		if ((an = a[2]) && bn) {
			cn[0] = an[0] - bn[0];
			cn[1] = an[1] - bn[1];
			cn[2] = an[2] - bn[2];
			cn[3] = an[3] - bn[3];
			cn[4] = an[4] - bn[4];
			cn[5] = an[5] - bn[5];
			cn[6] = an[6] - bn[6];
			cn[7] = an[7] - bn[7];
			cn[8] = an[8] - bn[8];
			cn[9] = an[9] - bn[9];
			cn[10] = an[10] - bn[10];
			cn[11] = an[11] - bn[11];
			cn[12] = an[12] - bn[12];
			cn[13] = an[13] - bn[13];
			cn[14] = an[14] - bn[14];
		}
		else if (an) {
			cn[0] = an[0];
			cn[1] = an[1];
			cn[2] = an[2];
			cn[3] = an[3];
			cn[4] = an[4];
			cn[5] = an[5];
			cn[6] = an[6];
			cn[7] = an[7];
			cn[8] = an[8];
			cn[9] = an[9];
			cn[10] = an[10];
			cn[11] = an[11];
			cn[12] = an[12];
			cn[13] = an[13];
			cn[14] = an[14];
		}
		else {
			cn[0] = -bn[0];
			cn[1] = -bn[1];
			cn[2] = -bn[2];
			cn[3] = -bn[3];
			cn[4] = -bn[4];
			cn[5] = -bn[5];
			cn[6] = -bn[6];
			cn[7] = -bn[7];
			cn[8] = -bn[8];
			cn[9] = -bn[9];
			cn[10] = -bn[10];
			cn[11] = -bn[11];
			cn[12] = -bn[12];
			cn[13] = -bn[13];
			cn[14] = -bn[14];
		}
	}
	if (cn = c[3]) {
		bn = b[3];
		if ((an = a[3]) && bn) {
			cn[0] = an[0] - bn[0];
			cn[1] = an[1] - bn[1];
			cn[2] = an[2] - bn[2];
			cn[3] = an[3] - bn[3];
			cn[4] = an[4] - bn[4];
			cn[5] = an[5] - bn[5];
			cn[6] = an[6] - bn[6];
			cn[7] = an[7] - bn[7];
			cn[8] = an[8] - bn[8];
			cn[9] = an[9] - bn[9];
			cn[10] = an[10] - bn[10];
			cn[11] = an[11] - bn[11];
			cn[12] = an[12] - bn[12];
			cn[13] = an[13] - bn[13];
			cn[14] = an[14] - bn[14];
			cn[15] = an[15] - bn[15];
			cn[16] = an[16] - bn[16];
			cn[17] = an[17] - bn[17];
			cn[18] = an[18] - bn[18];
			cn[19] = an[19] - bn[19];
		}
		else if (an) {
			cn[0] = an[0];
			cn[1] = an[1];
			cn[2] = an[2];
			cn[3] = an[3];
			cn[4] = an[4];
			cn[5] = an[5];
			cn[6] = an[6];
			cn[7] = an[7];
			cn[8] = an[8];
			cn[9] = an[9];
			cn[10] = an[10];
			cn[11] = an[11];
			cn[12] = an[12];
			cn[13] = an[13];
			cn[14] = an[14];
			cn[15] = an[15];
			cn[16] = an[16];
			cn[17] = an[17];
			cn[18] = an[18];
			cn[19] = an[19];
		}
		else {
			cn[0] = -bn[0];
			cn[1] = -bn[1];
			cn[2] = -bn[2];
			cn[3] = -bn[3];
			cn[4] = -bn[4];
			cn[5] = -bn[5];
			cn[6] = -bn[6];
			cn[7] = -bn[7];
			cn[8] = -bn[8];
			cn[9] = -bn[9];
			cn[10] = -bn[10];
			cn[11] = -bn[11];
			cn[12] = -bn[12];
			cn[13] = -bn[13];
			cn[14] = -bn[14];
			cn[15] = -bn[15];
			cn[16] = -bn[16];
			cn[17] = -bn[17];
			cn[18] = -bn[18];
			cn[19] = -bn[19];
		}
	}
	if (cn = c[4]) {
		bn = b[4];
		if ((an = a[4]) && bn) {
			cn[0] = an[0] - bn[0];
			cn[1] = an[1] - bn[1];
			cn[2] = an[2] - bn[2];
			cn[3] = an[3] - bn[3];
			cn[4] = an[4] - bn[4];
			cn[5] = an[5] - bn[5];
			cn[6] = an[6] - bn[6];
			cn[7] = an[7] - bn[7];
			cn[8] = an[8] - bn[8];
			cn[9] = an[9] - bn[9];
			cn[10] = an[10] - bn[10];
			cn[11] = an[11] - bn[11];
			cn[12] = an[12] - bn[12];
			cn[13] = an[13] - bn[13];
			cn[14] = an[14] - bn[14];
		}
		else if (an) {
			cn[0] = an[0];
			cn[1] = an[1];
			cn[2] = an[2];
			cn[3] = an[3];
			cn[4] = an[4];
			cn[5] = an[5];
			cn[6] = an[6];
			cn[7] = an[7];
			cn[8] = an[8];
			cn[9] = an[9];
			cn[10] = an[10];
			cn[11] = an[11];
			cn[12] = an[12];
			cn[13] = an[13];
			cn[14] = an[14];
		}
		else {
			cn[0] = -bn[0];
			cn[1] = -bn[1];
			cn[2] = -bn[2];
			cn[3] = -bn[3];
			cn[4] = -bn[4];
			cn[5] = -bn[5];
			cn[6] = -bn[6];
			cn[7] = -bn[7];
			cn[8] = -bn[8];
			cn[9] = -bn[9];
			cn[10] = -bn[10];
			cn[11] = -bn[11];
			cn[12] = -bn[12];
			cn[13] = -bn[13];
			cn[14] = -bn[14];
		}
	}
	if (cn = c[5]) {
		bn = b[5];
		if ((an = a[5]) && bn) {
			cn[0] = an[0] - bn[0];
			cn[1] = an[1] - bn[1];
			cn[2] = an[2] - bn[2];
			cn[3] = an[3] - bn[3];
			cn[4] = an[4] - bn[4];
			cn[5] = an[5] - bn[5];
		}
		else if (an) {
			cn[0] = an[0];
			cn[1] = an[1];
			cn[2] = an[2];
			cn[3] = an[3];
			cn[4] = an[4];
			cn[5] = an[5];
		}
		else {
			cn[0] = -bn[0];
			cn[1] = -bn[1];
			cn[2] = -bn[2];
			cn[3] = -bn[3];
			cn[4] = -bn[4];
			cn[5] = -bn[5];
		}
	}
	if (cn = c[6]) {
		bn = b[6];
		if ((an = a[6]) && bn) {
			cn[0] = an[0] - bn[0];
		}
		else if (an) {
			cn[0] = an[0];
		}
		else {
			cn[0] = -bn[0];
		}
	}
}
#ifdef __cplusplus
}
#endif /* __cplusplus */
